Attribute VB_Name = "Code"
'   Program:  CnvIbfs -- Convert IB's File System Data Base

'    Author:  Donald Draper Campbell
'             Electronic Engineer
'             Federal Communications Commission
'             Office of Engineering and Technology
'             Technical Analysis Branch
'             445 12th Street, SW, suite 7-A263
'             Washington, DC  20554    USA
'             e-mail:  donald.campbell@fcc.gov
'             Tele: +1 (202) 418-2405, 7:30a -> 4:00p, eastern time
'             e-mail: cmpblldd@ix.netcom.com


'  This program is used to convert the Sybase dump tables which
'  IB's File System (IBFS) database into OET's Master Frequency File (MFF)
'  database which is in MS ACCESS format.

'SourceCode:  www.fcc.gov/oet/info/software

'  Language:  Microsoft VisualBASIC (Professional) version 6.0 -- 32-bit

Option Explicit

Public Const gtVersionDate = "2013.02.25 (O)"

Sub Main()    '  in CnvIbfs

    'gtMsg1 = "Because this program create large data files which become fragmented, please run both 'Disk Cleanup' and 'Disk Defragmenter' on each hard use by this program before continuing."
    'MsgBox gtMsg1, , "Main - CnvIbfs"
    'DoEvents

    'On Error GoTo MainErr

    If (Trim(Dir(gtInputDataTableMain)) <> "main.dat") Then
        gtMsg = "The file 'main.dat' was not found!" & vbCrLf & vbCrLf & _
                "You need to redefine the path to this file." & vbCrLf & vbCrLf & _
                "Select  " & Chr(34) & "Setup | Modify File Location" & Chr(34) & "  on the menu bar."
        MsgBox gtMsg
        DoEvents
        GoTo ReStartMain
    End If

    Load frmStatus
    frmStatus.Show

    frmStatus.lblDateTimeStart = Now

    Set wsJet = DBEngine.Workspaces(0)

    If (Dir(gtInputFilePath & "baddata.txt") <> "") Then
        Kill gtInputFilePath & "baddata.txt"
    End If
    giBadDataFF = FreeFile
    Open (gtInputFilePath & "baddata.txt") For Output As #giBadDataFF
    'Open (gtInputFilePath & "baddata.txt") For Append As #giBadDataFF

    Erase gtPOCode, gtPOString

    giPocFF = FreeFile
    Open (gtPath2App & "pocodes.dat") For Input As giPocFF

    giPocCnt = 0
    Do While Not EOF(giPocFF)
        giPocCnt = giPocCnt + 1
        Line Input #giPocFF, gtInputData
        gtPOCode(giPocCnt) = Trim(Mid(gtInputData, 1, 4))
        gtPOString(giPocCnt) = Trim(Mid(gtInputData, 10))
    Loop
    Close (giPocFF)

    giActionCounter = 0
    frmStatus.lblStepTotal.Caption = "42"

    If (frmCnvIbfs.mnuSetupExpFreqYN(0).Checked = True) Then
        giFreqRangeFlag = 1
    Else
        giFreqRangeFlag = 0
    End If
    
    'GoTo Point1
    'GoTo TableMain

    'GoTo SiteTable

    Call PopulateDataSource

    giActionCounter = giActionCounter + 1
    Call PopulateAddressTable

    giActionCounter = giActionCounter + 1
    Call PopulateAntennaConditionTable

    giActionCounter = giActionCounter + 1
    Call PopulateAntennaFxTable

    giActionCounter = giActionCounter + 1
    Call PopulateAntennaGainTable

    giActionCounter = giActionCounter + 1
    Call PopulateAntennaTypeCodeTable

    giActionCounter = giActionCounter + 1
    Call PopulateAntennaTable

    giActionCounter = giActionCounter + 1
    Call PopulateAzimuthTable

    giActionCounter = giActionCounter + 1
    Call PopulateClassOfStationCodeTable

    giActionCounter = giActionCounter + 1
    Call PopulateConditionTable

    giActionCounter = giActionCounter + 1
    Call PopulateContactTable

    giActionCounter = giActionCounter + 1
    Call PopulateEarthStationStaTable

    ' test
    
    giActionCounter = giActionCounter + 1
    Call PopulateForm312Table

    giActionCounter = giActionCounter + 1
    Call PopulateFrequencyTable              '  <==

    giActionCounter = giActionCounter + 1
    Call PopulateFreqCondTable

    giActionCounter = giActionCounter + 1
    Call PopulateFreqCoordTable

    giActionCounter = giActionCounter + 1
    Call PopulateFrequencyFxTable

    giActionCounter = giActionCounter + 1
    Call PopulateFxTable

    giActionCounter = giActionCounter + 1
    Call PopulateLicenseeHistoryTable

    giActionCounter = giActionCounter + 1
    Call PopulateLicenseConditionTable

'TableMain:

    giActionCounter = giActionCounter + 1
    Call PopulateMainTable

'MsgBox "pause after Main"
'DoEvents

    giActionCounter = giActionCounter + 1
    Call PopulateNatureOfServiceTable

    giActionCounter = giActionCounter + 1
    Call PopulateNatureOfServiceCodeTable

    giActionCounter = giActionCounter + 1
    Call PopulatePolarizationCodeTable

    giActionCounter = giActionCounter + 1
    Call PopulatePtCommTable

    giActionCounter = giActionCounter + 1
    Call PopulatePtCommFxTable

    giActionCounter = giActionCounter + 1
    Call PopulatePurposeTable

    'giActionCounter = giActionCounter + 1
    'Call PopulateSection214Table

SiteTable:

    giActionCounter = giActionCounter + 1
    Call PopulateSiteTable

    giActionCounter = giActionCounter + 1
    Call BuildAntSiteDataSet_A_B

    giActionCounter = giActionCounter + 1
    Call BuildAntSiteDataSet_C_D_E

'MsgBox "Pause"
'DoEvents

    giActionCounter = giActionCounter + 1
    Call PopulateSiteConditionTable

    giActionCounter = giActionCounter + 1
    Call PopulateSpaceStationTable

    giActionCounter = giActionCounter + 1
    Call PopulateSpaceStationStaTable

    giActionCounter = giActionCounter + 1
    Call PopulateStatusCodeTable

    giActionCounter = giActionCounter + 1
    Call PopulateTransmitterTable
    
    ' test
    
    giActionCounter = giActionCounter + 1
    Call PopulateFrequencyBandTable
    
    ' test
    
    giActionCounter = giActionCounter + 1
    Call PopulateIntlAlocFrequencyTable
    
    ' test
    
    giActionCounter = giActionCounter + 1
    Call PopulateFrequencySatTable

        giActionCounter = giActionCounter + 1
        frmStatus.lblStepCurrent = Str(giActionCounter)
        gtCompactDbMsg = "Compacting IBFS database !"
    Call CompactDB

    Set dbJet = wsJet.OpenDatabase(gtOutputPathAndFilename)
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)

    glLengthOfFile = 0
    gtActionText = gtCompactDbMsg
    Call WriteProcessLog

    rsProcessLog.Close
    Set rsProcessLog = Nothing
    dbJet.Close
    Set dbJet = Nothing
    wsJet.Close


Point1:

    'GoTo Point2

    giActionCounter = giActionCounter + 1
    Call EsPopulateMffTables
    
    giActionCounter = giActionCounter + 1
    Call PopulateTransmitterTable
    
    giActionCounter = giActionCounter + 1
    Call PopulateLiceEinFrnTable
    
    'giActionCounter = giActionCounter + 1
    '==> add code Call FxPopulateMffTables
    
    'Close (giBadDataFF)
        giActionCounter = giActionCounter + 1
        frmStatus.lblStepCurrent = Str(giActionCounter)
        gtCompactDbMsg = "Compacting IBFS database !"
    Call CompactDB

    Set wsJet = DBEngine.Workspaces(0)
    Set dbJet = wsJet.OpenDatabase(gtOutputPathAndFilename)
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)

    glLengthOfFile = 0
    gtActionText = gtCompactDbMsg
    Call WriteProcessLog

    rsProcessLog.Close
    Set rsProcessLog = Nothing
    dbJet.Close
    Set dbJet = Nothing
    wsJet.Close

Point2:

    frmStatus.lblStatus.Caption = "F I N I S H E D   build IBFS database!"

    wsJet.Close
    
ReStartMain:

    'Call CompactDB
    
    frmStatus.lblStatus.Caption = "F I N I S H E D   build IBFS database!"
    frmStatus.Hide
    Unload frmStatus

    Close (giBadDataFF)
    
    Exit Sub

MainErr:

    gtMsg = "Error in Main" & vbCrLf
    gtMsg = gtMsg & "error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    gtMsg = gtMsg & "This error occurred at: " & gtErrorMsg
    'Print #giBadDataFF, gtMsg
    MsgBox gtMsg

End Sub     '  Main

Sub NewLineRepair()

    'MsgBox gtInputData, , "Raw Input"
    If (Right(gtInputData, 3) <> "|^|") Then
        gtTempString = Trim(gtInputData)
        'MsgBox gtTempString, , "In If"
        Do
            Line Input #giIDFF, gtInputData
            gtTempString = gtTempString & " \n " & Trim(gtInputData)
            'MsgBox gtTempString, , "In Do"
        Loop Until (Right(gtTempString, 3) = "|^|")
        gtInputData = gtTempString
        'MsgBox gtInputData, , "Exit Do"
    End If
    gtInputData = Mid(gtInputData, 1, (Len(gtInputData) - 3))
        
    'MsgBox gtInputData, , "Now Parse"
'MsgBox "pause", , "New Line Repair"

End Sub    '  NewLineRepair

Sub PopulateMainTable()

    Dim gtInputDataArray

    Set dbJet = wsJet.OpenDatabase(gtOutputPathAndFilename)
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    Set rsMainTbl = dbJet.OpenRecordset("IbfsMain", dbOpenTable)

    gtActionText = gtActionTextMsg & "Populate Main Table!"
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)

    gxBeginDateTime = Now
    glBeginSeconds = GetTickCount()
    
    'giMaxFldCnt = 59
    'giMaxFldCnt = 67
    giMaxFldCnt = 71
    
    gtTableName = "IbfsMain"
    gtInputFileName = "main.dat"
    frmStatus.lblStatus.Caption = "Populating 'MAIN' table with  < " & gtInputFileName & " >  data !"
    frmStatus.lblStepCurrent.Caption = Str(giActionCounter)
    frmStatus.Refresh

    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh

    giIDFF = FreeFile
    Open (gtInputFilePath & gtInputFileName) For Input As giIDFF
    glLengthOfFile = LOF(giIDFF)

    frmStatus.lblFileSize.Caption = Format(glLengthOfFile, "###,###,###0")
    frmStatus.Refresh
    glRecCnt = 0
    glRecLen = 0
    
    Do While Not EOF(giIDFF)
        glRecCnt = glRecCnt + 1
        glRecLen = glRecLen + Len(gtInputData) + 2
        If ((glRecCnt Mod 100) = 0) Then
            frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
            gsPercentComplete = (glRecLen / glLengthOfFile) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
        End If
        gtTempString = ""
        Line Input #giIDFF, gtInputData
        gtInputData = Trim(gtInputData)
        If (Len(gtInputData) = 0) Then GoTo MainTag
        
        'Print #giBadDataFF, gtInputData
        
        Call NewLineRepair
        
        'MsgBox gtInputData
        'DoEvents
        
        gtInputDataArray = ""
        gtInputDataArray = Split(gtInputData, "|", giMaxFldCnt, 1)

        BeginTrans
        rsMainTbl.AddNew
        rsMainTbl!FilingKey = Val(Trim(gtInputDataArray(0)))
        rsMainTbl!FilingState = Trim(gtInputDataArray(1))
        rsMainTbl!CallSign = Trim(gtInputDataArray(2))
        rsMainTbl!FileNumber = Trim(gtInputDataArray(3))
        rsMainTbl!SubsystemCode = Trim(gtInputDataArray(4))
        rsMainTbl!StatusCode = Trim(gtInputDataArray(5))
            Call ConvertDate(Trim(gtInputDataArray(6)), gtOutputDate)
        rsMainTbl!StatusDate = gtOutputDate
        rsMainTbl!LastAction = Trim(gtInputDataArray(7))
            Call ConvertDate(Trim(gtInputDataArray(8)), gtOutputDate)
        rsMainTbl!LastActionDate = gtOutputDate
        rsMainTbl!MtsNumber = Trim(gtInputDataArray(9))
            Call ConvertDate(Trim(gtInputDataArray(10)), gtOutputDate)
        rsMainTbl!DateFiled = gtOutputDate
            Call ConvertDate(Trim(gtInputDataArray(11)), gtOutputDate)
        rsMainTbl!MellonDate = gtOutputDate
            Call ConvertDate(Trim(gtInputDataArray(12)), gtOutputDate)
        rsMainTbl!DateGrant = gtOutputDate
            Call ConvertDate(Trim(gtInputDataArray(13)), gtOutputDate)
        rsMainTbl!DateDeny = gtOutputDate
            Call ConvertDate(Trim(gtInputDataArray(14)), gtOutputDate)
        rsMainTbl!DateDismiss = gtOutputDate
            Call ConvertDate(Trim(gtInputDataArray(15)), gtOutputDate)
        rsMainTbl!DateSurrender = gtOutputDate
            Call ConvertDate(Trim(gtInputDataArray(16)), gtOutputDate)
        rsMainTbl!DateBegin = gtOutputDate
            Call ConvertDate(Trim(gtInputDataArray(17)), gtOutputDate)
        rsMainTbl!DateExpire = gtOutputDate
            Call ConvertDate(Trim(gtInputDataArray(18)), gtOutputDate)
        rsMainTbl!DateLastUpdate = gtOutputDate
        
        rsMainTbl!AffPubNoticeSw = Trim(gtInputDataArray(19))
            Call ConvertDate(Trim(gtInputDataArray(20)), gtOutputDate)
        rsMainTbl!AffPubNoticeDate = gtOutputDate
        rsMainTbl!ActPubNoticeSw = Trim(gtInputDataArray(21))
            Call ConvertDate(Trim(gtInputDataArray(22)), gtOutputDate)
        rsMainTbl!ActPubNoticeDate = gtOutputDate
        rsMainTbl!SubmissionId = Trim(gtInputDataArray(23))
        rsMainTbl!FeeControlNumber = Mid(Trim(gtInputDataArray(24)), 1, 20)
        rsMainTbl!AppTypeCode = Trim(gtInputDataArray(25))
        
            rsMainTbl!FilingOtherTxt = ""    '  Initialize "Memo" field
        rsMainTbl!FilingOtherTxt.AppendChunk Trim(gtInputDataArray(26))

        rsMainTbl!KeyWord1 = Trim(gtInputDataArray(27))
        rsMainTbl!KeyWord2 = Trim(gtInputDataArray(28))
        rsMainTbl!TowerClearedSw = Trim(gtInputDataArray(29))
            Call ConvertDate(Trim(gtInputDataArray(30)), gtOutputDate)
        rsMainTbl!DateBlocked = gtOutputDate
        rsMainTbl!BlockedReasonCode = Trim(gtInputDataArray(31))
        
            rsMainTbl!BlockedReason = ""    '  Initialize "Memo" field
        rsMainTbl!BlockedReason.AppendChunk Trim(gtInputDataArray(32))
        
        rsMainTbl!TypeApplicantCode = Trim(gtInputDataArray(33))
            
            rsMainTbl!ApplicantOtherText = ""    '  Initialize "Memo" field
        rsMainTbl!ApplicantOtherText.AppendChunk Trim(gtInputDataArray(34))
        
        If (Len(Trim(gtInputDataArray(35))) = 0) Then
            rsMainTbl!ClassOfStationCode = "??"
        Else
            rsMainTbl!ClassOfStationCode = Trim(gtInputDataArray(35))
        End If
        rsMainTbl!ClassOtherText = ""     '  Initialize "Memo" field
        rsMainTbl!ClassOtherText.AppendChunk Trim(gtInputDataArray(36))
        
        rsMainTbl!SignerName = ""      '  Initialize "Memo" field
        rsMainTbl!SignerName.AppendChunk Trim(gtInputDataArray(37))
        
        rsMainTbl!SignerTitle = ""       '  Initialize "Memo" field
        rsMainTbl!SignerTitle.AppendChunk Trim(gtInputDataArray(38))
        
            Call ConvertDate(Trim(gtInputDataArray(39)), gtOutputDate)
        rsMainTbl!DateSigned = gtOutputDate
        
        rsMainTbl!Description = ""       '  Initialize "Memo" field
        rsMainTbl!Description.AppendChunk Trim(gtInputDataArray(40))
        
        rsMainTbl!AddressKey = Val(Trim(gtInputDataArray(41)))
        
        rsMainTbl!AddressAttention = ""       '  Initialize "Memo" field
        rsMainTbl!AddressAttention.AppendChunk Trim(gtInputDataArray(42))
        
        rsMainTbl!AddressPhoneNum = Trim(gtInputDataArray(43))
        rsMainTbl!AddressFaxNum = Trim(gtInputDataArray(44))
        
        rsMainTbl!AddressEMail = Trim(gtInputDataArray(45))
        
        rsMainTbl!ContactKey = Val(Trim(gtInputDataArray(46)))
        
        rsMainTbl!ContactAttention = ""       '  Initialize "Memo" field
        rsMainTbl!ContactAttention.AppendChunk Trim(gtInputDataArray(47))
        
        rsMainTbl!ContactRelationship = Trim(gtInputDataArray(48))
        rsMainTbl!ContactPhoneNum = Trim(gtInputDataArray(49))
        rsMainTbl!ContactFaxNum = Trim(gtInputDataArray(50))
        
        rsMainTbl!ContactEMail = ""       '  Initialize "Memo" field
        rsMainTbl!ContactEMail.AppendChunk Trim(gtInputDataArray(51))
        
        rsMainTbl!OtherPurposeText = ""       '  Initialize "Memo" field
        rsMainTbl!OtherPurposeText.AppendChunk Trim(gtInputDataArray(52))
        rsMainTbl!StreamlinedSw = Trim(gtInputDataArray(53))
            Call ConvertDate(Trim(gtInputDataArray(54)), gtOutputDate)
        rsMainTbl!DateTransferred = gtOutputDate
        rsMainTbl!Confidential = Trim(gtInputDataArray(55))
            Call ConvertDate(Trim(gtInputDataArray(56)), gtOutputDate)
        rsMainTbl!DateQueued = gtOutputDate
            Call ConvertDate(Trim(gtInputDataArray(57)), gtOutputDate)
        rsMainTbl!DateWithdrew = gtOutputDate
        rsMainTbl!QueueFlag = Trim(gtInputDataArray(58))
        
        rsMainTbl!FilingId = Trim(gtInputDataArray(59))
            Call ConvertDate(Trim(gtInputDataArray(60)), gtOutputDate)
        rsMainTbl!DateCreated = gtOutputDate
        rsMainTbl!InitiatorId = Trim(gtInputDataArray(61))
        rsMainTbl!PublicPnNoteKey = Val(Trim(gtInputDataArray(62)))
        rsMainTbl!FeeExemptSw = Trim(gtInputDataArray(63))
            rsMainTbl!FeeExemptReason = ""    '  Initialize "Memo" field
        rsMainTbl!FeeExemptReason.AppendChunk Trim(gtInputDataArray(64))    '  Varchar(255)
        rsMainTbl!RemittanceId = Val(gtInputDataArray(65))    '  Int
        rsMainTbl!NextStep = Trim(gtInputDataArray(66))
        rsMainTbl!ReleasedBy = Trim(gtInputDataArray(67))    '  Char(1)
            Call ConvertDate(Trim(gtInputDataArray(68)), gtOutputDate)
        rsMainTbl!DateReleased = gtOutputDate    '  DateTime
            Call ConvertDate(Trim(gtInputDataArray(69)), gtOutputDate)
        rsMainTbl!DateAdopted = gtOutputDate    '  DateTime
        rsMainTbl!OrderDaNumber = Trim(gtInputDataArray(70))    '  Char(12)
        
        rsMainTbl.Update
        CommitTrans
        DoEvents

MainTag:
    Loop
    Close (giIDFF)
    
    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    DoEvents

    Call WriteProcessLog

    rsMainTbl.Close
    Set rsMainTbl = Nothing
    rsProcessLog.Close
    Set rsProcessLog = Nothing
    dbJet.Close

    'gtCompactMsg = "Compacting Database  < " & gtInputFileName & " >"
    'Call CompactDB
    frmStatus.lblStatus.Caption = "Finished processing  <  " & gtInputFileName & "  >  data !"
    frmStatus.Refresh

    Exit Sub
    
PopulateMainTableErr:
    
    gtMsg = "Error in PopulateMainTable" & vbCrLf
    gtMsg = gtMsg & "Error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    'Print #giBadDataFF, gtMsg
    MsgBox gtMsg

End Sub    '  PopulateMainTable

Sub PopulateAddressTable()

    Dim gtInputDataArray

    Set dbJet = wsJet.OpenDatabase(gtOutputPathAndFilename)
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    Set rsAddressTbl = dbJet.OpenRecordset("IbfsAddress", dbOpenTable)
    
    gtActionText = gtActionTextMsg & "Addr data!"
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    
    gxBeginDateTime = Now
    glBeginSeconds = GetTickCount()
    
    'giMaxFldCnt = 13
    giMaxFldCnt = 14
    
    gtTableName = "IbfsAddress"
    gtInputFileName = "address.dat"
    frmStatus.lblStatus.Caption = "Populating 'Address' table with  < " & gtInputFileName & " >  data !"
    frmStatus.lblStepCurrent.Caption = Str(giActionCounter)
    frmStatus.Refresh

    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh

    giIDFF = FreeFile
    Open (gtInputFilePath & gtInputFileName) For Input As giIDFF
    glLengthOfFile = LOF(giIDFF)

    frmStatus.lblFileSize.Caption = Format(glLengthOfFile, "###,###,###0")
    frmStatus.Refresh
    glRecCnt = 0
    glRecLen = 0

    Do While Not EOF(giIDFF)
        glRecCnt = glRecCnt + 1
        glRecLen = glRecLen + Len(gtInputData) + 2
        If ((glRecCnt Mod 100) = 0) Then
            frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
            gsPercentComplete = (glRecLen / glLengthOfFile) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
        End If
        Line Input #giIDFF, gtInputData
        gtInputData = Trim(gtInputData)
        
        If (Len(gtInputData) = 0) Then GoTo AddressTag

        Call NewLineRepair
        
        gtInputDataArray = ""
        gtInputDataArray = Split(gtInputData, "|", giMaxFldCnt, 1)

        BeginTrans
        rsAddressTbl.AddNew
        rsAddressTbl!AddressKey = Val(gtInputDataArray(0))
        rsAddressTbl!AddressId = Trim(gtInputDataArray(1))
        rsAddressTbl!AddressName = Trim(gtInputDataArray(2))
        rsAddressTbl!DbaName = Trim(gtInputDataArray(3))
        rsAddressTbl!Street1 = Trim(gtInputDataArray(4))
        rsAddressTbl!Street2 = Trim(gtInputDataArray(5))
        rsAddressTbl!City = Trim(gtInputDataArray(6))
        rsAddressTbl!StateCode = Trim(Mid(gtInputDataArray(7), 1, 2))
        rsAddressTbl!ZipCode = Trim(gtInputDataArray(8))
        rsAddressTbl!CountryCode = Trim(Mid(gtInputDataArray(9), 1, 2))
        rsAddressTbl!Soundex = Trim(gtInputDataArray(10))
        rsAddressTbl!DbaSoundex = Trim(gtInputDataArray(11))
        rsAddressTbl!Frn = Mid(Trim(gtInputDataArray(12)), 1, 10)
        'rsAddressTbl!Redlight = Trim(gtInputDataArray(13))
        rsAddressTbl.Update
        CommitTrans
        DoEvents

AddressTag:
    Loop
    Close (giIDFF)

    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    DoEvents

    gtActionText = "PopulateAddressTable"
    Call WriteProcessLog
        
    rsAddressTbl.Close
    Set rsAddressTbl = Nothing
    rsProcessLog.Close
    Set rsProcessLog = Nothing
    dbJet.Close

    'gtCompactMsg = "Compacting Database  < " & gtInputFileName & " >"
    'Call CompactDB
    frmStatus.lblStatus.Caption = "Finished processing  <  " & gtInputFileName & "  >  data !"
    DoEvents

    Exit Sub
    
PopulateAddressTableErr:
    
    gtMsg = "Error in PopulateSiteTable" & vbCrLf
    gtMsg = gtMsg & "Error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    'Print #giBadDataFF, gtMsg
    MsgBox gtMsg

End Sub    '  PopulateAddressTable

Sub PopulateContactTable()

    Dim gtInputDataArray

    Set dbJet = wsJet.OpenDatabase(gtOutputPathAndFilename)
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    Set rsContactTbl = dbJet.OpenRecordset("IbfsContact", dbOpenTable)

    gtActionText = gtActionTextMsg & "Populate Contact Table!"
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)

    gxBeginDateTime = Now
    glBeginSeconds = GetTickCount()
    
    giMaxFldCnt = 12
    'giMaxFldCnt = 13
    
    gtTableName = "IbfsContact"
    gtInputFileName = "contact.dat"
    frmStatus.lblStatus.Caption = "Populating 'Contact' table with  < " & gtInputFileName & " >  data !"
    frmStatus.lblStepCurrent.Caption = Str(giActionCounter)
    frmStatus.Refresh
    
    'Print #giBadDataFF, ""
    'Print #giBadDataFF, "=====>  " & gtInputFileName & "  <====="
    'Print #giBadDataFF, ""
    
    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh

    giIDFF = FreeFile
    Open (gtInputFilePath & gtInputFileName) For Input As giIDFF
    glLengthOfFile = LOF(giIDFF)

    frmStatus.lblFileSize.Caption = Format(glLengthOfFile, "###,###,###0")
    frmStatus.Refresh
    glRecCnt = 0
    glRecLen = 0

    Do While Not EOF(giIDFF)
        glRecCnt = glRecCnt + 1
        glRecLen = glRecLen + Len(gtInputData) + 2
        If ((glRecCnt Mod 100) = 0) Then
            frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
            gsPercentComplete = (glRecLen / glLengthOfFile) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
        End If
        Line Input #giIDFF, gtInputData
        gtInputData = Trim(gtInputData)
        
        If (Len(gtInputData) = 0) Then GoTo ContactTag

        Call NewLineRepair

        gtInputDataArray = ""
        gtInputDataArray = Split(gtInputData, "|", giMaxFldCnt, 1)

        BeginTrans
        rsContactTbl.AddNew
        rsContactTbl!ContactKey = Val(gtInputDataArray(0))
        rsContactTbl!ContactId = Trim(gtInputDataArray(1))
        rsContactTbl!ContactName = Trim(gtInputDataArray(2))
        rsContactTbl!Title = Trim(gtInputDataArray(3))
        rsContactTbl!CompanyName = Trim(gtInputDataArray(4))
        rsContactTbl!Street1 = Trim(gtInputDataArray(5))
        rsContactTbl!Street2 = Trim(gtInputDataArray(6))
        rsContactTbl!City = Trim(gtInputDataArray(7))
        rsContactTbl!StateCode = Mid(Trim(gtInputDataArray(8)), 1, 2)
        rsContactTbl!ZipCode = Trim(gtInputDataArray(9))
        rsContactTbl!CountryCode = Mid(Trim(gtInputDataArray(10)), 1, 3)
        rsContactTbl!Frn = Mid(Trim(gtInputDataArray(11)), 1, 20)
        rsContactTbl.Update
        CommitTrans
        DoEvents

ContactTag:
    Loop
    Close (giIDFF)
    
    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    DoEvents

    Call WriteProcessLog

    rsContactTbl.Close
    Set rsContactTbl = Nothing
    rsProcessLog.Close
    Set rsProcessLog = Nothing
    dbJet.Close

    'gtCompactMsg = "Compacting Database  < " & gtInputFileName & " >"
    'Call CompactDB
    frmStatus.lblStatus.Caption = "Finished processing  <  " & gtInputFileName & "  >  data !"
    DoEvents

    Exit Sub
    
PopulateContactTableErr:
    
    gtMsg = "Error in PopulateContactTable" & vbCrLf
    gtMsg = gtMsg & "Error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    'Print #giBadDataFF, gtMsg
    MsgBox gtMsg

End Sub    '  PopulateContactTable

Sub PopulateSiteTable()

    Dim gtInputDataArray

    Set dbJet = wsJet.OpenDatabase(gtOutputPathAndFilename)
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    Set rsSiteTbl = dbJet.OpenRecordset("IbfsSite", dbOpenTable)
    
    gtActionText = gtActionTextMsg & "Populate Site Table!"
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    
    gxBeginDateTime = Now
    glBeginSeconds = GetTickCount()
    
    'giMaxFldCnt = 30
    giMaxFldCnt = 33
    
    gtTableName = "IbfsSite"
    gtInputFileName = "site.dat"
    frmStatus.lblStatus.Caption = "Populating 'Site' table with  < " & gtInputFileName & " >  data !"
    frmStatus.lblStepCurrent.Caption = Str(giActionCounter)
    frmStatus.Refresh
    'Print #giBadDataFF, ""
    'Print #giBadDataFF, "=====>  " & gtInputFileName & "  <====="
    'Print #giBadDataFF, ""
    
    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh

    giIDFF = FreeFile
    Open (gtInputFilePath & gtInputFileName) For Input As giIDFF
    glLengthOfFile = LOF(giIDFF)

    frmStatus.lblFileSize.Caption = Format(glLengthOfFile, "###,###,###0")
    frmStatus.Refresh
    glRecCnt = 0
    glRecLen = 0

    Do While Not EOF(giIDFF)
        glRecCnt = glRecCnt + 1
        glRecLen = glRecLen + Len(gtInputData) + 2
        If ((glRecCnt Mod 100) = 0) Then
            frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
            gsPercentComplete = (glRecLen / glLengthOfFile) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
        End If
        Line Input #giIDFF, gtInputData
        gtInputData = Trim(gtInputData)
        
        If (Len(gtInputData) = 0) Then GoTo SiteTag

        Call NewLineRepair

        gtInputDataArray = ""
        gtInputDataArray = Split(gtInputData, "|", giMaxFldCnt, 1)

        BeginTrans
        rsSiteTbl.AddNew
        rsSiteTbl!SiteKey = Val(Trim(gtInputDataArray(0)))
        rsSiteTbl!FilingKey = Val(Trim(gtInputDataArray(1)))
        rsSiteTbl!SiteId = Trim(gtInputDataArray(2))
        rsSiteTbl!SiteDescription = ""        '  Initialize "Memo" field
        rsSiteTbl!SiteDescription.AppendChunk Trim(gtInputDataArray(3))       '  255
        rsSiteTbl!ContactPerson = Trim(gtInputDataArray(4))
        rsSiteTbl!SiteStreet1 = Trim(gtInputDataArray(5))
        rsSiteTbl!SiteStreet2 = Trim(gtInputDataArray(6))
        rsSiteTbl!SiteCity = Trim(gtInputDataArray(7))
        rsSiteTbl!SiteCounty = Trim(gtInputDataArray(8))
        rsSiteTbl!SiteState = Trim(gtInputDataArray(9))
        rsSiteTbl!SiteZipcode = Trim(gtInputDataArray(10))
        rsSiteTbl!SiteTelephone = Trim(gtInputDataArray(11))
        gdSiteElevation = Val(Trim(gtInputDataArray(12)))
        If (gdSiteElevation > 9999.9) Then
            gdSiteElevation = 9999.9
            ' bad data
        End If
        If (gdSiteElevation >= 0) Then
            gtSiteElevation = Format(gdSiteElevation, "0000.0; 000.0;0000.0")
        Else
            gtSiteElevation = Format(Abs(gdSiteElevation), "-000.0")
        End If
        rsSiteTbl!SiteElevation = gtSiteElevation
        
        ' = = = = =
        If (Abs(Val(gtInputDataArray(13))) > 90) Then
            MsgBox ("Site Key: " & gtInputDataArray(0) & vbCrLf & "Lat Deg: " & vbCrLf & gtInputDataArray(13)), , "Site Table"
            DoEvents
        End If
        If (Abs(Val(gtInputDataArray(14))) >= 60) Then
            MsgBox ("Site Key: " & gtInputDataArray(0) & vbCrLf & "Lat Min: " & vbCrLf & gtInputDataArray(14)), , "Site Table"
            DoEvents
        End If
        If (Abs(Val(gtInputDataArray(15))) >= 60) Then
            'MsgBox ("Site Key: " & gtInputDataArray(0) & vbCrLf & "Lat Sec: " & vbCrLf & gtInputDataArray(15)), , "Site Table"
            'DoEvents
        End If
        ' = = = = =
        
        If ((Mid(Trim(gtInputDataArray(16)), 1, 1) = "N") Or (IsNull(gtInputDataArray(16)))) Then
            rsSiteTbl!SiteLatDMS = "N" & _
                                Format(Val(Trim(gtInputDataArray(13))), "000") & _
                                Format(Val(Trim(gtInputDataArray(14))), "00") & _
                                Format(Val(Trim(gtInputDataArray(15))), "00.0")
        Else
            rsSiteTbl!SiteLatDMS = "S" & _
                                Format(Val(Trim(gtInputDataArray(13))), "000") & _
                                Format(Val(Trim(gtInputDataArray(14))), "00") & _
                                Format(Val(Trim(gtInputDataArray(15))), "00.0")
        End If
        gdSiteLatSec = (Val(Trim(gtInputDataArray(13))) * 3600) + _
                        (Val(Trim(gtInputDataArray(14))) * 60) + _
                        (Val(Trim(gtInputDataArray(15))))
        If ((Mid(Trim(gtInputDataArray(16)), 1, 1) = "N") Or (IsNull(gtInputDataArray(16)))) Then
            rsSiteTbl!SiteLatSec = Format(gdSiteLatSec, "00000000.0")
        Else
            rsSiteTbl!SiteLatSec = Format(gdSiteLatSec, "-0000000.0")
        End If

        ' = = = = =
        If (Abs(Val(gtInputDataArray(17))) > 180) Then
            MsgBox ("Site Key: " & gtInputDataArray(0) & vbCrLf & "Lon Deg: " & vbCrLf & gtInputDataArray(17)), , "Site Table"
            DoEvents
        End If
        If (Abs(Val(gtInputDataArray(18))) >= 60) Then
            'MsgBox ("Site Key: " & gtInputDataArray(0) & vbCrLf & "Lon Min: " & vbCrLf & gtInputDataArray(18)), , "Site Table"
            'DoEvents
        End If
        If (Abs(Val(gtInputDataArray(19))) >= 60) Then
            'MsgBox ("Site Key: " & gtInputDataArray(0) & vbCrLf & "Lon Sec: " & vbCrLf & gtInputDataArray(19)), , "Site Table"
            'DoEvents
        End If
        ' = = = = =
        If ((Mid(Trim(gtInputDataArray(20)), 1, 1) = "W") Or (IsNull(gtInputDataArray(20)))) Then
            rsSiteTbl!SiteLonDMS = "W" & _
                                Format(Val(Trim(gtInputDataArray(17))), "000") & _
                                Format(Val(Trim(gtInputDataArray(18))), "00") & _
                                Format(Val(Trim(gtInputDataArray(19))), "00.0")
        Else
            rsSiteTbl!SiteLonDMS = "E" & _
                                Format(Val(Trim(gtInputDataArray(17))), "000") & _
                                Format(Val(Trim(gtInputDataArray(18))), "00") & _
                                Format(Val(Trim(gtInputDataArray(19))), "00.0")
        End If
        gdSiteLonSec = (Val(Trim(gtInputDataArray(17))) * 3600) + _
                       (Val(Trim(gtInputDataArray(18))) * 60) + _
                       (Val(Trim(gtInputDataArray(19))))
        If ((Mid(Trim(gtInputDataArray(20)), 1, 1) = "W") Or (IsNull(gtInputDataArray(20)))) Then
            rsSiteTbl!SiteLonSec = Format(gdSiteLonSec, "-0000000.0")
        Else
            rsSiteTbl!SiteLonSec = Format(gdSiteLonSec, "00000000.0")
        End If
        
        rsSiteTbl!NadInd = Val(Trim(gtInputDataArray(21)))
        rsSiteTbl!NumVsatsBuilt = Format(Val(Trim(gtInputDataArray(22))), "000000")
            Call ConvertDate(Trim(gtInputDataArray(23)), gtOutputDate)
        rsSiteTbl!VsatReportDate = gtOutputDate
        rsSiteTbl!FaaCoordSw = Trim(gtInputDataArray(24))
        rsSiteTbl!Comply25209aSw = Trim(gtInputDataArray(25))
        rsSiteTbl!Comply25209a2Sw = Trim(gtInputDataArray(26))
        rsSiteTbl!RemoteControlSw = Trim(gtInputDataArray(27))
        rsSiteTbl!ForeignFreqCoordReqSw = Trim(gtInputDataArray(28))
        rsSiteTbl!FreqCoordReqSw = Trim(gtInputDataArray(29))
        
        'rsSiteTbl!AreaOfOperationCode = Trim(gtInputDataArray(30))
        'rsSiteTbl!FaaCoordNotReqSw = Trim(gtInputDataArray(31))
        'rsSiteTbl!Comply25211Sw = Trim(gtInputDataArray(32))
        
        rsSiteTbl.Update
        CommitTrans
        DoEvents

SiteTag:
    Loop
    Close (giIDFF)
    
    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    DoEvents

    Call WriteProcessLog

    rsSiteTbl.Close
    Set rsSiteTbl = Nothing
    rsProcessLog.Close
    Set rsProcessLog = Nothing
    dbJet.Close

    'gtCompactMsg = "Compacting Database  < " & gtInputFileName & " >"
    'Call CompactDB
    frmStatus.lblStatus.Caption = "Finished processing  <  " & gtInputFileName & "  >  data !"
    DoEvents

    Exit Sub
    
PopulateSiteTableErr:
    
    gtMsg = "Error in PopulateSiteTable" & vbCrLf
    gtMsg = gtMsg & "Error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    'Print #giBadDataFF, gtMsg
    MsgBox gtMsg

End Sub    '  PopulateSiteTable

Sub PopulateAntennaTable()

    Dim gtInputDataArray

    Set dbJet = wsJet.OpenDatabase(gtOutputPathAndFilename)
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    Set rsAntennaTbl = dbJet.OpenRecordset("IbfsAntenna", dbOpenTable)

    gtActionText = gtActionTextMsg & "Populate Antenna Table!"
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)

    gxBeginDateTime = Now
    glBeginSeconds = GetTickCount()
    
    giMaxFldCnt = 17
    gtTableName = "IbfsAntenna"
    gtInputFileName = "anten.dat"
    frmStatus.lblStatus.Caption = "Populating 'Antenna' table with  < " & gtInputFileName & " >  data !"
    frmStatus.lblStepCurrent.Caption = Str(giActionCounter)
    frmStatus.Refresh
    'Print #giBadDataFF, ""
    'Print #giBadDataFF, "=====>  " & gtInputFileName & "  <====="
    'Print #giBadDataFF, ""
    
    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh

    giIDFF = FreeFile
    Open (gtInputFilePath & gtInputFileName) For Input As giIDFF
    glLengthOfFile = LOF(giIDFF)

    frmStatus.lblFileSize.Caption = Format(glLengthOfFile, "###,###,###0")
    frmStatus.Refresh
    glRecCnt = 0
    glRecLen = 0

    Do While Not EOF(giIDFF)
        glRecCnt = glRecCnt + 1
        glRecLen = glRecLen + Len(gtInputData) + 2
        If ((glRecCnt Mod 100) = 0) Then
            frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
            gsPercentComplete = (glRecLen / glLengthOfFile) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
        End If
        Line Input #giIDFF, gtInputData
        gtInputData = Trim(gtInputData)
        
        If (Len(gtInputData) = 0) Then GoTo AntennaTag

        Call NewLineRepair

        gtInputDataArray = ""
        gtInputDataArray = Split(gtInputData, "|", giMaxFldCnt, 1)

        BeginTrans
        rsAntennaTbl.AddNew
        rsAntennaTbl!AntennaKey = Val(gtInputDataArray(0))
        rsAntennaTbl!AntennaId = Trim(gtInputDataArray(1))
        rsAntennaTbl!SiteKey = Val(gtInputDataArray(2))
        rsAntennaTbl!Diameter = Format(Val(gtInputDataArray(3)), "0000.0")
        rsAntennaTbl!DiameterMinor = Format(Val(gtInputDataArray(4)), "0000.0")
        rsAntennaTbl!DiameterMajor = Format(Val(gtInputDataArray(5)), "0000.0")
        rsAntennaTbl!HeightBldgAgl = Format(Val(gtInputDataArray(6)), "0000.0")
            gdHeightMaxAgl = Abs(Val(gtInputDataArray(7)))
            If (gdHeightMaxAgl >= 9999.9) Then gdHeightMaxAgl = 9999.9
        rsAntennaTbl!HeightMaxAgl = Format(gdHeightMaxAgl, "0000.0")
            gdHeightMaxAmsl = Val(gtInputDataArray(8))
            If (gdHeightMaxAmsl >= 9999.9) Then gdHeightMaxAmsl = 9999.9
        If (gdHeightMaxAmsl >= 0) Then
            rsAntennaTbl!HeightMaxAmsl = Format(gdHeightMaxAmsl, "0000.0")
        Else
            rsAntennaTbl!HeightMaxAmsl = Format(gdHeightMaxAmsl, "000.0")
        End If
            gdHeightMaxARoof = Val(gtInputDataArray(9))
            If (gdHeightMaxARoof >= 9999.9) Then gdHeightMaxARoof = 9999.9
        rsAntennaTbl!HeightMaxARoof = Format(gdHeightMaxARoof, "0000.0;0000.0; 000.0")
        rsAntennaTbl!Manufacturer = Trim(gtInputDataArray(10))
            gdMaxInputPower = Val(gtInputDataArray(11))
            If (gdMaxInputPower >= 9999.9) Then gdMaxInputPower = 9999.9
        
        rsAntennaTbl!MaxInputPower = Format(gdMaxInputPower, "0000.0; 000.0;0000.0")
            gdMaxOutputEirp = Val(gtInputDataArray(12))
            If (gdMaxOutputEirp >= 9999.9) Then gdMaxOutputEirp = 9999.9
        rsAntennaTbl!MaxOutputEirp = Format(gdMaxOutputEirp, "0000.0; 000.0;0000.0")
        rsAntennaTbl!Model = Trim(gtInputDataArray(13))
        rsAntennaTbl!Quantity = Format(Val(gtInputDataArray(14)), "000000")
        rsAntennaTbl!TowerId = Trim(gtInputDataArray(15))
        rsAntennaTbl!TowerClearedSw = Trim(gtInputDataArray(16))
        rsAntennaTbl.Update
        CommitTrans
        DoEvents

AntennaTag:
    Loop
    Close (giIDFF)
    
    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    DoEvents

    Call WriteProcessLog

    rsAntennaTbl.Close
    Set rsAntennaTbl = Nothing
    rsProcessLog.Close
    Set rsProcessLog = Nothing
    dbJet.Close

    'gtCompactMsg = "Compacting Database  < " & gtInputFileName & " >"
    'Call CompactDB
    frmStatus.lblStatus.Caption = "Finished processing  <  " & gtInputFileName & "  >  data !"
    DoEvents

    Exit Sub
    
PopulateAntennaTableErr:
    
    gtMsg = "Error in PopulateAntennaTable" & vbCrLf
    gtMsg = gtMsg & "Error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    'Print #giBadDataFF, gtMsg
    MsgBox gtMsg

End Sub    '  PopulateAntennaTable

Sub PopulateAntennaFxTable()

    Set dbJet = wsJet.OpenDatabase(gtOutputPathAndFilename)
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    Set rsAntennaFxTbl = dbJet.OpenRecordset("IbfsAntennaFx", dbOpenTable)

    gtActionText = gtActionTextMsg & "Populate Antenna FX Table!"
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)

    gxBeginDateTime = Now
    glBeginSeconds = GetTickCount()
    
    giMaxFldCnt = 28
    gtTableName = "IbfsAntennaFx"
    gtInputFileName = "ant_fx.dat"
    frmStatus.lblStatus.Caption = "Populating 'AntennaFx' table with  < " & gtInputFileName & " >  data !"
    frmStatus.lblStepCurrent.Caption = Str(giActionCounter)
    frmStatus.Refresh
    'Print #giBadDataFF, ""
    'Print #giBadDataFF, "=====>  " & gtInputFileName & "  <====="
    'Print #giBadDataFF, ""
    
    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh

    giIDFF = FreeFile
    Open (gtInputFilePath & gtInputFileName) For Input As giIDFF
    glLengthOfFile = LOF(giIDFF)

    frmStatus.lblFileSize.Caption = Format(glLengthOfFile, "###,###,###0")
    frmStatus.Refresh
    glRecCnt = 0
    glRecLen = 0

    Do While Not EOF(giIDFF)
        glRecCnt = glRecCnt + 1
        glRecLen = glRecLen + Len(gtInputData) + 2
        If ((glRecCnt Mod 100) = 0) Then
            frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
            gsPercentComplete = (glRecLen / glLengthOfFile) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
        End If
        Line Input #giIDFF, gtInputData
        gtInputData = Trim(gtInputData)
        
        If (Len(gtInputData) = 0) Then GoTo AntennaFxTag

        Call NewLineRepair

        giSegmCnt = 1
        Erase gtDataArray
        Call ParseInputData

        BeginTrans
        rsAntennaFxTbl.AddNew
        rsAntennaFxTbl!AntennaKey = Val(gtDataArray(1, giSegmCnt))
        rsAntennaFxTbl!SiteKey = Val(gtDataArray(2, giSegmCnt))
        rsAntennaFxTbl!AntennaId = Trim(Trim(gtDataArray(3, giSegmCnt)))
        rsAntennaFxTbl!Gain1 = Format(Val(gtDataArray(4, giSegmCnt)), "0000.0")
        rsAntennaFxTbl!Gain2 = Format(Val(gtDataArray(5, giSegmCnt)), "0000.0")
        rsAntennaFxTbl!Frequency1 = Trim(gtDataArray(6, giSegmCnt))
        rsAntennaFxTbl!Frequency2 = Trim(gtDataArray(7, giSegmCnt))
        rsAntennaFxTbl!PolarizationCode = Trim(gtDataArray(8, giSegmCnt))
        rsAntennaFxTbl!FrequencyLower = Trim(gtDataArray(9, giSegmCnt))
        rsAntennaFxTbl!FrequencyUpper = Trim(gtDataArray(10, giSegmCnt))
        rsAntennaFxTbl!HeightMaxAmsl = Format(Val(Trim(gtDataArray(11, giSegmCnt))), "0000.0")
        rsAntennaFxTbl!HeightMaxAgl = Format(Val(Trim(gtDataArray(12, giSegmCnt))), "0000.0")
        rsAntennaFxTbl!Elevation = Format(Val(Trim(gtDataArray(13, giSegmCnt))), "0000.0")
        rsAntennaFxTbl!Manufacturer = Trim(gtDataArray(14, giSegmCnt))
        rsAntennaFxTbl!Model = Trim(gtDataArray(15, giSegmCnt))
        rsAntennaFxTbl!Quantity = Format(Val(gtDataArray(16, giSegmCnt)), "000000")
        rsAntennaFxTbl!TowerId = Trim(gtDataArray(17, giSegmCnt))
        rsAntennaFxTbl!Beamwidth = Format(Val(gtDataArray(18, giSegmCnt)), "0000.0")
        rsAntennaFxTbl!RotatableSw = Trim(gtDataArray(19, giSegmCnt))
        rsAntennaFxTbl!TakeOffAngle = Format(Val(gtDataArray(20, giSegmCnt)), "0000.0")
        rsAntennaFxTbl!SlewableSw = Trim(gtDataArray(21, giSegmCnt))
        rsAntennaFxTbl!SlewAmt = Format(Val(gtDataArray(22, giSegmCnt)), "0000.0;0000.0; 000.0")
        rsAntennaFxTbl!TargetZone = Trim(gtDataArray(23, giSegmCnt))
        rsAntennaFxTbl!AntennaTypeCode = Format(Val(gtDataArray(24, giSegmCnt)), "00")
        rsAntennaFxTbl!AntennaPattern = Trim(gtDataArray(25, giSegmCnt))
        rsAntennaFxTbl!SchematicSw = Trim(gtDataArray(26, giSegmCnt))
        rsAntennaFxTbl!OperationDesc = ""
        rsAntennaFxTbl!OperationDesc.AppendChunk Trim(gtDataArray(27, giSegmCnt))
        rsAntennaFxTbl!TowerClearedSw = Trim(gtDataArray(28, giSegmCnt))
        rsAntennaFxTbl.Update
        CommitTrans
        DoEvents

AntennaFxTag:
    Loop
    Close (giIDFF)
    
    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    DoEvents

    Call WriteProcessLog

    rsAntennaFxTbl.Close
    Set rsAntennaFxTbl = Nothing
    rsProcessLog.Close
    Set rsProcessLog = Nothing
    dbJet.Close

    frmStatus.lblStatus.Caption = "Finished processing  <  " & gtInputFileName & "  >  data !"
    DoEvents

    Exit Sub
    
PopulateAntennaFxTableErr:
    
    gtMsg = "Error in PopulateAntennaFxTable" & vbCrLf
    gtMsg = gtMsg & "Error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    'Print #giBadDataFF, gtMsg
    MsgBox gtMsg

End Sub    '  PopulateAntennaFxFxTable

Sub PopulateAntennaGainTable()

    Dim gtInputDataArray

    Set dbJet = wsJet.OpenDatabase(gtOutputPathAndFilename)
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    Set rsAntennaGainTbl = dbJet.OpenRecordset("IbfsAntennaGain", dbOpenTable)

    gtActionText = gtActionTextMsg & "Populate Antenna Gain Table!"
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)

    gxBeginDateTime = Now
    glBeginSeconds = GetTickCount()
    

    giMaxFldCnt = 5
    
    gtTableName = "IbfsAntennaGain"
    gtInputFileName = "ant_gain.dat"
    frmStatus.lblStatus.Caption = "Populating 'AntennaGain' table with  < " & gtInputFileName & " >  data !"
    frmStatus.lblStepCurrent.Caption = Str(giActionCounter)
    frmStatus.Refresh
    'Print #giBadDataFF, ""
    'Print #giBadDataFF, "=====>  " & gtInputFileName & "  <====="
    'Print #giBadDataFF, ""
    
    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh

    giIDFF = FreeFile
    Open (gtInputFilePath & gtInputFileName) For Input As giIDFF
    glLengthOfFile = LOF(giIDFF)

    frmStatus.lblFileSize.Caption = Format(glLengthOfFile, "###,###,###0")
    frmStatus.Refresh
    glRecCnt = 0
    glRecLen = 0

    Do While Not EOF(giIDFF)
        glRecCnt = glRecCnt + 1
        glRecLen = glRecLen + Len(gtInputData) + 2
        If ((glRecCnt Mod 100) = 0) Then
            frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
            gsPercentComplete = (glRecLen / glLengthOfFile) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
        End If
        Line Input #giIDFF, gtInputData
        gtInputData = Trim(gtInputData)
        
        If (Len(gtInputData) = 0) Then GoTo AntennaGainTag

        Call NewLineRepair

        gtInputDataArray = ""
        gtInputDataArray = Split(gtInputData, "|", giMaxFldCnt, 1)

        BeginTrans
        rsAntennaGainTbl.AddNew
        rsAntennaGainTbl!GainKey = Val(gtInputDataArray(0))
        rsAntennaGainTbl!AntennaKey = Val(gtInputDataArray(1))
        rsAntennaGainTbl!Gain = Mid(Format(Val(Mid(gtInputDataArray(2), 1, 5)), "0000.0;-000.0;0000.0"), 1, 6)
        'rsAntennaGainTbl!Frequency = Format(Val(gtInputDataArray(3)), "00000000.00000000")
        gdFrequency = Val(Trim(gtInputDataArray(3)))
        'If (gdFrequency <= 0) Then
        '    gtFrequency = Format(gdFrequency, "00000000.00000000; -000000.00000000; 00000000.00000000")
        '    MsgBox gtFrequency
        '    DoEvents
        'End If
        rsAntennaGainTbl!Frequency = Format(gdFrequency, "00000000.00000000;-0000000.00000000;00000000.00000000")
        rsAntennaGainTbl!TransMode = Trim(gtInputDataArray(4))
        rsAntennaGainTbl.Update
        CommitTrans
        DoEvents

AntennaGainTag:
    Loop
    Close (giIDFF)
    
    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    DoEvents

    Call WriteProcessLog

    rsAntennaGainTbl.Close
    Set rsAntennaGainTbl = Nothing
    rsProcessLog.Close
    Set rsProcessLog = Nothing
    dbJet.Close

    'gtCompactMsg = "Compacting Database  < " & gtInputFileName & " >"
    'Call CompactDB
    frmStatus.lblStatus.Caption = "Finished processing  <  " & gtInputFileName & "  >  data !"
    DoEvents

    Exit Sub
    
PopulateAntennaGainTableErr:
    
    gtMsg = "Error in PopulateAntennaGainTable" & vbCrLf
    gtMsg = gtMsg & "Error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    'Print #giBadDataFF, gtMsg
    MsgBox gtMsg

End Sub    '  PopulateAntennaGainTable

Sub PopulateAntennaTypeCodeTable()

    Dim gtInputDataArray

    Set dbJet = wsJet.OpenDatabase(gtOutputPathAndFilename)
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    Set rsAntTypCod = dbJet.OpenRecordset("IbfsAntTypCod", dbOpenTable)
    
    gtActionText = gtActionTextMsg & "Populate Antenna Type Code Table!"
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)

    gxBeginDateTime = Now
    glBeginSeconds = GetTickCount()
    
    giMaxFldCnt = 3
    gtTableName = "IbfsAntTypCod"
    gtInputFileName = "ant_type_code.dat"
    frmStatus.lblStatus.Caption = "Populating 'AntTypCod' table with  < " & gtInputFileName & " >  data !"
    frmStatus.lblStepCurrent.Caption = Str(giActionCounter)
    frmStatus.Refresh
    'Print #giBadDataFF, ""
    'Print #giBadDataFF, "=====>  " & gtInputFileName & "  <====="
    'Print #giBadDataFF, ""
    
    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh

    giIDFF = FreeFile
    Open (gtInputFilePath & gtInputFileName) For Input As giIDFF
    glLengthOfFile = LOF(giIDFF)

    frmStatus.lblFileSize.Caption = Format(glLengthOfFile, "###,###,###0")
    frmStatus.Refresh
    glRecCnt = 0
    glRecLen = 0

    Do While Not EOF(giIDFF)
        glRecCnt = glRecCnt + 1
        glRecLen = glRecLen + Len(gtInputData) + 2
        If ((glRecCnt Mod 100) = 0) Then
            frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
            gsPercentComplete = (glRecLen / glLengthOfFile) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
        End If
        Line Input #giIDFF, gtInputData
        gtInputData = Trim(gtInputData)
        
        If (Len(gtInputData) = 0) Then GoTo AntTypCodTag

        Call NewLineRepair

        gtInputDataArray = ""
        gtInputDataArray = Split(gtInputData, "|", giMaxFldCnt, 1)

        BeginTrans
        rsAntTypCod.AddNew
    '  Create Fields
        rsAntTypCod!AntennaTypeCode = Format(Val(gtInputDataArray(0)), "00")
        rsAntTypCod!Description = ""    '  Initialize "Memo" field
        rsAntTypCod!Description.AppendChunk gtInputDataArray(1)
            Call ConvertDate(Trim(gtInputDataArray(2)), gtOutputDate)
        rsAntTypCod!InactiveDate = gtOutputDate
        rsAntTypCod.Update
        CommitTrans
        DoEvents

AntTypCodTag:
    
    Loop
    Close (giIDFF)
    
    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    DoEvents

    Call WriteProcessLog

    rsAntTypCod.Close
    Set rsAntTypCod = Nothing
    rsProcessLog.Close
    Set rsProcessLog = Nothing
    dbJet.Close

    'gtCompactMsg = "Compacting Database  < " & gtInputFileName & " >"
    'Call CompactDB
    frmStatus.lblStatus.Caption = "Finished processing  <  " & gtInputFileName & "  >  data !"
    DoEvents

    Exit Sub
    
PopulateAntTypCodTableErr:
    
    gtMsg = "Error in PopulateAntennaTypeCodeTable" & vbCrLf
    gtMsg = gtMsg & "Error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    'Print #giBadDataFF, gtMsg
    MsgBox gtMsg

End Sub    '  PopulateAntennaTypeCodeTable

Sub PopulateFrequencyTable()
    
    Dim gtInputDataArray
    
    Set dbJet = wsJet.OpenDatabase(gtOutputPathAndFilename)
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    Set rsFrequencyTbl = dbJet.OpenRecordset("IbfsFrequency", dbOpenTable)

    gtActionText = gtActionTextMsg & "Populate Frequency Table!"
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)

    gxBeginDateTime = Now
    glBeginSeconds = GetTickCount()
    
    'giMaxFldCnt = 10
    giMaxFldCnt = 13
    
    gtTableName = "IbfsFrequency"
    gtInputFileName = "freq.dat"
    frmStatus.lblStatus.Caption = "Populating 'Frequency' table with  < " & gtInputFileName & " >  data !"
    frmStatus.lblStepCurrent.Caption = Str(giActionCounter)
    frmStatus.Refresh
    
    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh

    giIDFF = FreeFile
    Open (gtInputFilePath & gtInputFileName) For Input As giIDFF
    glLengthOfFile = LOF(giIDFF)

    frmStatus.lblFileSize.Caption = Format(glLengthOfFile, "###,###,###0")
    frmStatus.Refresh
    glRecCnt = 0
    glRecLen = 0

    Do While Not EOF(giIDFF)
        glRecCnt = glRecCnt + 1
        glRecLen = glRecLen + Len(gtInputData) + 2
        If ((glRecCnt Mod 100) = 0) Then
            frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
            gsPercentComplete = (glRecLen / glLengthOfFile) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
        End If
        Line Input #giIDFF, gtInputData
        gtInputData = Trim(gtInputData)
        
        If (Len(gtInputData) = 0) Then GoTo AntennaTag

        Call NewLineRepair

        gtInputDataArray = ""
        gtInputDataArray = Split(gtInputData, "|", giMaxFldCnt, 1)

        gtTransModeFix = Trim(gtInputDataArray(8))
        If (Len(gtTransModeFix) = 0) Then
            gtTransModeFix = "R"
        End If
        
        gtFrequencyLower = Format(Val(gtInputDataArray(6)), "00000000.00000000")
        gdFrequencyLower = Val(gtInputDataArray(6))
        If (gdFrequencyLower <= 0) Then
        End If
        
        gtFrequencyUpper = Format(Val(gtInputDataArray(7)), "00000000.00000000")
        gdFrequencyUpper = Val(gtInputDataArray(7))
        If (gtFrequencyUpper <= 0) Then
        End If

        If ((gdFrequencyLower >= 1525# And gdFrequencyLower <= 1610#) And (gdFrequencyUpper >= 1525# And gdFrequencyUpper <= 1610#)) Then
            gtTransModeFix = "R"
        End If
        
        If ((gdFrequencyLower >= 1610# And gdFrequencyLower <= 1660#) And (gdFrequencyUpper >= 1610# And gdFrequencyUpper <= 1660#)) Then
            gtTransModeFix = "T"
        End If
        
        If ((gdFrequencyLower >= 3700# And gdFrequencyLower <= 4200#) And (gdFrequencyUpper >= 3700# And gdFrequencyUpper <= 4200#)) Then
            gtTransModeFix = "R"
        End If
        
        If ((gdFrequencyLower >= 5925# And gdFrequencyLower <= 6425#) And (gdFrequencyUpper >= 5925# And gdFrequencyUpper <= 6425#)) Then
            gtTransModeFix = "T"
        End If
        
        If ((gdFrequencyLower >= 10700# And gdFrequencyLower <= 12200#) And (gdFrequencyUpper >= 10700# And gdFrequencyUpper <= 12200#)) Then
            gtTransModeFix = "R"
        End If
        
        If ((gdFrequencyLower >= 14000# And gdFrequencyLower <= 14500#) And (gdFrequencyUpper >= 14000# And gdFrequencyUpper <= 14500#)) Then
            gtTransModeFix = "T"
        End If

        BeginTrans
        rsFrequencyTbl.AddNew
        rsFrequencyTbl!FrequencyKey = Val(Trim(gtInputDataArray(0)))
        rsFrequencyTbl!AntennaKey = Val(gtInputDataArray(1))
        rsFrequencyTbl!PolarizationCode = Trim(gtInputDataArray(2))
            gdEirp = Val(gtInputDataArray(3))
        If (gdEirp >= 0) Then
            rsFrequencyTbl!Eirp = Format(gdEirp, "0000.0")
        Else
            If (Abs(gdEirp) >= 999) Then
                rsFrequencyTbl!Eirp = "-999.0"
            Else
                rsFrequencyTbl!Eirp = Format(gdEirp, "000.0")
            End If
        End If
            gdEirpDensity = Val(gtInputDataArray(4))
        If (gdEirpDensity >= 0) Then
            rsFrequencyTbl!EirpDensity = Format(gdEirpDensity, "0000.0")
        Else
            If (Abs(gdEirpDensity) >= 999) Then
                rsFrequencyTbl!EirpDensity = "-999.0"
            Else
                rsFrequencyTbl!EirpDensity = Format(gdEirpDensity, "000.0")
            End If
        End If
        rsFrequencyTbl!Emission = Trim(gtInputDataArray(5))
        rsFrequencyTbl!FrequencyLower = gtFrequencyLower
        rsFrequencyTbl!FrequencyUpper = gtFrequencyUpper
        rsFrequencyTbl!TransMode = Trim(gtInputDataArray(8))
        rsFrequencyTbl!TransModeFix = gtTransModeFix
        rsFrequencyTbl!Modulation = Trim(gtInputDataArray(9))
        'rsFrequencyTbl!FrequencyLowerDisplay = gtFrequencyLowerDisplay
        'rsFrequencyTbl!FrequencyUpperDisplay = gtFrequencyUpperDisplay
        'rsFrequencyTbl!UnitOfMeasure = gtUnitOfMeasure
        rsFrequencyTbl.Update
        CommitTrans
        DoEvents

AntennaTag:
    Loop
    
    Close (giIDFF)
    
    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    DoEvents

    Call WriteProcessLog

    rsFrequencyTbl.Close
    Set rsFrequencyTbl = Nothing
    rsProcessLog.Close
    Set rsProcessLog = Nothing
    dbJet.Close

    'gtCompactMsg = "Compacting Database  < " & gtInputFileName & " >"
    'Call CompactDB
    frmStatus.lblStatus.Caption = "Finished processing  <  " & gtInputFileName & "  >  data !"
    DoEvents

    Exit Sub
    
PopulateFrequencyTableErr:
    
    gtMsg = "Error in PopulateFrequencyTable" & vbCrLf
    gtMsg = gtMsg & "Error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    'Print #giBadDataFF, gtMsg
    MsgBox gtMsg

End Sub    '  PopulateFrequencyTable

Sub PopulateFreqCoordTable()

    Dim gtInputDataArray

    Set dbJet = wsJet.OpenDatabase(gtOutputPathAndFilename)
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    Set rsFreqCoordTbl = dbJet.OpenRecordset("IbfsFreqCoord", dbOpenTable)

    gtActionText = gtActionTextMsg & "Populate Freq Coord Table!"
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)

    gxBeginDateTime = Now
    glBeginSeconds = GetTickCount()
    
    'giMaxFldCnt = 14
    giMaxFldCnt = 15
    
    gtTableName = "IbfsFreqCoord"
    gtInputFileName = "freq_coord.dat"
    frmStatus.lblStatus.Caption = "Populating 'FreqCoord' table with  < " & gtInputFileName & " >  data !"
    frmStatus.lblStepCurrent.Caption = Str(giActionCounter)
    frmStatus.Refresh
    'Print #giBadDataFF, ""
    'Print #giBadDataFF, "=====>  " & gtInputFileName & "  <====="
    'Print #giBadDataFF, ""
    
    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh

    giIDFF = FreeFile
    Open (gtInputFilePath & gtInputFileName) For Input As giIDFF
    glLengthOfFile = LOF(giIDFF)

    frmStatus.lblFileSize.Caption = Format(glLengthOfFile, "###,###,###0")
    frmStatus.Refresh
    glRecCnt = 0
    glRecLen = 0

    Do While Not EOF(giIDFF)
        glRecCnt = glRecCnt + 1
        glRecLen = glRecLen + Len(gtInputData) + 2
        If ((glRecCnt Mod 100) = 0) Then
            frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
            gsPercentComplete = (glRecLen / glLengthOfFile) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
        End If
        Line Input #giIDFF, gtInputData
        gtInputData = Trim(gtInputData)
        
        If (Len(gtInputData) = 0) Then GoTo FreqCoordTag

        Call NewLineRepair

        gtInputDataArray = ""
        gtInputDataArray = Split(gtInputData, "|", giMaxFldCnt, 1)

        BeginTrans
        rsFreqCoordTbl.AddNew
        rsFreqCoordTbl!CoordKey = Val(Trim(gtInputDataArray(0)))
        rsFreqCoordTbl!AntennaKey = Val(gtInputDataArray(1))
        rsFreqCoordTbl!AzimuthEast = Format(Val(Trim(gtInputDataArray(2))), "0000.0; 000.0;0000.0")
        rsFreqCoordTbl!AzimuthWest = Format(Val(Trim(gtInputDataArray(3))), "0000.0; 000.0;0000.0")
        rsFreqCoordTbl!ElevationEast = Format(Val(Trim(gtInputDataArray(4))), "0000.0; 000.0;0000.0")
        rsFreqCoordTbl!ElevationWest = Format(Val(Trim(gtInputDataArray(5))), "0000.0; 000.0;0000.0")
        rsFreqCoordTbl!FreqLimitLow = Format(Val(Trim(gtInputDataArray(6))), "00000000.00000000")
        rsFreqCoordTbl!FreqLimitHigh = Format(Val(Trim(gtInputDataArray(7))), "00000000.00000000")
        If ((Val(Trim(gtInputDataArray(8))) <= 9999#) And (Val(Trim(gtInputDataArray(8))) >= -999#)) Then
            rsFreqCoordTbl!HorizMaxDensity = Format(Val(Trim(gtInputDataArray(8))), "0000.0;-000.0; ")
        End If
        rsFreqCoordTbl!SatArcEast = Format(Val(Trim(gtInputDataArray(9))), "0000.0")
        rsFreqCoordTbl!SatArcWest = Format(Val(Trim(gtInputDataArray(10))), "0000.0")
        rsFreqCoordTbl!SatHemiEast = Trim(gtInputDataArray(11))
        rsFreqCoordTbl!SatHemiWest = Trim(gtInputDataArray(12))
        rsFreqCoordTbl!SatOrbitType = Trim(gtInputDataArray(13))
        'rsFreqCoordTbl!TransMode = Trim(gtInputDataArray(14))
        rsFreqCoordTbl.Update
        CommitTrans
        DoEvents

FreqCoordTag:
    Loop
    Close (giIDFF)
    
    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    DoEvents

    Call WriteProcessLog

    rsFreqCoordTbl.Close
    Set rsFreqCoordTbl = Nothing
    rsProcessLog.Close
    Set rsProcessLog = Nothing
    dbJet.Close

    frmStatus.lblStatus.Caption = "Finished processing  <  " & gtInputFileName & "  >  data !"
    DoEvents

    Exit Sub
    
PopulateFreqCoordTableErr:
    
    gtMsg = "Error in PopulateFrequencyTable" & vbCrLf
    gtMsg = gtMsg & "Error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    'Print #giBadDataFF, gtMsg
    MsgBox gtMsg

End Sub    '  PopulateFreqCoordTable

Sub PopulateFrequencyFxTable()

    Dim gtInputDataArray

    Set dbJet = wsJet.OpenDatabase(gtOutputPathAndFilename)
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    Set rsFrequencyFxTbl = dbJet.OpenRecordset("IbfsFrequencyFx", dbOpenTable)
    
    gtActionText = gtActionTextMsg & "Populate Frequency FX Table!"
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    
    gxBeginDateTime = Now
    glBeginSeconds = GetTickCount()
    giMaxFldCnt = 8
    gtTableName = "IbfsFrequencyFx"
    gtInputFileName = "freq_fx.dat"
    frmStatus.lblStatus.Caption = "Populating 'FrequencyFx' table with  < " & gtInputFileName & " >  data !"
    frmStatus.lblStepCurrent.Caption = Str(giActionCounter)
    frmStatus.Refresh
    'Print #giBadDataFF, ""
    'Print #giBadDataFF, "=====>  " & gtInputFileName & "  <====="
    'Print #giBadDataFF, ""
    
    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh

    giIDFF = FreeFile
    Open (gtInputFilePath & gtInputFileName) For Input As giIDFF
    glLengthOfFile = LOF(giIDFF)

    frmStatus.lblFileSize.Caption = Format(glLengthOfFile, "###,###,###0")
    frmStatus.Refresh
    
    If (glRecCnt = 0) Then
        rsFrequencyFxTbl.Close
        Set rsFrequencyFxTbl = Nothing
        rsProcessLog.Close
        Set rsProcessLog = Nothing
        dbJet.Close
        frmStatus.lblStatus.Caption = "Finished processing  <  " & gtInputFileName & "  >  data !"
        DoEvents
        Exit Sub
    End If
    glRecCnt = 0
    glRecLen = 0
    
    Do While Not EOF(giIDFF)
        glRecCnt = glRecCnt + 1
        glRecLen = glRecLen + Len(gtInputData) + 2
        If ((glRecCnt Mod 100) = 0) Then
            frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
            gsPercentComplete = (glRecLen / glLengthOfFile) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
        End If
        Line Input #giIDFF, gtInputData
        gtInputData = Trim(gtInputData)
        
        If (Len(gtInputData) = 0) Then GoTo AntennaTag

        Call NewLineRepair

        gtInputDataArray = ""
        gtInputDataArray = Split(gtInputData, "|", giMaxFldCnt, 1)

        BeginTrans
        rsFrequencyFxTbl.AddNew
        rsFrequencyFxTbl!FrequencyKey = Val(Trim(gtInputDataArray(0)))
        rsFrequencyFxTbl!SiteKey = Trim(Trim(gtInputDataArray(1)))
        rsFrequencyFxTbl!PolarizationCode = Trim(gtInputDataArray(2))
            gdEirp = Val(gtInputDataArray(3))
        If (gdEirp >= 0) Then
            rsFrequencyFxTbl!Eirp = Format(gdEirp, "0000.0")
        Else
            rsFrequencyFxTbl!Eirp = Format(gdEirp, "000.0")
        End If
        rsFrequencyFxTbl!Emission = Trim(gtInputDataArray(4))
        rsFrequencyFxTbl!FrequencyLower = Format(Val(gtInputDataArray(5)), "00000000.00000000")
        rsFrequencyFxTbl!FrequencyUpper = Format(Val(gtInputDataArray(6)), "00000000.00000000")
        rsFrequencyFxTbl!TransMode = Trim(gtInputDataArray(7))
        rsFrequencyFxTbl.Update
        CommitTrans
        DoEvents

AntennaTag:
    Loop
    Close (giIDFF)
    
    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    DoEvents

    Call WriteProcessLog

    rsFrequencyFxTbl.Close
    Set rsFrequencyFxTbl = Nothing
    rsProcessLog.Close
    Set rsProcessLog = Nothing
    dbJet.Close

    frmStatus.lblStatus.Caption = "Finished processing  <  " & gtInputFileName & "  >  data !"
    DoEvents

    Exit Sub
    
PopulateFrequencyFxTableErr:
    
    gtMsg = "Error in PopulateFrequencyFxTable" & vbCrLf
    gtMsg = gtMsg & "Error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    'Print #giBadDataFF, gtMsg
    MsgBox gtMsg

End Sub    '  PopulateFrequencyFxFxTable

Sub PopulateNatureOfServiceTable()
    
    Dim gtInputDataArray

    Set dbJet = wsJet.OpenDatabase(gtOutputPathAndFilename)
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    Set rsNatOfSer = dbJet.OpenRecordset("IbfsNatureOfService", dbOpenTable)
    
    gtActionText = gtActionTextMsg & "Populate Nature Of Service Table!"
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    
    gxBeginDateTime = Now
    glBeginSeconds = GetTickCount()
    giMaxFldCnt = 2
    gtTableName = "NatureOfService"
    gtInputFileName = "nat_serv.dat"
    frmStatus.lblStatus.Caption = "Populating 'NatureOfService' table with  < " & gtInputFileName & " >  data !"
    frmStatus.lblStepCurrent.Caption = Str(giActionCounter)
    frmStatus.Refresh
    'Print #giBadDataFF, ""
    'Print #giBadDataFF, "=====>  " & gtInputFileName & "  <====="
    'Print #giBadDataFF, ""
    
    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh

    giIDFF = FreeFile
    Open (gtInputFilePath & gtInputFileName) For Input As giIDFF
    glLengthOfFile = LOF(giIDFF)

    frmStatus.lblFileSize.Caption = Format(glLengthOfFile, "###,###,###0")
    frmStatus.Refresh
    glRecCnt = 0
    glRecLen = 0

    Do While Not EOF(giIDFF)
        glRecCnt = glRecCnt + 1
        glRecLen = glRecLen + Len(gtInputData) + 2
        If ((glRecCnt Mod 100) = 0) Then
            frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
            gsPercentComplete = (glRecLen / glLengthOfFile) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
        End If
        Line Input #giIDFF, gtInputData
        gtInputData = Trim(gtInputData)
        
        If (Len(gtInputData) = 0) Then GoTo NatureOfServiceTag

        Call NewLineRepair

        gtInputDataArray = ""
        gtInputDataArray = Split(gtInputData, "|", giMaxFldCnt, 1)

        BeginTrans
        rsNatOfSer.AddNew
        rsNatOfSer!FilingKey = Val(gtInputDataArray(0))
        rsNatOfSer!NatureOfServiceCode = gtInputDataArray(1)
        rsNatOfSer.Update
        CommitTrans
        DoEvents

NatureOfServiceTag:
    Loop
    Close (giIDFF)
    
    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    DoEvents

    Call WriteProcessLog

    rsNatOfSer.Close
    Set rsNatOfSer = Nothing
    rsProcessLog.Close
    Set rsProcessLog = Nothing
    dbJet.Close

    'gtCompactMsg = "Compacting Database  < " & gtInputFileName & " >"
    'Call CompactDB
    frmStatus.lblStatus.Caption = "Finished processing  <  " & gtInputFileName & "  >  data !"
    DoEvents

    Exit Sub

PopulateNatureOfServiceTableErr:
    
    gtMsg = "Error in PopulateNatureOfServiceTable" & vbCrLf
    gtMsg = gtMsg & "Error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    'Print #giBadDataFF, gtMsg
    MsgBox gtMsg

End Sub    '  PopulateNatureOfServiceTable

Sub PopulateNatureOfServiceCodeTable()

    Dim gtInputDataArray

    Set dbJet = wsJet.OpenDatabase(gtOutputPathAndFilename)
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    Set rsNatOfSerCod = dbJet.OpenRecordset("IbfsNatureOfServiceCode", dbOpenTable)

    gtActionText = gtActionTextMsg & "Populate Nature Of Service Code Table!"
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)

    gxBeginDateTime = Now
    glBeginSeconds = GetTickCount()
    giMaxFldCnt = 3
    gtTableName = "NatureOfServiceCode"
    gtInputFileName = "nat_serv_code.dat"
    frmStatus.lblStatus.Caption = "Populating 'NatureOfServiceCode' table with  < " & gtInputFileName & " >  data !"
    frmStatus.lblStepCurrent.Caption = Str(giActionCounter)
    frmStatus.Refresh
    'Print #giBadDataFF, ""
    'Print #giBadDataFF, "=====>  " & gtInputFileName & "  <====="
    'Print #giBadDataFF, ""
    
    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh

    giIDFF = FreeFile
    Open (gtInputFilePath & gtInputFileName) For Input As giIDFF
    glLengthOfFile = LOF(giIDFF)

    frmStatus.lblFileSize.Caption = Format(glLengthOfFile, "###,###,###0")
    frmStatus.Refresh
    glRecCnt = 0
    glRecLen = 0

    Do While Not EOF(giIDFF)
        glRecCnt = glRecCnt + 1
        glRecLen = glRecLen + Len(gtInputData) + 2
        If ((glRecCnt Mod 100) = 0) Then
            frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
            gsPercentComplete = (glRecLen / glLengthOfFile) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
        End If
        Line Input #giIDFF, gtInputData
        gtInputData = Trim(gtInputData)
        
        If (Len(gtInputData) = 0) Then GoTo NatureOfServiceCodeTag

        Call NewLineRepair

        gtInputDataArray = ""
        gtInputDataArray = Split(gtInputData, "|", giMaxFldCnt, 1)

        Select Case Trim(gtInputDataArray(0))    '  NatureOfServiceCode
            Case Is = "AMSS" 'Aeronautical Mobile Satellite Service
                gtRadSvc = "JA"
            Case Is = "CC"   'Communications Satellite Service <IB - ??>
                gtRadSvc = "JB"
            Case Is = "DBS"  'Direct Broadcast Satellite Service
                gtRadSvc = "JC"
            Case Is = "DHFS" 'Direct to Home Fixed Satellite
                gtRadSvc = "JD"
            Case Is = "DAMS" 'Domestic Aeronautical Mobile Satellite Service
                gtRadSvc = "JE"
            Case Is = "DFSS" 'Domestic Fixed Satellite Service
                gtRadSvc = "JF"
            Case Is = "DLMS" 'Domestic Land Mobile Satellite Service
                gtRadSvc = "JG"
            Case Is = "DMMS" 'Domestic Maritime Mobile Satellite Service
                gtRadSvc = "JH"
            Case Is = "DMSS" 'Domestic Mobile Satellite Service
                gtRadSvc = "JI"
            Case Is = "EESS" 'Earth Exploration Satellite Service
                gtRadSvc = "JJ"
            Case Is = "FDBS" 'Feeder Link for DBS in Fixed Satellite Service
                gtRadSvc = "JK"
            Case Is = "IFLM" 'Feeder Link for Mobile Satellite Service
                gtRadSvc = "JL"
            Case Is = "FLW"  'Feeder Link for Wide Area Augmentation System
                gtRadSvc = "JM"
            Case Is = "FLFS" 'Feeder Link in Fixed Satellite Service
                gtRadSvc = "JN"
            Case Is = "FSS"  'Fixed Satellite Service
                gtRadSvc = "JO"
            Case Is = "PLAN" 'Fixed Satellite Service ORB 88 Allotment Plan
                gtRadSvc = "JP"
            Case Is = "IAMS" 'International Aeronautical Mobile Satellite Serv.
                gtRadSvc = "JQ"
            Case Is = "IC"   'International Control Service
                gtRadSvc = "JR"
            Case Is = "IFP"  'International Fixed Public Service
                gtRadSvc = "JS"
            Case Is = "IFSS" 'International Fixed Satellite Service
                gtRadSvc = "JT"
            Case Is = "IHFB" 'International HF Broadcasting Service
                gtRadSvc = "JU"
            Case Is = "ILMS" 'International Land Mobile Satellite Service
                gtRadSvc = "JV"
            Case Is = "IMMS" 'International Maritime Mobile Satellite Service
                gtRadSvc = "JW"
            Case Is = "IMSS" 'International Mobile Satellite Service
                gtRadSvc = "JX"
            Case Is = "IP"   'International Press Service
                gtRadSvc = "JY"
            Case Is = "MMS"  'Maritime Mobile Satellite Service
                gtRadSvc = "JZ"
            Case Is = "MSS"  'Mobile Satellite Service
                gtRadSvc = "KA"
            Case Is = "OTH"  'Other
                gtRadSvc = "KB"
            Case Is = "RDS"  'Radio Determination Satellite Service
                gtRadSvc = "KC"
            Case Is = "DARS" 'Satellite Digital Audio Radio Service
                gtRadSvc = "KD"
            Case Is = "DTH" '  Direct-to-Home Fixed Satellite Service
                gtRadSvc = "KE"
            Case Is = "ESV" '  Earth Stations on Vessels
                gtRadSvc = "KF"
            Case Is = "RNSS" '
                gtRadSvc = "K?"
            Case Is = "LATC" '
                gtRadSvc = "LA"    ' = LATC --
            Case Else
                gtRadSvc = "K?"
                MsgBox ("Unknown 'Nature Of Service Code' = " & gtInputDataArray(0))
                DoEvents
        End Select

        BeginTrans
        rsNatOfSerCod.AddNew
        rsNatOfSerCod!NatureOfServiceCode = gtInputDataArray(0)
        rsNatOfSerCod!Description = gtInputDataArray(1)
            Call ConvertDate(Trim(gtInputDataArray(2)), gtOutputDate)
        rsNatOfSerCod!InactiveDate = gtOutputDate
        rsNatOfSerCod!RadSvcCode = gtRadSvc
        rsNatOfSerCod.Update
        CommitTrans
        DoEvents

NatureOfServiceCodeTag:
    Loop
    Close (giIDFF)
    
    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    DoEvents

    Call WriteProcessLog

    rsNatOfSerCod.Close
    Set rsNatOfSerCod = Nothing
    rsProcessLog.Close
    Set rsProcessLog = Nothing
    dbJet.Close

    'gtCompactMsg = "Compacting Database  < " & gtInputFileName & " >"
    'Call CompactDB
    frmStatus.lblStatus.Caption = "Finished processing  <  " & gtInputFileName & "  >  data !"
    DoEvents

    Exit Sub

PopulateNatureOfServiceCodeTableErr:
    
    gtMsg = "Error in PopulateNatureOfServiceCodeTable" & vbCrLf
    gtMsg = gtMsg & "Error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    'Print #giBadDataFF, gtMsg
    MsgBox gtMsg

End Sub    '  PopulateNatureOfServiceCodeTable

Sub PopulateAzimuthTable()

    Dim gtInputDataArray

    Set dbJet = wsJet.OpenDatabase(gtOutputPathAndFilename)
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    Set rsAzimuth = dbJet.OpenRecordset("IbfsAzimuth", dbOpenTable)
    
    gtActionText = gtActionTextMsg & "Populate Azimuth Table!"
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)

    gxBeginDateTime = Now
    glBeginSeconds = GetTickCount()
    giMaxFldCnt = 3
    gtTableName = "Azimuth"
    gtInputFileName = "azimuth.dat"
    frmStatus.lblStatus.Caption = "Populating 'Azimuth' table with  < " & gtInputFileName & " >  data !"
    frmStatus.lblStepCurrent.Caption = Str(giActionCounter)
    frmStatus.Refresh
    'Print #giBadDataFF, ""
    'Print #giBadDataFF, "=====>  " & gtInputFileName & "  <====="
    'Print #giBadDataFF, ""
    
    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh

    giIDFF = FreeFile
    Open (gtInputFilePath & gtInputFileName) For Input As giIDFF
    glLengthOfFile = LOF(giIDFF)
    
    If (glLengthOfFile <= 0) Then GoTo ExitAzimuth
    
'MsgBox "pause"
'DoEvents
    frmStatus.lblFileSize.Caption = Format(glLengthOfFile, "###,###,###0")
    frmStatus.Refresh
    glRecCnt = 0
    glRecLen = 0

    Do While Not EOF(giIDFF)
        glRecCnt = glRecCnt + 1
        glRecLen = glRecLen + Len(gtInputData) + 2
        If ((glRecCnt Mod 100) = 0) Then
            frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
            gsPercentComplete = (glRecLen / glLengthOfFile) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
        End If
        Line Input #giIDFF, gtInputData
        gtInputData = Trim(gtInputData)
        
        If (Len(gtInputData) = 0) Then GoTo AzimuthTag

        Call NewLineRepair

        gtInputDataArray = ""
        gtInputDataArray = Split(gtInputData, "|", giMaxFldCnt, 1)

        BeginTrans
        rsAzimuth.AddNew
        rsAzimuth!AzimuthKey = Val(gtInputDataArray(0))
        rsAzimuth!AntennaKey = Val(gtInputDataArray(1))
        rsAzimuth!Azimuth = Val(gtInputDataArray(2))
        rsAzimuth.Update
        CommitTrans
        DoEvents

AzimuthTag:
    Loop
    Close (giIDFF)
    
    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    DoEvents

ExitAzimuth:

    Call WriteProcessLog

    rsAzimuth.Close
    Set rsAzimuth = Nothing
    rsProcessLog.Close
    Set rsProcessLog = Nothing
    dbJet.Close

    'gtCompactMsg = "Compacting Database  < " & gtInputFileName & " >"
    'Call CompactDB
    frmStatus.lblStatus.Caption = "Finished processing  <  " & gtInputFileName & "  >  data !"
    DoEvents

    Exit Sub
    
PopulateAzimuthTableErr:
    
    gtMsg = "Error in PopulateAzimuth" & vbCrLf
    gtMsg = gtMsg & "Error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    'Print #giBadDataFF, gtMsg
    MsgBox gtMsg

End Sub    '  PopulateAzimuthTable

Sub PopulateClassOfStationCodeTable()

    Dim gtInputDataArray

    Set dbJet = wsJet.OpenDatabase(gtOutputPathAndFilename)
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    Set rsClassOfStaCod = dbJet.OpenRecordset("IbfsClassOfStationCode", dbOpenTable)

    gtActionText = gtActionTextMsg & "APopulate Class Of Station Code Table!"
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)

    gxBeginDateTime = Now
    glBeginSeconds = GetTickCount()
    giMaxFldCnt = 3
    gtTableName = "ClassOfStationCode"
    gtInputFileName = "class.dat"
    frmStatus.lblStatus.Caption = "Populating 'NatureOfServiceCode' table with  < " & gtInputFileName & " >  data !"
    frmStatus.lblStepCurrent.Caption = Str(giActionCounter)
    frmStatus.Refresh
    'Print #giBadDataFF, ""
    'Print #giBadDataFF, "=====>  " & gtInputFileName & "  <====="
    'Print #giBadDataFF, ""
    
    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh

    giIDFF = FreeFile
    Open (gtInputFilePath & gtInputFileName) For Input As giIDFF
    glLengthOfFile = LOF(giIDFF)

    frmStatus.lblFileSize.Caption = Format(glLengthOfFile, "###,###,###0")
    frmStatus.Refresh
    glRecCnt = 0
    glRecLen = 0

    Do While Not EOF(giIDFF)
        glRecCnt = glRecCnt + 1
        glRecLen = glRecLen + Len(gtInputData) + 2
        If ((glRecCnt Mod 100) = 0) Then
            frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
            gsPercentComplete = (glRecLen / glLengthOfFile) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
        End If
        Line Input #giIDFF, gtInputData
        gtInputData = Trim(gtInputData)
        
        If (Len(gtInputData) = 0) Then GoTo NatureOfServiceCodeTag

        Call NewLineRepair

        gtInputDataArray = ""
        gtInputDataArray = Split(gtInputData, "|", giMaxFldCnt, 1)

        BeginTrans
        rsClassOfStaCod.AddNew
        rsClassOfStaCod!ClassOfStationCode = gtInputDataArray(0)
        rsClassOfStaCod!Description = gtInputDataArray(1)
            Call ConvertDate(Trim(gtInputDataArray(2)), gtOutputDate)
        rsClassOfStaCod!InactiveDate = gtOutputDate
        rsClassOfStaCod.Update
        CommitTrans
        DoEvents

NatureOfServiceCodeTag:
    Loop
    Close (giIDFF)
    
    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    DoEvents

    Call WriteProcessLog

    rsClassOfStaCod.Close
    Set rsClassOfStaCod = Nothing
    rsProcessLog.Close
    Set rsProcessLog = Nothing
    dbJet.Close

    frmStatus.lblStatus.Caption = "Finished processing  <  " & gtInputFileName & "  >  data !"
    DoEvents

    Exit Sub

PopulateClassOfStationCodeTableErr:
    
    gtMsg = "Error in PopulateClassOfStationCode" & vbCrLf
    gtMsg = gtMsg & "Error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    'Print #giBadDataFF, gtMsg
    MsgBox gtMsg

End Sub    '  PopulateClassOfStationCodeTable

Sub PopulatePolarizationCodeTable()

    Dim gtInputDataArray

    Set dbJet = wsJet.OpenDatabase(gtOutputPathAndFilename)
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    Set rsPolarCode = dbJet.OpenRecordset("IbfsPolarCode", dbOpenTable)
    
    gtActionText = gtActionTextMsg & "Populate Polarization Code Table!"
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    
    gxBeginDateTime = Now
    glBeginSeconds = GetTickCount()
    giMaxFldCnt = 3
    gtTableName = "PolarizationCode"
    gtInputFileName = "polar.dat"
    frmStatus.lblStatus.Caption = "Populating 'NatureOfServiceCode' table with  < " & gtInputFileName & " >  data !"
    frmStatus.lblStepCurrent.Caption = Str(giActionCounter)
    frmStatus.Refresh
    'Print #giBadDataFF, ""
    'Print #giBadDataFF, "=====>  " & gtInputFileName & "  <====="
    'Print #giBadDataFF, ""
    
    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh

    giIDFF = FreeFile
    Open (gtInputFilePath & gtInputFileName) For Input As giIDFF
    glLengthOfFile = LOF(giIDFF)

    frmStatus.lblFileSize.Caption = Format(glLengthOfFile, "###,###,###0")
    frmStatus.Refresh
    glRecCnt = 0
    glRecLen = 0

    Do While Not EOF(giIDFF)
        glRecCnt = glRecCnt + 1
        glRecLen = glRecLen + Len(gtInputData) + 2
        If ((glRecCnt Mod 100) = 0) Then
            frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
            gsPercentComplete = (glRecLen / glLengthOfFile) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
        End If
        Line Input #giIDFF, gtInputData
        gtInputData = Trim(gtInputData)
        
        If (Len(gtInputData) = 0) Then GoTo PolarizationCodeTag

        Call NewLineRepair

        gtInputDataArray = ""
        gtInputDataArray = Split(gtInputData, "|", giMaxFldCnt, 1)

        BeginTrans
        rsPolarCode.AddNew
        rsPolarCode!PolarizationCode = gtInputDataArray(0)
        rsPolarCode!PolarizationType = gtInputDataArray(1)
            Call ConvertDate(Trim(gtInputDataArray(2)), gtOutputDate)
        rsPolarCode!InactiveDate = gtOutputDate
        rsPolarCode.Update
        CommitTrans
        DoEvents

PolarizationCodeTag:
    Loop
    Close (giIDFF)
    
    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    DoEvents

    Call WriteProcessLog

    rsPolarCode.Close
    Set rsPolarCode = Nothing
    rsProcessLog.Close
    Set rsProcessLog = Nothing
    dbJet.Close

    'gtCompactMsg = "Compacting Database  < " & gtInputFileName & " >"
    'Call CompactDB
    frmStatus.lblStatus.Caption = "Finished processing  <  " & gtInputFileName & "  >  data !"
    DoEvents

    Exit Sub

PopulatePolarizationCodeTableErr:
    
    gtMsg = "Error in PopulatePolarizationCode" & vbCrLf
    gtMsg = gtMsg & "Error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    'Print #giBadDataFF, gtMsg
    MsgBox gtMsg

End Sub    '  PopulatePolarizationCodeTable

Sub PopulatePtCommTable()

    Dim gtInputDataArray

    Set dbJet = wsJet.OpenDatabase(gtOutputPathAndFilename)
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    Set rsPtCommTbl = dbJet.OpenRecordset("IbfsPtComm", dbOpenTable)
    
    gtActionText = gtActionTextMsg & "Populate Pt CommT able!"
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    
    gxBeginDateTime = Now
    glBeginSeconds = GetTickCount()
    giMaxFldCnt = 3
    gtTableName = "IbfsPtComm"
    gtInputFileName = "ptcomm.dat"
    frmStatus.lblStatus.Caption = "Populating 'PtComm' table with  < " & gtInputFileName & " >  data !"
    frmStatus.lblStepCurrent.Caption = Str(giActionCounter)
    frmStatus.Refresh
    'Print #giBadDataFF, ""
    'Print #giBadDataFF, "=====>  " & gtInputFileName & "  <====="
    'Print #giBadDataFF, ""
    
    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh

    glLengthOfFile = 0
    giIDFF = FreeFile
    Open (gtInputFilePath & gtInputFileName) For Input As giIDFF
    glLengthOfFile = LOF(giIDFF)

    frmStatus.lblFileSize.Caption = Format(glLengthOfFile, "###,###,###0")
    frmStatus.Refresh
    glRecCnt = 0
    glRecLen = 0

    Do While Not EOF(giIDFF)
        glRecCnt = glRecCnt + 1
        glRecLen = glRecLen + Len(gtInputData) + 2
        If ((glRecCnt Mod 100) = 0) Then
            frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
            gsPercentComplete = (glRecLen / glLengthOfFile) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
        End If
        Line Input #giIDFF, gtInputData
        gtInputData = Trim(gtInputData)
        
        If (Len(gtInputData) = 0) Then GoTo PtCommTag

        Call NewLineRepair

        gtInputDataArray = ""
        gtInputDataArray = Split(gtInputData, "|", giMaxFldCnt, 1)

        BeginTrans
        rsPtCommTbl.AddNew
        rsPtCommTbl!PtCommKey = Val(gtInputDataArray(0))
        rsPtCommTbl!SiteKey = Val(gtInputDataArray(1))
        rsPtCommTbl!SpaceStationKey = Val(gtInputDataArray(2))
        rsPtCommTbl.Update
        CommitTrans
        DoEvents

PtCommTag:
    Loop
    Close (giIDFF)
    
    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    DoEvents

    Call WriteProcessLog

    rsPtCommTbl.Close
    Set rsPtCommTbl = Nothing
    rsProcessLog.Close
    Set rsProcessLog = Nothing
    dbJet.Close

    'gtCompactMsg = "Compacting Database  < " & gtInputFileName & " >"
    'Call CompactDB
    frmStatus.lblStatus.Caption = "Finished processing  <  " & gtInputFileName & "  >  data !"
    DoEvents

    Exit Sub
    
PopulatePtCommTableErr:
    
    gtMsg = "Error in PopulatePtCommTable" & vbCrLf
    gtMsg = gtMsg & "Error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    'Print #giBadDataFF, gtMsg
    MsgBox gtMsg

End Sub    '  PopulatePtCommTable

Sub PopulatePtCommFxTable()

    Dim gtInputDataArray

    Set dbJet = wsJet.OpenDatabase(gtOutputPathAndFilename)
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    Set rsPtCommFxTbl = dbJet.OpenRecordset("IbfsPtCommFx", dbOpenTable)

    gtActionText = gtActionTextMsg & "Populate Pt Comm FX Table!"
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)

    gxBeginDateTime = Now
    glBeginSeconds = GetTickCount()
    giMaxFldCnt = 4
    gtTableName = "IbfsPtCommFx"
    gtInputFileName = "ptcomm_fx.dat"
    frmStatus.lblStatus.Caption = "Populating 'PtCommFx' table with  < " & gtInputFileName & " >  data !"
    frmStatus.lblStepCurrent.Caption = Str(giActionCounter)
    frmStatus.Refresh
    'Print #giBadDataFF, ""
    'Print #giBadDataFF, "=====>  " & gtInputFileName & "  <====="
    'Print #giBadDataFF, ""
    
    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh

    giIDFF = FreeFile
    Open (gtInputFilePath & gtInputFileName) For Input As giIDFF
    glLengthOfFile = LOF(giIDFF)

    frmStatus.lblFileSize.Caption = Format(glLengthOfFile, "###,###,###0")
    frmStatus.Refresh
    glRecCnt = 0
    glRecLen = 0

    Do While Not EOF(giIDFF)
        glRecCnt = glRecCnt + 1
        glRecLen = glRecLen + Len(gtInputData) + 2
        If ((glRecCnt Mod 100) = 0) Then
            frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
            gsPercentComplete = (glRecLen / glLengthOfFile) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
        End If
        Line Input #giIDFF, gtInputData
        gtInputData = Trim(gtInputData)
        
        If (Len(gtInputData) = 0) Then GoTo PtCommFxTag

        Call NewLineRepair

        gtInputDataArray = ""
        gtInputDataArray = Split(gtInputData, "|", giMaxFldCnt, 1)

        BeginTrans
        rsPtCommFxTbl.AddNew
        rsPtCommFxTbl!PtCommKey = Val(gtInputDataArray(0))
        rsPtCommFxTbl!SiteKey = Val(gtInputDataArray(1))
        rsPtCommFxTbl!Location = ""    '  Initialize "Memo" field
        rsPtCommFxTbl!Location.AppendChunk Trim(gtInputDataArray(2))
        rsPtCommFxTbl!Distance = Val(gtInputDataArray(3))
        rsPtCommFxTbl.Update
        CommitTrans
        DoEvents

PtCommFxTag:
    Loop
    Close (giIDFF)
    
    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    DoEvents

    Call WriteProcessLog

    rsPtCommFxTbl.Close
    Set rsPtCommFxTbl = Nothing
    rsProcessLog.Close
    Set rsProcessLog = Nothing
    dbJet.Close

    'gtCompactMsg = "Compacting Database  < " & gtInputFileName & " >"
    'Call CompactDB
    frmStatus.lblStatus.Caption = "Finished processing  <  " & gtInputFileName & "  >  data !"
    DoEvents

    Exit Sub
    
PopulatePtCommFxTableErr:
    
    gtMsg = "Error in PopulatePtCommFxTable" & vbCrLf
    gtMsg = gtMsg & "Error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    'Print #giBadDataFF, gtMsg
    MsgBox gtMsg

End Sub    '  PopulatePtCommFxTable

Sub PopulatePurposeTable()

    Dim gtInputDataArray

    Set dbJet = wsJet.OpenDatabase(gtOutputPathAndFilename)
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    Set rsPurposeTbl = dbJet.OpenRecordset("IbfsPurpose", dbOpenTable)

    gtActionText = gtActionTextMsg & "Populate Purpose Table!"
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)

    gxBeginDateTime = Now
    glBeginSeconds = GetTickCount()
    giMaxFldCnt = 2
    gtTableName = "IbfsPurpose"
    gtInputFileName = "purpose.dat"
    frmStatus.lblStatus.Caption = "Populating 'Purpose' table with  < " & gtInputFileName & " >  data !"
    frmStatus.lblStepCurrent.Caption = Str(giActionCounter)
    frmStatus.Refresh
    'Print #giBadDataFF, ""
    'Print #giBadDataFF, "=====>  " & gtInputFileName & "  <====="
    'Print #giBadDataFF, ""
    
    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh

    giIDFF = FreeFile
    Open (gtInputFilePath & gtInputFileName) For Input As giIDFF
    glLengthOfFile = LOF(giIDFF)

    frmStatus.lblFileSize.Caption = Format(glLengthOfFile, "###,###,###0")
    frmStatus.Refresh
    glRecCnt = 0
    glRecLen = 0

    Do While Not EOF(giIDFF)
        glRecCnt = glRecCnt + 1
        glRecLen = glRecLen + Len(gtInputData) + 2
        If ((glRecCnt Mod 100) = 0) Then
            frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
            gsPercentComplete = (glRecLen / glLengthOfFile) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
        End If
        Line Input #giIDFF, gtInputData
        gtInputData = Trim(gtInputData)
        
        If (Len(gtInputData) = 0) Then GoTo PurposeTag

        Call NewLineRepair

        gtInputDataArray = ""
        gtInputDataArray = Split(gtInputData, "|", giMaxFldCnt, 1)

        BeginTrans
        rsPurposeTbl.AddNew
        rsPurposeTbl!FilingKey = Val(gtInputDataArray(0))
        rsPurposeTbl!PurposeCode = ""    '  Initialize "Memo" field
        rsPurposeTbl!PurposeCode.AppendChunk Trim(gtInputDataArray(1))
        rsPurposeTbl.Update
        CommitTrans
        DoEvents

PurposeTag:
    Loop
    Close (giIDFF)
    
    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    DoEvents

    Call WriteProcessLog

    rsPurposeTbl.Close
    Set rsPurposeTbl = Nothing
    rsProcessLog.Close
    Set rsProcessLog = Nothing
    dbJet.Close

    'gtCompactMsg = "Compacting Database  < " & gtInputFileName & " >"
    'Call CompactDB
    frmStatus.lblStatus.Caption = "Finished processing  <  " & gtInputFileName & "  >  data !"
    DoEvents

    Exit Sub
    
PopulatePurposeTableErr:
    
    gtMsg = "Error in PopulatePurposeTable" & vbCrLf
    gtMsg = gtMsg & "Error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    'Print #giBadDataFF, gtMsg
    MsgBox gtMsg

End Sub    '  PopulatePurposeTable

Sub PopulateSpaceStationTable()

    Dim gtInputDataArray

    Set dbJet = wsJet.OpenDatabase(gtOutputPathAndFilename)
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    Set rsSpaceStationTbl = dbJet.OpenRecordset("IbfsSpaceStation", dbOpenTable)
    
    gtActionText = gtActionTextMsg & "Populate Space Station Table!"
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    
    gxBeginDateTime = Now
    glBeginSeconds = GetTickCount()
    giMaxFldCnt = 7
    gtTableName = "IbfsSpaceStation"
    gtInputFileName = "space_sta.dat"
    frmStatus.lblStatus.Caption = "Populating 'SpaceStation' table with  < " & gtInputFileName & " >  data !"
    frmStatus.lblStepCurrent.Caption = Str(giActionCounter)
    frmStatus.Refresh
    'Print #giBadDataFF, ""
    'Print #giBadDataFF, "=====>  " & gtInputFileName & "  <====="
    'Print #giBadDataFF, ""
    
    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh

    giIDFF = FreeFile
    Open (gtInputFilePath & gtInputFileName) For Input As giIDFF
    glLengthOfFile = LOF(giIDFF)

    frmStatus.lblFileSize.Caption = Format(glLengthOfFile, "###,###,###0")
    frmStatus.Refresh
    glRecCnt = 0
    glRecLen = 0

    Do While Not EOF(giIDFF)
        glRecCnt = glRecCnt + 1
        glRecLen = glRecLen + Len(gtInputData) + 2
        If ((glRecCnt Mod 100) = 0) Then
            frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
            gsPercentComplete = (glRecLen / glLengthOfFile) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
        End If
        Line Input #giIDFF, gtInputData
        gtInputData = Trim(gtInputData)
        
        If (Len(gtInputData) = 0) Then GoTo SpaceStationTag

        Call NewLineRepair

        gtInputDataArray = ""
        gtInputDataArray = Split(gtInputData, "|", giMaxFldCnt, 1)

        BeginTrans
        rsSpaceStationTbl.AddNew
        rsSpaceStationTbl!SpaceStationKey = Val(Trim(gtInputDataArray(0)))
        rsSpaceStationTbl!UsName = Trim(Trim(gtInputDataArray(1)))
        rsSpaceStationTbl!ItuName = Trim(gtInputDataArray(2))
        rsSpaceStationTbl!OrbitLocation = Trim(gtInputDataArray(3))
        rsSpaceStationTbl!Verbose = ""    '  Initialize "Memo" field
        rsSpaceStationTbl!Verbose.AppendChunk Trim(gtInputDataArray(4))
            Call ConvertDate(Trim(gtInputDataArray(5)), gtOutputDate)
        rsSpaceStationTbl!InactiveDate = gtOutputDate
        rsSpaceStationTbl!LongHemi = Trim(gtInputDataArray(6))
        rsSpaceStationTbl.Update
        CommitTrans
        DoEvents

SpaceStationTag:
    Loop
    Close (giIDFF)
    
    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    DoEvents

    Call WriteProcessLog

    rsSpaceStationTbl.Close
    Set rsSpaceStationTbl = Nothing
    rsProcessLog.Close
    Set rsProcessLog = Nothing
    dbJet.Close

    'gtCompactMsg = "Compacting Database  < " & gtInputFileName & " >"
    'Call CompactDB
    frmStatus.lblStatus.Caption = "Finished processing  <  " & gtInputFileName & "  >  data !"
    DoEvents

    Exit Sub
    
PopulateSpaceStationTableErr:
    
    gtMsg = "Error in PopulateSpaceStationTable" & vbCrLf
    gtMsg = gtMsg & "Error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    'Print #giBadDataFF, gtMsg
    MsgBox gtMsg

End Sub    '  PopulateSpaceStationTable

Sub PopulateSpaceStationStaTable()

    Dim gtInputDataArray

    Set dbJet = wsJet.OpenDatabase(gtOutputPathAndFilename)
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    Set rsSpaceStationStaTbl = dbJet.OpenRecordset("IbfsSpaceStationSta", dbOpenTable)
    
    gtActionText = gtActionTextMsg & "Populate Space Station STA Table!"
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    
    gxBeginDateTime = Now
    glBeginSeconds = GetTickCount()
    giMaxFldCnt = 4
    gtTableName = "IbfsSpaceStationSta"
    gtInputFileName = "space_sta_sta.dat"
    frmStatus.lblStatus.Caption = "Populating 'SpaceStationSta' table with  < " & gtInputFileName & " >  data !"
    frmStatus.lblStepCurrent.Caption = Str(giActionCounter)
    frmStatus.Refresh
    'Print #giBadDataFF, ""
    'Print #giBadDataFF, "=====>  " & gtInputFileName & "  <====="
    'Print #giBadDataFF, ""

    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh

    giIDFF = FreeFile
    Open (gtInputFilePath & gtInputFileName) For Input As giIDFF
    glLengthOfFile = LOF(giIDFF)

    frmStatus.lblFileSize.Caption = Format(glLengthOfFile, "###,###,###0")
    frmStatus.Refresh
    glRecCnt = 0
    glRecLen = 0

    Do While Not EOF(giIDFF)
        glRecCnt = glRecCnt + 1
        glRecLen = glRecLen + Len(gtInputData) + 2
        If ((glRecCnt Mod 100) = 0) Then
            frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
            gsPercentComplete = (glRecLen / glLengthOfFile) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
        End If
        Line Input #giIDFF, gtInputData
        gtInputData = Trim(gtInputData)
        
        If (Len(gtInputData) = 0) Then GoTo SpaceStationStaTag

        Call NewLineRepair

        gtInputDataArray = ""
        gtInputDataArray = Split(gtInputData, "|", giMaxFldCnt, 1)

        BeginTrans
        rsSpaceStationStaTbl.AddNew
        rsSpaceStationStaTbl!FilingKey = Val(Trim(gtInputDataArray(0)))
        rsSpaceStationStaTbl!TypeStaCode = Trim(Trim(gtInputDataArray(1)))
            Call ConvertDate(Trim(gtInputDataArray(2)), gtOutputDate)
        rsSpaceStationStaTbl!RequestedDate = gtOutputDate
        rsSpaceStationStaTbl!RequestedLocation = ""    '  Initialize "Memo" field
        rsSpaceStationStaTbl!RequestedLocation.AppendChunk Trim(gtInputDataArray(3))
        rsSpaceStationStaTbl.Update
        CommitTrans
        DoEvents

SpaceStationStaTag:
    
    Loop
    Close (giIDFF)
    
    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    DoEvents

    Call WriteProcessLog

    rsSpaceStationStaTbl.Close
    Set rsSpaceStationStaTbl = Nothing
    rsProcessLog.Close
    Set rsProcessLog = Nothing
    dbJet.Close

    'gtCompactMsg = "Compacting Database  < " & gtInputFileName & " >"
    'Call CompactDB
    frmStatus.lblStatus.Caption = "Finished processing  <  " & gtInputFileName & "  >  data !"
    DoEvents

    Exit Sub
    
PopulateSpaceStationStaTableErr:
    
    gtMsg = "Error in PopulateSpaceStationStaTable" & vbCrLf
    gtMsg = gtMsg & "Error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    'Print #giBadDataFF, gtMsg
    MsgBox gtMsg

End Sub    '  PopulateSpaceStationStaTable

Sub PopulateStatusCodeTable()

    Dim gtInputDataArray

    Set dbJet = wsJet.OpenDatabase(gtOutputPathAndFilename)
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    Set rsStatusCodeTbl = dbJet.OpenRecordset("IbfsStatusCode", dbOpenTable)
    
    gtActionText = gtActionTextMsg & "Populate Status Code Table!"
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    
    gxBeginDateTime = Now
    glBeginSeconds = GetTickCount()
    giMaxFldCnt = 4
    gtTableName = "IbfsStatusCode"
    gtInputFileName = "status_code.dat"
    frmStatus.lblStatus.Caption = "Populating 'StatusCode' table with  < " & gtInputFileName & " >  data !"
    frmStatus.lblStepCurrent.Caption = Str(giActionCounter)
    frmStatus.Refresh
    'Print #giBadDataFF, ""
    'Print #giBadDataFF, "=====>  " & gtInputFileName & "  <====="
    'Print #giBadDataFF, ""
    
    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh

    giIDFF = FreeFile
    Open (gtInputFilePath & gtInputFileName) For Input As giIDFF
    glLengthOfFile = LOF(giIDFF)

    frmStatus.lblFileSize.Caption = Format(glLengthOfFile, "###,###,###0")
    frmStatus.Refresh
    glRecCnt = 0
    glRecLen = 0

    Do While Not EOF(giIDFF)
        glRecCnt = glRecCnt + 1
        glRecLen = glRecLen + Len(gtInputData) + 2
        If ((glRecCnt Mod 100) = 0) Then
            frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
            gsPercentComplete = (glRecLen / glLengthOfFile) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
        End If
        Line Input #giIDFF, gtInputData
        gtInputData = Trim(gtInputData)
        
        If (Len(gtInputData) = 0) Then GoTo StatusCodeTag

        Call NewLineRepair

        gtInputDataArray = ""
        gtInputDataArray = Split(gtInputData, "|", giMaxFldCnt, 1)

        BeginTrans
        rsStatusCodeTbl.AddNew
        rsStatusCodeTbl!StatusCode = Trim(gtInputDataArray(0))
        rsStatusCodeTbl!StatusText = ""    '  Initialize "Memo" field
        rsStatusCodeTbl!StatusText.AppendChunk Trim(gtInputDataArray(1))
        rsStatusCodeTbl!InternalSw = Trim(gtInputDataArray(2))
            Call ConvertDate(Trim(gtInputDataArray(3)), gtOutputDate)
        rsStatusCodeTbl!InactiveDate = gtOutputDate
        
        rsStatusCodeTbl.Update
        CommitTrans
        DoEvents

StatusCodeTag:
    Loop
    Close (giIDFF)
    
    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    DoEvents

    Call WriteProcessLog

    rsStatusCodeTbl.Close
    Set rsStatusCodeTbl = Nothing
    rsProcessLog.Close
    Set rsProcessLog = Nothing
    dbJet.Close

    'gtCompactMsg = "Compacting Database  < " & gtInputFileName & " >"
    'Call CompactDB
    frmStatus.lblStatus.Caption = "Finished processing  <  " & gtInputFileName & "  >  data !"
    DoEvents

    Exit Sub
    
PopulateStatusCodeTableErr:
    
    gtMsg = "Error in PopulateStatusCodeTable" & vbCrLf
    gtMsg = gtMsg & "Error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    'Print #giBadDataFF, gtMsg
    MsgBox gtMsg

End Sub    '  PopulateStatusCodeTable

Sub WriteStatus()
    
    DoEvents
    gxFinishDateTime = Now
    glFinishSeconds = GetTickCount()
    BeginTrans
    rsProcessLog.AddNew
    rsProcessLog!SequenceKey = Format(giActionCounter, "0#")
    rsProcessLog!Action = gtActionText
    rsProcessLog!TimeStart = gxBeginDateTime
    rsProcessLog!TimeFinish = gxFinishDateTime
    rsProcessLog!TimeTotalSec = Format((glFinishSeconds - glBeginSeconds), "###,##0.0")
    rsProcessLog!TimeTotalHours = Format(((glFinishSeconds - glBeginSeconds) / 3600), "###,##0.0")
    rsProcessLog!TotalRecords = glRecCnt
    rsProcessLog.Update
    CommitTrans
    DoEvents

End Sub


Sub POBoxDrawer(gtTmpStreetIn, gtTmpStreetOut, gtTmpPOBOut, giTmpFlag)

    'On Error GoTo POBoxDrawerErr
            
    For giN = 1 To giPocCnt
        giPOPos = InStr(1, Trim(gtTmpStreetIn), Trim(gtPOString(giN)), 1)
        If (giPOPos >= 1) Then Exit For
    Next giN
    Select Case giPOPos
        Case Is = 0    '  String not found
            giTmpFlag = 0
        Case Is = 1
            giTmpFlag = 1
            gtTmpStreet = Trim(Mid(gtTmpStreetIn, (Len(Trim(gtPOString(giN))) + 1)))
            gtTmpPOCode = gtPOCode(giN)
            giLenTmpStreet = Len(gtTmpStreet)
            For giX = 1 To giLenTmpStreet
                If (Mid(gtTmpStreet, giX, 1) = " " Or Mid(gtTmpStreet, giX, 1) = "-") Then Exit For
            Next giX
            gtTmpPOBOut = gtTmpPOCode & " " & Trim(Mid(gtTmpStreet, 1, (giX - 1)))
            If (giX < giLenTmpStreet) Then
                gtTmpStreetOut = Trim(Mid(gtTmpStreet, (giX + 1)))
            Else
                gtTmpStreetOut = ""
            End If
        Case Is > 1
            giTmpFlag = 1
            gtTmpPOCode = gtPOCode(giN)
            gtTmpPOBOut = gtTmpPOCode & " " & Trim(Mid(gtTmpStreetIn, (giPOPos + Len(Trim(gtPOString(giN))))))
            gtTmpStreetOut = Trim(Mid(gtTmpStreetIn, 1, (giPOPos - 1)))
    End Select
    
    Exit Sub
    
POBoxDrawerErr:

    gtMsg = "Error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    gtMsg = gtMsg & gtErrMsg & vbCrLf
    gtMsg = gtMsg & "Call Sign: " & gtDataArray(1, giSegmCnt) & vbCrLf
    gtMsg = gtMsg & "Field Numb: " & Str(giX) & vbCrLf
    gtMsg = gtMsg & "Str Length: " & Str(Len(gtDataArray(giX, giSegmCnt))) & "  characters !" & vbCrLf
    gtMsg = gtMsg & gtDataArray(giX, giSegmCnt)
    'Print #giBadDataFF, gtMsg
    MsgBox gtMsg

End Sub    '  POBoxDrawer

Sub RuralRouteTest(gtTmpStreet, RuralRouteFlag%)

    RuralRouteFlag% = 0
    Erase gtNotPOBString
    gtNotPOBString(1) = "RR"
    gtNotPOBString(2) = "RT"
    gtNotPOBString(3) = "RD"
    gtNotPOBString(4) = "RFD"
    gtNotPOBString(5) = "ROUTE"
    gtNotPOBString(6) = "RURAL"
    gtNotPOBString(7) = "STAR"
    gtNotPOBString(8) = "HC"
    gtNotPOBString(8) = " R"
    gtNotPOBString(8) = " R "
    gtNotPOBString(8) = "R "
    gtNotPOBString(9) = "HWY"
    giNBegin = 1
    giNEnd = 9
    For n% = giNBegin To giNEnd
        giPOPos = InStr(1, gtTmpStreet, gtNotPOBString(n%), 1)
        If (giPOPos >= 1) Then
            RuralRouteFlag% = 1
            Exit For
        End If
    Next n%

End Sub    '  RuralRouteTest

Sub ConvertDate(gtInputDate, gtOutputDate)

    If (Len(gtInputDate) > 0) Then
        gtMM = Mid(gtInputDate, 1, 3)
        Select Case gtMM
            Case Is = "Jan"
                gtMM = "01"
            Case Is = "Feb"
                gtMM = "02"
            Case Is = "Mar"
                gtMM = "03"
            Case Is = "Apr"
                gtMM = "04"
            Case Is = "May"
                gtMM = "05"
            Case Is = "Jun"
                gtMM = "06"
            Case Is = "Jul"
                gtMM = "07"
            Case Is = "Aug"
                gtMM = "08"
            Case Is = "Sep"
                gtMM = "09"
            Case Is = "Oct"
                gtMM = "10"
            Case Is = "Nov"
                gtMM = "11"
            Case Is = "Dec"
                gtMM = "12"
        End Select
        gtDD = Trim(Mid(gtInputDate, 5, 2))
        If (Val(gtDD) < 10) Then
            gtDD = "0" & gtDD
        End If
        gtYY = Mid(gtInputDate, 8, 4)
        gtOutputDate = gtYY & gtMM & gtDD
    Else
        gtOutputDate = ""
    End If

End Sub    '  ConvertDate


Sub PopulateTransmitterTable()

    Set dbJet = wsJet.OpenDatabase(gtOutputPathAndFilename)
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    Set rsTransmitterTbl = dbJet.OpenRecordset("IbfsTransmitter", dbOpenTable)
    
    gtActionText = gtActionTextMsg & "Populate Transmitter Table!"
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    
    gxBeginDateTime = Now
    glBeginSeconds = GetTickCount()
    giMaxFldCnt = 10
    gtTableName = "IbfsTransmitter"
    gtInputFileName = "transmitter.dat"
    frmStatus.lblStatus.Caption = "Populating 'Transmitter' table with  < " & gtInputFileName & " >  data !"
    DoEvents
    'Print #giBadDataFF, ""
    'Print #giBadDataFF, "=====>  " & gtInputFileName & "  <====="
    'Print #giBadDataFF, ""
    
    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh

    giIDFF = FreeFile
    Open (gtInputFilePath & gtInputFileName) For Input As giIDFF
    glLengthOfFile = LOF(giIDFF)

    frmStatus.lblFileSize.Caption = Format(glLengthOfFile, "###,###,###0")
    frmStatus.Refresh
    glRecCnt = 0
    glRecLen = 0

    Do While Not EOF(giIDFF)
        glRecCnt = glRecCnt + 1
        glRecLen = glRecLen + Len(gtInputData) + 2
        If ((glRecCnt Mod 100) = 0) Then
            frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
            gsPercentComplete = (glRecLen / glLengthOfFile) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
        End If
        Line Input #giIDFF, gtInputData
        gtInputData = Trim(gtInputData)
        
        If (Len(gtInputData) = 0) Then GoTo TransmitterTag

        Call NewLineRepair

        giSegmCnt = 1
        Erase gtDataArray
        Call ParseInputData

        BeginTrans
        rsTransmitterTbl.AddNew
        rsTransmitterTbl!TransmitterKey = Val(gtDataArray(1, giSegmCnt))
        rsTransmitterTbl!SiteKey = Val(gtDataArray(2, giSegmCnt))
        rsTransmitterTbl!TransmitterDescription = ""
        rsTransmitterTbl!TransmitterDescription.AppendChunk Trim(gtDataArray(3, giSegmCnt))
        rsTransmitterTbl!Quanity = Format(Val(gtDataArray(4, giSegmCnt)), "000000")
        rsTransmitterTbl!Manufacturer = Trim(gtDataArray(5, giSegmCnt))
        rsTransmitterTbl!Model = Trim(gtDataArray(6, giSegmCnt))
        rsTransmitterTbl!SerialNum = Trim(gtDataArray(7, giSegmCnt))
        rsTransmitterTbl!EmissionType = Trim(gtDataArray(8, giSegmCnt))
        rsTransmitterTbl!Power = Format(Val(gtDataArray(9, giSegmCnt)), "000000")
        rsTransmitterTbl!Tolerance = Format(Val(gtDataArray(10, giSegmCnt)), "0000.0")
        rsTransmitterTbl.Update
        CommitTrans
        DoEvents

TransmitterTag:
    Loop
    Close (giIDFF)
    
    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    DoEvents

    Call WriteProcessLog

    rsTransmitterTbl.Close
    Set rsTransmitterTbl = Nothing
    rsProcessLog.Close
    Set rsProcessLog = Nothing
    dbJet.Close

    frmStatus.lblStatus.Caption = "Finished processing  <  " & gtInputFileName & "  >  data !"
    DoEvents

    Exit Sub
    
PopulateTransmitterTableErr:
    
    gtMsg = "Error in TransmitterTable" & vbCrLf
    gtMsg = gtMsg & "Error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    'Print #giBadDataFF, gtMsg
    MsgBox gtMsg

End Sub    '  PopulateTransmitterTable

Sub PopulateConditionTable()

    Dim gtInputDataArray
    
    Set dbJet = wsJet.OpenDatabase(gtOutputPathAndFilename)
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    Set rsCondition = dbJet.OpenRecordset("IbfsCondition", dbOpenTable)

    gtActionText = gtActionTextMsg & "Populate Condition Table!"
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)

    gxBeginDateTime = Now
    glBeginSeconds = GetTickCount()
    giMaxFldCnt = 5
    gtTableName = "IbfsCondition"
    gtInputFileName = "Cond.dat"
    frmStatus.lblStatus.Caption = "Populating 'Condition' table with  < " & gtInputFileName & " >  data !"
    DoEvents
    
    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh

    giIDFF = FreeFile
    Open (gtInputFilePath & gtInputFileName) For Input As giIDFF
    glLengthOfFile = LOF(giIDFF)

    frmStatus.lblFileSize.Caption = Format(glLengthOfFile, "###,###,###0")
    frmStatus.Refresh
    glRecCnt = 0
    glRecLen = 0

    Do While Not EOF(giIDFF)
        glRecCnt = glRecCnt + 1
        glRecLen = glRecLen + Len(gtInputData) + 2
        If ((glRecCnt Mod 100) = 0) Then
            frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
            gsPercentComplete = (glRecLen / glLengthOfFile) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
        End If
        Line Input #giIDFF, gtInputData
        gtInputData = Trim(gtInputData)
        
        If (Len(gtInputData) = 0) Then GoTo ConditionTag

        Call NewLineRepair

        gtInputDataArray = ""
        gtInputDataArray = Split(gtInputData, "|", giMaxFldCnt, 1)
        
        BeginTrans
        rsCondition.AddNew
        rsCondition!ConditionCode = Val(gtInputDataArray(0))
        rsCondition!SubsystemCode = Trim(gtInputDataArray(1))
        rsCondition!ConditionText = ""
        rsCondition!ConditionText.AppendChunk Trim(gtInputDataArray(2))
        rsCondition!ConditionNote = ""
        rsCondition!ConditionNote.AppendChunk Trim(gtInputDataArray(3))
        rsCondition.Update
        CommitTrans
        DoEvents

ConditionTag:
    Loop
    Close (giIDFF)
    
    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    DoEvents
    
    Call WriteProcessLog

    rsCondition.Close
    Set rsCondition = Nothing
    rsProcessLog.Close
    Set rsProcessLog = Nothing
    dbJet.Close

    frmStatus.lblStatus.Caption = "Finished processing  <  " & gtInputFileName & "  >  data !"
    DoEvents

    Exit Sub
    
PopulateConditionTableErr:
    
    gtMsg = "Error in ConditionTable" & vbCrLf
    gtMsg = gtMsg & "Error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    'Print #giBadDataFF, gtMsg
    MsgBox gtMsg

End Sub    '  PopulateConditionTable

Sub PopulateAntennaConditionTable()

    Dim gtInputDataArray
    
    Set dbJet = wsJet.OpenDatabase(gtOutputPathAndFilename)
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    Set rsAntennaCondition = dbJet.OpenRecordset("IbfsAntennaCondition", dbOpenTable)

    gtActionText = gtActionTextMsg & "Populate Antenna Condition Table!"
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)

    gxBeginDateTime = Now
    glBeginSeconds = GetTickCount()
    giMaxFldCnt = 4
    gtTableName = "IbfsAntennaCondition"
    gtInputFileName = "ant_cond.dat"
    frmStatus.lblStatus.Caption = "Populating 'AntennaCondition' table with  < " & gtInputFileName & " >  data !"
    DoEvents
    
    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh

    giIDFF = FreeFile
    Open (gtInputFilePath & gtInputFileName) For Input As giIDFF
    glLengthOfFile = LOF(giIDFF)

    frmStatus.lblFileSize.Caption = Format(glLengthOfFile, "###,###,###0")
    frmStatus.Refresh
    glRecCnt = 0
    glRecLen = 0

    Do While Not EOF(giIDFF)
        glRecCnt = glRecCnt + 1
        glRecLen = glRecLen + Len(gtInputData) + 2
        If ((glRecCnt Mod 100) = 0) Then
            frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
            gsPercentComplete = (glRecLen / glLengthOfFile) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
        End If
        Line Input #giIDFF, gtInputData
        gtInputData = Trim(gtInputData)
        
        If (Len(gtInputData) = 0) Then GoTo AntennaConditionTag

        Call NewLineRepair

        gtInputDataArray = ""
        gtInputDataArray = Split(gtInputData, "|", giMaxFldCnt, 1)
        
        BeginTrans
        rsAntennaCondition.AddNew
        rsAntennaCondition!ConditionKey = Val(gtInputDataArray(0))
        rsAntennaCondition!AntennaKey = Val(gtInputDataArray(1))
        rsAntennaCondition!ConditionCode = Val(gtInputDataArray(2))
        rsAntennaCondition.Update
        CommitTrans
        DoEvents

AntennaConditionTag:
    Loop
    Close (giIDFF)
    
    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    DoEvents

    Call WriteProcessLog
    
    rsAntennaCondition.Close
    Set rsAntennaCondition = Nothing
    rsProcessLog.Close
    Set rsProcessLog = Nothing
    dbJet.Close

    frmStatus.lblStatus.Caption = "Finished processing  <  " & gtInputFileName & "  >  data !"
    DoEvents

    Exit Sub
    
PopulateAntennaConditionTableErr:
    
    gtMsg = "Error in AntennaConditionTable" & vbCrLf
    gtMsg = gtMsg & "Error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    'Print #giBadDataFF, gtMsg
    MsgBox gtMsg

End Sub    '  PopulateAntennaAntennaConditionTable

Sub PopulateFreqCondTable()
    
    Dim gtInputDataArray
    
    Set dbJet = wsJet.OpenDatabase(gtOutputPathAndFilename)
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    Set rsFrequencyCondition = dbJet.OpenRecordset("IbfsFrequencyCondition", dbOpenTable)
    
    gtActionText = gtActionTextMsg & "Populate Freq Cond Table!"
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    
    gxBeginDateTime = Now
    glBeginSeconds = GetTickCount()
    giMaxFldCnt = 4
    gtTableName = "IbfsFrequencyCondition"
    gtInputFileName = "freq_cond.dat"
    frmStatus.lblStatus.Caption = "Populating 'FrequencyCondition' table with  < " & gtInputFileName & " >  data !"
    DoEvents
    
    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh

    giIDFF = FreeFile
    Open (gtInputFilePath & gtInputFileName) For Input As giIDFF
    glLengthOfFile = LOF(giIDFF)

    frmStatus.lblFileSize.Caption = Format(glLengthOfFile, "###,###,###0")
    frmStatus.Refresh
    glRecCnt = 0
    glRecLen = 0

    Do While Not EOF(giIDFF)
        glRecCnt = glRecCnt + 1
        glRecLen = glRecLen + Len(gtInputData) + 2
        If ((glRecCnt Mod 100) = 0) Then
            frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
            gsPercentComplete = (glRecLen / glLengthOfFile) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
        End If
        Line Input #giIDFF, gtInputData
        gtInputData = Trim(gtInputData)
        
        If (Len(gtInputData) = 0) Then GoTo FrequencyConditionTag

        Call NewLineRepair

        gtInputDataArray = ""
        gtInputDataArray = Split(gtInputData, "|", giMaxFldCnt, 1)
        
        BeginTrans
        rsFrequencyCondition.AddNew
        rsFrequencyCondition!ConditionKey = Val(gtInputDataArray(0))
        rsFrequencyCondition!FrequencyKey = Val(gtInputDataArray(1))
        rsFrequencyCondition!ConditionCode = Val(gtInputDataArray(2))
        rsFrequencyCondition.Update
        CommitTrans
        DoEvents

FrequencyConditionTag:
    Loop
    Close (giIDFF)
    
    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    DoEvents

    Call WriteProcessLog

    rsFrequencyCondition.Close
    Set rsFrequencyCondition = Nothing
    rsProcessLog.Close
    Set rsProcessLog = Nothing
    dbJet.Close

    frmStatus.lblStatus.Caption = "Finished processing  <  " & gtInputFileName & "  >  data !"
    DoEvents

    Exit Sub
    
PopulateFreqCondTableErr:
    
    gtMsg = "Error in FrequencyConditionTable" & vbCrLf
    gtMsg = gtMsg & "Error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    'Print #giBadDataFF, gtMsg
    MsgBox gtMsg

End Sub    '  PopulateFreqCondTable

Sub PopulateFxTable()

    Dim gtInputDataArray

    Set dbJet = wsJet.OpenDatabase(gtOutputPathAndFilename)
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    Set rsFx = dbJet.OpenRecordset("IbfsFx", dbOpenTable)

    gtActionText = gtActionTextMsg & "Populate FX Table!"
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)

    gxBeginDateTime = Now
    glBeginSeconds = GetTickCount()
    giMaxFldCnt = 29
    gtTableName = "IbfsFx"
    gtInputFileName = "fx.dat"
    frmStatus.lblStatus.Caption = "Populating 'Fx' table with  < " & gtInputFileName & " >  data !"
    DoEvents
    
    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh

    giIDFF = FreeFile
    Open (gtInputFilePath & gtInputFileName) For Input As giIDFF
    glLengthOfFile = LOF(giIDFF)

    frmStatus.lblFileSize.Caption = Format(glLengthOfFile, "###,###,###0")
    frmStatus.Refresh
    glRecCnt = 0
    glRecLen = 0

    Do While Not EOF(giIDFF)
        glRecCnt = glRecCnt + 1
        glRecLen = glRecLen + Len(gtInputData) + 2
        If ((glRecCnt Mod 100) = 0) Then
            frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
            gsPercentComplete = (glRecLen / glLengthOfFile) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
        End If
        Line Input #giIDFF, gtInputData
        gtInputData = Trim(gtInputData)
        
        If (Len(gtInputData) = 0) Then GoTo FxTag

        Call NewLineRepair

        gtInputDataArray = ""
        gtInputDataArray = Split(gtInputData, "|", giMaxFldCnt, 1)

        BeginTrans
        rsFx.AddNew
        rsFx!FilingKey = Val(gtInputDataArray(0))
        rsFx!FilenumRefer = gtInputDataArray(1)
            Call ConvertDate(Trim(gtInputDataArray(2)), gtOutputDate)
        rsFx!FilenumReferDate = gtOutputDate
        rsFx!IracStatus = gtInputDataArray(3)
        rsFx!TowerStatus = gtInputDataArray(4)
            Call ConvertDate(Trim(gtInputDataArray(5)), gtOutputDate)
        rsFx!CpExpireDate = gtOutputDate
        rsFx!ProximitySw = gtInputDataArray(6)
        rsFx!NepaMajorActionSw = gtInputDataArray(7)
        rsFx!RadiationHazardReportSw = gtInputDataArray(8)
        rsFx!CitizenSw = gtInputDataArray(9)
        rsFx!PartnersCitizenSw = gtInputDataArray(10)
        rsFx!CorpStateCode = gtInputDataArray(11)
        rsFx!AlienOwnershipSw = gtInputDataArray(12)
        rsFx!AlienControlSw = gtInputDataArray(13)
        rsFx!AlienOfficer4cSw = gtInputDataArray(14)
        rsFx!AlienOfficer4fSw = gtInputDataArray(15)
        rsFx!CorporateControlSw = gtInputDataArray(16)
        rsFx!SubsidiarySw = gtInputDataArray(17)
        rsFx!AssociationNoMembers = Val(gtInputDataArray(18))
        rsFx!AssociationNoAlienMembers = Val(gtInputDataArray(19))
            rsFx!PrincipalBusiness = ""    '  Initialize "Memo" field
        rsFx!PrincipalBusiness.AppendChunk Trim(gtInputDataArray(20))
        rsFx!AmFmTvInterestSw = gtInputDataArray(21)
        rsFx!ForeignRepSw = gtInputDataArray(22)
        rsFx!RevokedSw = gtInputDataArray(23)
        rsFx!DeniedSw = gtInputDataArray(24)
        rsFx!FelonySw = gtInputDataArray(25)
        rsFx!MonopolySw = gtInputDataArray(26)
        rsFx!AssetsSw = gtInputDataArray(27)
        rsFx!CapitalAssuranceSw = gtInputDataArray(28)
        rsFx.Update
        CommitTrans
        DoEvents

FxTag:
    Loop
    Close (giIDFF)
    
    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    DoEvents

    Call WriteProcessLog

    rsFx.Close
    Set rsFx = Nothing
    rsProcessLog.Close
    Set rsProcessLog = Nothing
    dbJet.Close

    frmStatus.lblStatus.Caption = "Finished processing  <  " & gtInputFileName & "  >  data !"
    DoEvents

    Exit Sub
    
PopulateFxTableErr:
    
    gtMsg = "Error in FxTable" & vbCrLf
    gtMsg = gtMsg & "Error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    'Print #giBadDataFF, gtMsg
    MsgBox gtMsg

End Sub    '  PopulateFxTable

Sub PopulateLicenseConditionTable()
    
    Dim gtInputDataArray
    
    Set dbJet = wsJet.OpenDatabase(gtOutputPathAndFilename)
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    Set rsLicenseCondition = dbJet.OpenRecordset("IbfsLicenseCondition", dbOpenTable)
    
    gtActionText = gtActionTextMsg & "Populate License Condition Table!"
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    
    gxBeginDateTime = Now
    glBeginSeconds = GetTickCount()
    giMaxFldCnt = 4
    gtTableName = "IbfsLicenseCondition"
    gtInputFileName = "lic_cond.dat"
    frmStatus.lblStatus.Caption = "Populating 'LicenseCondition' table with  < " & gtInputFileName & " >  data !"
    DoEvents
    
    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh

    giIDFF = FreeFile
    Open (gtInputFilePath & gtInputFileName) For Input As giIDFF
    glLengthOfFile = LOF(giIDFF)

    frmStatus.lblFileSize.Caption = Format(glLengthOfFile, "###,###,###0")
    frmStatus.Refresh
    glRecCnt = 0
    glRecLen = 0

    Do While Not EOF(giIDFF)
        glRecCnt = glRecCnt + 1
        glRecLen = glRecLen + Len(gtInputData) + 2
        If ((glRecCnt Mod 100) = 0) Then
            frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
            gsPercentComplete = (glRecLen / glLengthOfFile) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
        End If
        Line Input #giIDFF, gtInputData
        gtInputData = Trim(gtInputData)
        
        If (Len(gtInputData) = 0) Then GoTo LicenseConditionTag

        Call NewLineRepair

        gtInputDataArray = ""
        gtInputDataArray = Split(gtInputData, "|", giMaxFldCnt, 1)
        
        BeginTrans
        rsLicenseCondition.AddNew
        rsLicenseCondition!ConditionKey = Val(gtInputDataArray(0))
        rsLicenseCondition!FilingKey = Val(gtInputDataArray(1))
        rsLicenseCondition!ConditionCode = Val(gtInputDataArray(2))
        rsLicenseCondition.Update
        CommitTrans
        DoEvents

LicenseConditionTag:
    Loop
    Close (giIDFF)
    
    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    DoEvents

    Call WriteProcessLog

    rsLicenseCondition.Close
    Set rsLicenseCondition = Nothing
    rsProcessLog.Close
    Set rsProcessLog = Nothing
    dbJet.Close

    frmStatus.lblStatus.Caption = "Finished processing  <  " & gtInputFileName & "  >  data !"
    DoEvents

    Exit Sub
    
PopulateLicenseConditionTableErr:
    
    gtMsg = "Error in LicenseConditionTable" & vbCrLf
    gtMsg = gtMsg & "Error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    'Print #giBadDataFF, gtMsg
    MsgBox gtMsg

End Sub    '  PopulateLicenseConditionTable

Sub PopulateSiteConditionTable()
    
    Dim gtInputDataArray
        Set wsJet = DBEngine.Workspaces(0)

    Set dbJet = wsJet.OpenDatabase(gtOutputPathAndFilename)
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    Set rsSiteCondition = dbJet.OpenRecordset("IbfsSiteCondition", dbOpenTable)
    
    gtActionText = gtActionTextMsg & "Populate Site Condition Table!"
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    
    gxBeginDateTime = Now
    glBeginSeconds = GetTickCount()
    giMaxFldCnt = 4
    gtTableName = "IbfsSiteCondition"
    gtInputFileName = "site_cond.dat"
    frmStatus.lblStatus.Caption = "Populating 'SiteCondition' table with  < " & gtInputFileName & " >  data !"
    DoEvents
    
    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh

    giIDFF = FreeFile
    Open (gtInputFilePath & gtInputFileName) For Input As giIDFF
    glLengthOfFile = LOF(giIDFF)

    frmStatus.lblFileSize.Caption = Format(glLengthOfFile, "###,###,###0")
    frmStatus.Refresh
    glRecCnt = 0
    glRecLen = 0

    Do While Not EOF(giIDFF)
        glRecCnt = glRecCnt + 1
        glRecLen = glRecLen + Len(gtInputData) + 2
        If ((glRecCnt Mod 100) = 0) Then
            frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
            gsPercentComplete = (glRecLen / glLengthOfFile) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
        End If
        Line Input #giIDFF, gtInputData
        gtInputData = Trim(gtInputData)
        
        If (Len(gtInputData) = 0) Then GoTo SiteConditionTag

        Call NewLineRepair

        gtInputDataArray = ""
        gtInputDataArray = Split(gtInputData, "|", giMaxFldCnt, 1)
        
        BeginTrans
        rsSiteCondition.AddNew
        rsSiteCondition!ConditionKey = Val(gtInputDataArray(0))
        rsSiteCondition!ConditionCode = Val(gtInputDataArray(1))
        rsSiteCondition!SiteKey = Val(gtInputDataArray(2))
        rsSiteCondition.Update
        CommitTrans
        DoEvents

SiteConditionTag:
    Loop
    Close (giIDFF)
    
    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    DoEvents

    Call WriteProcessLog

    rsSiteCondition.Close
    Set rsSiteCondition = Nothing
    rsProcessLog.Close
    Set rsProcessLog = Nothing
    dbJet.Close

    frmStatus.lblStatus.Caption = "Finished processing  <  " & gtInputFileName & "  >  data !"
    DoEvents

    Exit Sub
    
PopulateSiteConditionTableErr:
    
    gtMsg = "Error in SiteConditionTable" & vbCrLf
    gtMsg = gtMsg & "Error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    'Print #giBadDataFF, gtMsg
    MsgBox gtMsg

End Sub    '  PopulateSiteConditionTable

Sub PopulateFrequencyBandTable()

' FrequencyBand

    Dim gtInputDataArray

    Set dbJet = wsJet.OpenDatabase(gtOutputPathAndFilename)
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    Set rsFrequencyBand = dbJet.OpenRecordset("IbfsFrequencyBand", dbOpenTable)
    
    gtActionText = gtActionTextMsg & "Populate Frequency Band Table!"
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    
    gxBeginDateTime = Now
    glBeginSeconds = GetTickCount()
    
    'giMaxFldCnt = 4
    giMaxFldCnt = 9
    
    gtTableName = "IbfsFrequencyBand"
    
    gtInputFileName = "FREQUENCY_BAND.dat"
    
    frmStatus.lblStatus.Caption = "Populating 'FrequencyBand' table with  < " & gtInputFileName & " >  data !"
    DoEvents
    
    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh

    giIDFF = FreeFile
    Open (gtInputFilePath & gtInputFileName) For Input As giIDFF
    glLengthOfFile = LOF(giIDFF)

    frmStatus.lblFileSize.Caption = Format(glLengthOfFile, "###,###,###0")
    frmStatus.Refresh
    glRecCnt = 0
    glRecLen = 0

    Do While Not EOF(giIDFF)
        glRecCnt = glRecCnt + 1
        glRecLen = glRecLen + Len(gtInputData) + 2
        If ((glRecCnt Mod 100) = 0) Then
            frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
            gsPercentComplete = (glRecLen / glLengthOfFile) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
        End If
        Line Input #giIDFF, gtInputData
        gtInputData = Trim(gtInputData)
        
        If (Len(gtInputData) = 0) Then GoTo FrequencyBandTag

        Call NewLineRepair

        gtInputDataArray = ""
        gtInputDataArray = Split(gtInputData, "|", giMaxFldCnt, 1)
        
        BeginTrans
        rsFrequencyBand.AddNew
        
        rsFrequencyBand!FreqId = Val(gtInputDataArray(0))
        rsFrequencyBand!FrequencyLower = Trim(gtInputDataArray(1))
        rsFrequencyBand!FrequencyUpper = Trim(gtInputDataArray(2))
        rsFrequencyBand!BandName = Trim(gtInputDataArray(3))
        rsFrequencyBand!DownlinkFrequencyLower = Trim(gtInputDataArray(4))
        rsFrequencyBand!DownlinkFrequencyUpper = Trim(gtInputDataArray(5))
        rsFrequencyBand!UplinkFrequencyLower = Trim(gtInputDataArray(6))
        rsFrequencyBand!UplinkFrequencyUpper = Trim(gtInputDataArray(7))
        rsFrequencyBand!RuleCiting = Trim(gtInputDataArray(8))
        rsFrequencyBand.Update
        CommitTrans
        DoEvents

FrequencyBandTag:
    Loop
    Close (giIDFF)
    
    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    DoEvents

    Call WriteProcessLog

    rsFrequencyBand.Close
    Set rsFrequencyBand = Nothing
    rsProcessLog.Close
    Set rsProcessLog = Nothing
    dbJet.Close

    frmStatus.lblStatus.Caption = "Finished processing  <  " & gtInputFileName & "  >  data !"
    DoEvents

    Exit Sub
    
PopulateFrequencyBandTableErr:
    
    gtMsg = "Error in FrequencyBandTable" & vbCrLf
    gtMsg = gtMsg & "Error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    'Print #giBadDataFF, gtMsg
    MsgBox gtMsg

End Sub    '  PopulateFrequencyBandTable

Sub PopulateIntlAlocFrequencyTable()

    Dim gtInputDataArray
    
    Set dbJet = wsJet.OpenDatabase(gtOutputPathAndFilename)
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    Set rsIntlAlocFrequency = dbJet.OpenRecordset("IbfsIntlAlocFrequency", dbOpenTable)
    
    gtActionText = gtActionTextMsg & "Populate Intl Aloc Frrequency Table!"
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    
    gxBeginDateTime = Now
    glBeginSeconds = GetTickCount()
    giMaxFldCnt = 4
    gtTableName = "IbfsIntlAlocFrequency"
    
    gtInputFileName = "INTL_ALOC_FREQUENCY.dat"
    
    frmStatus.lblStatus.Caption = "Populating 'IntlAlocFrequency' table with  < " & gtInputFileName & " >  data !"
    DoEvents
    
    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh

    giIDFF = FreeFile
    Open (gtInputFilePath & gtInputFileName) For Input As giIDFF
    glLengthOfFile = LOF(giIDFF)

    frmStatus.lblFileSize.Caption = Format(glLengthOfFile, "###,###,###0")
    frmStatus.Refresh
    glRecCnt = 0
    glRecLen = 0

    Do While Not EOF(giIDFF)
        glRecCnt = glRecCnt + 1
        glRecLen = glRecLen + Len(gtInputData) + 2
        If ((glRecCnt Mod 100) = 0) Then
            frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
            gsPercentComplete = (glRecLen / glLengthOfFile) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
        End If
        Line Input #giIDFF, gtInputData
        gtInputData = Trim(gtInputData)
        
        If (Len(gtInputData) = 0) Then GoTo IntlAlocFrequencyTag

        Call NewLineRepair

        gtInputDataArray = ""
        gtInputDataArray = Split(gtInputData, "|", giMaxFldCnt, 1)
        
        BeginTrans
        rsIntlAlocFrequency.AddNew
        rsIntlAlocFrequency!Id = Val(gtInputDataArray(0))
        rsIntlAlocFrequency!FrequencyLower = Trim(gtInputDataArray(1))
        rsIntlAlocFrequency!FrequencyUpper = Trim(gtInputDataArray(2))
        'id numeric(18,0)  identity not null ,
        'frequency_lower char(17) null ,
        'frequency_upper char(17) null
        rsIntlAlocFrequency.Update
        CommitTrans
        DoEvents

IntlAlocFrequencyTag:
    Loop
    Close (giIDFF)
    
    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    DoEvents

    Call WriteProcessLog

    rsIntlAlocFrequency.Close
    Set rsIntlAlocFrequency = Nothing
    rsProcessLog.Close
    Set rsProcessLog = Nothing
    dbJet.Close

    frmStatus.lblStatus.Caption = "Finished processing  <  " & gtInputFileName & "  >  data !"
    DoEvents

    Exit Sub
    
PopulateIntlAlocFrequencyTableErr:
    
    gtMsg = "Error in IntlAlocFrequencyTable" & vbCrLf
    gtMsg = gtMsg & "Error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    'Print #giBadDataFF, gtMsg
    MsgBox gtMsg

End Sub    '  PopulateIntlAlocFrequencyTable

Sub PopulateLiceEinFrnTable()

    '   The subrountine "PopulateLiceEinFrnTable" is used to add the EIN to the data
    '   set from the file "einfrn.mdb".  If this file is not available, the action
    '   is skipped.

    Dim gtFccRegNum As String
    Dim gtFccRegNumPre As String
    Dim giCallSignCnt As Integer
    Dim giCallSignCntPre As Integer
    Dim gtFreqKeyPre As String
    Dim glCurrentCount As Long

    gtLiceEinFrnTablePath = "E:\MffMdb\EinFrn\einfrn.mdb"

    If (LCase(Dir(gtLiceEinFrnTablePath)) <> "einfrn.mdb") Then
        frmStatus.lblStatus.Caption = " 'einfrn.mdb' data not found!  Exiting subroutine! "
        MsgBox "File not found, exiting  PopulateLiceEinFrnTable"
        DoEvents
        Exit Sub
    End If

    frmStatus.lblStatus.Caption = "Processing 'LiceEinFrnTable' data !  Please wait . . . ."

    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh

    Set wsJet = DBEngine.Workspaces(0)
    Set dbJet = wsJet.OpenDatabase(gtOutputPathAndFilename)
    Set rsFreq = dbJet.OpenRecordset("Freq", dbOpenTable)
    Set rsLiceEinFrn = dbJet.OpenRecordset("LiceEinFrn", dbOpenTable)
    Set rsLice = dbJet.OpenRecordset("Lice", dbOpenTable)

    gtActionText = gtActionTextMsg & "Lice data!"
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)

    Set dbJetEinFrnTable = wsJet.OpenDatabase(gtLiceEinFrnTablePath)
    Set rsEinFrnTable = dbJetEinFrnTable.OpenRecordset("EinFrnTable", dbOpenTable)

    gtSql = "SELECT Freq.CsFnKey, Freq.FreqKey, Freq.FccRegNum, freq.StatusCode " & _
            "From Freq " & _
            "ORDER BY Freq.FccRegNum, Freq.CsFnKey, Freq.FreqKey"
    'MsgBox gtSql
    'DoEvents
    
    Set rsSQL = dbJet.OpenRecordset(gtSql, dbOpenSnapshot)

    rsSQL.MoveLast
    glNumRecs = rsSQL.RecordCount
    rsSQL.MoveFirst
    frmStatus.lblTotalRecords.Caption = Format(glNumRecs, "###,###,##0")
    frmStatus.Refresh
    DoEvents

    glRecCnt = 0
    
    gtCsFnKey = "*****"
    gtCsFnKeyPre = "*****"
    
    gtFccRegNum = "*****"
    gtFccRegNumPre = "*****"
    
    giCallSignCnt = 0
    giCallSignCntPre = 0

    Do While Not rsSQL.EOF

        glRecCnt = glRecCnt + 1
        If ((glRecCnt Mod 100) = 0) Then
            gsPercentComplete = (glRecCnt / glNumRecs) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            frmStatus.Refresh
            DoEvents
        End If

        If ((Val(rsSQL!FccRegNum) < 1)) Then
            GoTo SkipPopulateLiceEinFrnTable
        End If

        If ((rsSQL!StatusCode) <> "9") Then
            GoTo SkipPopulateLiceEinFrnTable
        End If

        gtFccRegNum = rsSQL!FccRegNum
        gtCsFnKey = rsSQL!CsFnKey
        gtFreqKey = rsSQL!FreqKey

        If (Trim(gtFccRegNum) <> Trim(gtFccRegNumPre)) Then
            
            If (glRecCnt = 1) Then
                giCallSignCnt = 1
                GoTo SkipPopulateLiceEinFrnTable
            End If
            
            rsEinFrnTable.Index = "idxFrnKey"
            rsEinFrnTable.Seek "=", gtFccRegNumPre
            If (Not rsEinFrnTable.NoMatch) Then
                'If (IsNull(rsEinFrnTable!CallSignCnt)) Then
                    glCurrentCount = 0
                'Else
                '    glCurrentCount = rsEinFrnTable!CallSignCnt
                'End If
                
                BeginTrans
                rsEinFrnTable.Edit
                    'rsEinFrnTable!CallSignCnt = giCallSignCntPre + glCurrentCount
                    'MsgBox ("CallSignCnt = " & Str(giCallSignCnt)), , "PopulateLiceEinFrnTable - 2"
                    DoEvents
                rsEinFrnTable.Update
                CommitTrans
                DoEvents
            End If
            
            giCallSignCntPre = 1
            giCallSignCnt = 1

'gtMsg = gtCsFnKey & vbCrLf & "gtFccRegNumPre = " & gtFccRegNumPre & vbCrLf & "giCallSignCnt = " & giCallSignCnt
'MsgBox gtMsg, , "Export"
'DoEvents

        Else    '  rsSQL!FccRegNum = gtFccRegNumPre
                
                If (rsSQL!CsFnKey <> gtCsFnKeyPre) Then
                    '  Update count
                    giCallSignCnt = giCallSignCnt + 1
                Else    ' gtCsFnKey = gtCsFnKeyPre
                    ' Skip record
                    giCallSignCnt = giCallSignCnt
                End If
                giCallSignCntPre = giCallSignCnt
        
        End If
            
If (giCallSignCnt >= 10) Then
'gtMsg = gtCsFnKey & vbCrLf & "gtFccRegNumPre = " & gtFccRegNumPre & vbCrLf & "giCallSignCnt = " & giCallSignCnt
'MsgBox gtMsg, , "Running Count"
DoEvents

End If

            gtFccRegNumPre = rsSQL!FccRegNum
            gtCsFnKeyPre = rsSQL!CsFnKey
            gtFreqKeyPre = rsSQL!FreqKey

        rsEinFrnTable.Index = "idxFrnKey"
        rsEinFrnTable.Seek "=", rsSQL!FreqKey
        If (Not rsEinFrnTable.NoMatch) Then
                
            '  Decode 'EinFrnTable'
                
            '  Decode 'EinFrnTable'
                
            If (IsNull(rsEinFrnTable!EinKey)) Then
                gtEinKey = ""
            Else
                gtEinKey = rsEinFrnTable!EinKey  '  0   '  1
            End If
            gtFrnKey = rsEinFrnTable!FrnKey
            gtEntityName = rsEinFrnTable!EntityName      '  2
            gtEntityOrg = rsEinFrnTable!EntityOrg
            gtEntityType = rsEinFrnTable!EntityType
            gtEntitySubType = rsEinFrnTable!EntitySubType
            gtStreet1 = rsEinFrnTable!Street1     '  3
            gtStreet2 = rsEinFrnTable!Street2   '  4
            gtPOBox = rsEinFrnTable!POBox     '  5
            gtCity = rsEinFrnTable!City     '  6
            gtState = rsEinFrnTable!State    '  7
            gtZip = rsEinFrnTable!ZipCode     '  8
            gtCountry = rsEinFrnTable!Country
            gtEmailAddress = rsEinFrnTable!EmailAddress
            gtTelephoneNumber = rsEinFrnTable!TelephoneNumber
            gtInputSource = rsEinFrnTable!InputSource   '  10
            gtRegDt = rsEinFrnTable!RegDt   '  11
            gtUpdDt = rsEinFrnTable!UpdDt     '  12

            '  Populate 'LiceEinFrn'
            rsLiceEinFrn.Index = "idxFrnKey"
            rsLiceEinFrn.Seek "=", rsSQL!FreqKey
            If (rsLiceEinFrn.NoMatch) Then
                BeginTrans
                rsLiceEinFrn.AddNew
                rsLiceEinFrn!EinKey = gtEinKey    '  0
                rsLiceEinFrn!FrnKey = gtFrnKey    '  1
                rsLiceEinFrn!EntityName = gtEntityName    '  2
                rsLiceEinFrn!EntityOrg = gtEntityOrg
                rsLiceEinFrn!EntityType = gtEntityType
                rsLiceEinFrn!EntitySubType = gtEntitySubType
                rsLiceEinFrn!Street1 = gtStreet1    '  3
                rsLiceEinFrn!Street2 = gtStreet2    '  4
                rsLiceEinFrn!POBox = gtPOBox    '  5
                rsLiceEinFrn!City = gtCity    '  6
                rsLiceEinFrn!State = gtState    '  7
                rsLiceEinFrn!ZipCode = gtZip    '  8
                rsLiceEinFrn!Country = gtCountry
                rsLiceEinFrn!EmailAddress = gtEmailAddress
                rsLiceEinFrn!TelephoneNumber = gtTelephoneNumber
                rsLiceEinFrn!InputSource = gtInputSource    '  10
                rsLiceEinFrn!RegDt = gtRegDt    '  11
                rsLiceEinFrn!UpdDt = gtUpdDt    '  12
                rsLiceEinFrn.Update
                CommitTrans
            End If

        End If

SkipPopulateLiceEinFrnTable:

        rsSQL.MoveNext
    Loop
        
    gsPercentComplete = (glRecCnt / glNumRecs) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    frmStatus.Refresh
    DoEvents
    
    Close
    Call WriteProcessLog
    rsLice.Close
    Set rsLice = Nothing
    rsEinFrnTable.Close
    Set rsEinFrnTable = Nothing
    dbJetEinFrnTable.Close
    Set dbJetEinFrnTable = Nothing
    dbJet.Close
    Set dbJet = Nothing
    wsJet.Close
    Set wsJet = Nothing

End Sub    '  PopulateLiceEinFrnTable

Sub PopulateFrequencySatTable()

    Dim gtInputDataArray
    
    Set dbJet = wsJet.OpenDatabase(gtOutputPathAndFilename)
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    Set rsFrequencySat = dbJet.OpenRecordset("IbfsFrequencySat", dbOpenTable)
    
    gtActionText = gtActionTextMsg & "Populate Frequency Sat Table!"
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    
    gxBeginDateTime = Now
    glBeginSeconds = GetTickCount()
    
    giMaxFldCnt = 5
    
    gtTableName = "IbfsFrequencySat"
    
    gtInputFileName = "FREQUENCY_SAT.dat"
    
    frmStatus.lblStatus.Caption = "Populating 'FrequencySat' table with  < " & gtInputFileName & " >  data !"
    DoEvents
    
    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh

    giIDFF = FreeFile
    Open (gtInputFilePath & gtInputFileName) For Input As giIDFF
    glLengthOfFile = LOF(giIDFF)

    frmStatus.lblFileSize.Caption = Format(glLengthOfFile, "###,###,###0")
    frmStatus.Refresh
    glRecCnt = 0
    glRecLen = 0

    Do While Not EOF(giIDFF)
        glRecCnt = glRecCnt + 1
        glRecLen = glRecLen + Len(gtInputData) + 2
        If ((glRecCnt Mod 100) = 0) Then
            frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
            gsPercentComplete = (glRecLen / glLengthOfFile) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
        End If
        Line Input #giIDFF, gtInputData
        gtInputData = Trim(gtInputData)
        
        If (Len(gtInputData) = 0) Then GoTo FrequencySatTag

        Call NewLineRepair

        gtInputDataArray = ""
        gtInputDataArray = Split(gtInputData, "|", giMaxFldCnt, 1)
        
        BeginTrans
        rsFrequencySat.AddNew

        rsFrequencySat!FrequencyKey = Val(gtInputDataArray(0))
        rsFrequencySat!FilingKey = Val(gtInputDataArray(1))
        rsFrequencySat!FrequencyLower = Trim(gtInputDataArray(2))
        rsFrequencySat!FrequencyUpper = Trim(gtInputDataArray(3))
        rsFrequencySat!TransMode = Trim(gtInputDataArray(4))

        'frequency_key int not null ,
        'filing_key int not null ,
        'frequency_lower char(17) null ,
        'frequency_upper char(17) null ,
        'trans_mode char(1) null
        rsFrequencySat.Update
        CommitTrans
        DoEvents

FrequencySatTag:
    Loop
    Close (giIDFF)
    
    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    DoEvents

    Call WriteProcessLog

    rsFrequencySat.Close
    Set rsFrequencySat = Nothing
    rsProcessLog.Close
    Set rsProcessLog = Nothing
    dbJet.Close

    frmStatus.lblStatus.Caption = "Finished processing  <  " & gtInputFileName & "  >  data !"
    DoEvents

    Exit Sub
    
PopulateFrequencySatTableErr:
    
    gtMsg = "Error in FrequencySatTable" & vbCrLf
    gtMsg = gtMsg & "Error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    'Print #giBadDataFF, gtMsg
    MsgBox gtMsg

End Sub    '  PopulateFrequencySatTable


Sub ParseInputData()

    'On Error GoTo ParseInputDataErr
    
    If (Len(gtInputData) = 0) Then Exit Sub
    
    gtDelimiter = Chr(124)    '  "|"
    gtInputData = gtInputData & gtDelimiter
    giLenInputData = Len(gtInputData)
    giPositionStart = 0
    giPositionEnd = -1
    giFieldLength = 0
    giFldNum = 0
    For giChrPos = 1 To giLenInputData
        If (Mid(gtInputData, giChrPos, 1) = gtDelimiter) Then
            giPositionEnd = (giChrPos)
            giFldNum = giFldNum + 1
            If ((giPositionEnd - giPositionStart) > 1) Then
                gtDataArray(giFldNum, giSegmCnt) = Trim(Mid(gtInputData, (giPositionStart + 1), (giPositionEnd - (giPositionStart + 1))))
            Else
                gtDataArray(giFldNum, giSegmCnt) = ""
            End If
            giPositionStart = giChrPos
            giPositionEnd = -1
            If (giFldNum >= giMaxFldCnt) Then Exit For
        End If
    Next giChrPos
'MsgBox "in ParseInputData"
'DoEvents
    Exit Sub

ParseInputDataErr:

    gtMsg = " Err Num: " & Str(Err.Number) & vbCrLf
    gtMsg = gtMsg & "Err Description: " & Err.Description & vbCrLf & vbCrLf
    gtMsg = gtMsg & gtInputData
    'Print #giBadDataFF, gtMsg
    MsgBox gtMsg
    
End Sub    '  ParseInputDataNew


Sub CompactDB()

    On Error GoTo CompactDB_Err

    giFF = FreeFile
    Open (gtOutputPathAndFilename) For Input As giFF
    glLof1 = LOF(giFF)
    Close (giFF)
    
    'gtCompactMsg = "Compacting database!"
    frmStatus.lblStatus.Caption = gtCompactMsg & vbCrLf & _
            "Current file size (bytes):   " & Format(glLof1, "###,###,##0") & vbCrLf & vbCrLf & _
            "Please wait . . . . "
    frmStatus.Refresh

    gtOutputPathAndFilenameName = Dir(gtOutputPathAndFilename)
    giX = InStr(1, gtOutputPathAndFilename, gtOutputPathAndFilenameName, 1)
    If (giX <= 0) Then
        Exit Sub
    End If
    gtDatabasePath = Mid(gtOutputPathAndFilename, 1, (giX - 1))
    gtTempDatabaseName = gtDatabasePath & "IbfsTemp.mdb"
    If (Dir(gtTempDatabaseName) <> "") Then
        Kill gtTempDatabaseName
    End If
    
    DBEngine.CompactDatabase gtOutputPathAndFilename, gtTempDatabaseName, dbLangGeneral
    
    Kill gtOutputPathAndFilename
    
    Name gtTempDatabaseName As gtOutputPathAndFilename
    
    giFF = FreeFile
    Open (gtOutputPathAndFilename) For Input As giFF
    glLof2 = LOF(giFF)
    Close (giFF)

    gtMsg = "Uncompressed file size: " & Format(glLof1, "###,###,##0") & vbCrLf & _
            "Compressed file size: " & Format(glLof2, "###,###,##0") & "  |  " & _
            "Compression ratio: " & Format(((1# - (glLof2 / glLof1)) * 100#), "0.0")
    frmStatus.lblStatus.Caption = gtMsg
    'MsgBox gtMsg, , "Database Compression"
    DoEvents
    
    Exit Sub

CompactDB_Err:
    
    MsgBox Err.Description
    DoEvents

End Sub    '  CompactDB


Sub EsPopulateMffTables()

    Dim glFilingKeyPre As Long

    frmStatus.lblStatus.Caption = "Creating SQL record set to populating MFF tables!" & vbCrLf & "PLEASE wait, this will take some time . . . . "
    frmStatus.lblStepCurrent.Caption = Str(giActionCounter)
    frmStatus.Refresh

    'gtSql = "SELECT IbfsMain.FilingKey, IbfsMain.AddressKey, " & _
            "IbfsMain.ContactKey, IbfsMain.CallSign, IbfsMain.ClassOfStationCode, " & _
            "IbfsSite.SiteKey, " & _
            "IbfsFrequency.FrequencyKey, IbfsFrequency.TransModeFix, " & _
            "IbfsAntenna.AntennaKey " & _
            "FROM ((IbfsMain INNER JOIN IbfsSite ON IbfsMain.FilingKey = IbfsSite.FilingKey) INNER JOIN IbfsAntenna ON IbfsSite.SiteKey = IbfsAntenna.SiteKey) INNER JOIN IbfsFrequency ON IbfsAntenna.AntennaKey = IbfsFrequency.AntennaKey " & _
            "Where (((IbfsMain.FilingState) = " & Chr(34) & "0" & Chr(34) & " Or (IbfsMain.FilingState) = " & Chr(34) & "1" & Chr(34) & ") And ((IbfsMain.SubsystemCode) = " & Chr(34) & "SES" & Chr(34) & " Or (IbfsMain.SubsystemCode) = " & Chr(34) & "SAT" & Chr(34) & ")) " & _
            "ORDER BY IbfsMain.CallSign, IbfsSite.SiteKey, IbfsFrequency.TransModeFix, IbfsAntenna.AntennaKey, IbfsFrequency.FrequencyKey"

    gtSql = "SELECT IbfsMain.CallSign, IbfsMain.FilingKey, " & _
            "IbfsMain.FilingState, IbfsMain.SubsystemCode, " & _
            "IbfsMain.ClassOfStationCode, IbfsMain.AddressKey, " & _
            "IbfsMain.ContactKey, IbfsSite.SiteKey, " & _
            "IbfsAntenna.AntennaKey, IbfsFrequency.FrequencyKey, " & _
            "IbfsFrequency.FrequencyLower, IbfsFrequency.FrequencyUpper, " & _
            "IbfsFrequency.Emission, IbfsFrequency.TransModeFix " & _
            "FROM ((IbfsMain INNER JOIN IbfsSite ON IbfsMain.FilingKey = IbfsSite.FilingKey) INNER JOIN IbfsAntenna ON IbfsSite.SiteKey = IbfsAntenna.SiteKey) INNER JOIN IbfsFrequency ON IbfsAntenna.AntennaKey = IbfsFrequency.AntennaKey " & _
            "Where (((IbfsMain.FilingState) = " & Chr(34) & "0" & Chr(34) & " Or (IbfsMain.FilingState) = " & Chr(34) & "1" & Chr(34) & ") And ((IbfsMain.SubsystemCode) = " & Chr(34) & "SES" & Chr(34) & ")) " & _
            "ORDER BY IbfsMain.CallSign, IbfsSite.SiteKey, IbfsAntenna.AntennaKey, IbfsFrequency.FrequencyLower, IbfsFrequency.FrequencyUpper, IbfsFrequency.TransModeFix"

            'Where (((IbfsMain.FilingState) = "0" Or (IbfsMain.FilingState) = "1") And ((IbfsMain.SubsystemCode) = "SES"))
            'ORDER BY IbfsMain.CallSign, IbfsSite.SiteKey, IbfsAntenna.AntennaKey, IbfsFrequency.FrequencyLower, IbfsFrequency.FrequencyUpper, IbfsFrequency.TransMode;
    
    'MsgBox gtSql, , "ES Populate MFF Tables"
    'DoEvents

    Set dbJet = wsJet.OpenDatabase(gtOutputPathAndFilename)

    Set dbJetAntSiteDb = wsJet.OpenDatabase(gtAntSiteDb)
    Set rsAntSiteInfo = dbJetAntSiteDb.OpenRecordset("AntSiteInfo", dbOpenTable)
    Set rsAntSiteCallSign = dbJetAntSiteDb.OpenRecordset("AntSiteCallSign", dbOpenTable)
    Set rsAntSiteOwner = dbJetAntSiteDb.OpenRecordset("AntSiteOwner", dbOpenTable)

    gtActionText = gtActionTextMsg & "Es Populate Mff Tables!"
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)

    Set rsMainTbl = dbJet.OpenRecordset("IbfsMain", dbOpenTable)
    Set rsAddressTbl = dbJet.OpenRecordset("IbfsAddress", dbOpenTable)
    Set rsContactTbl = dbJet.OpenRecordset("IbfsContact", dbOpenTable)
    Set rsSiteTbl = dbJet.OpenRecordset("IbfsSite", dbOpenTable)
    Set rsAntennaTbl = dbJet.OpenRecordset("IbfsAntenna", dbOpenTable)
    Set rsAntennaGainTbl = dbJet.OpenRecordset("IbfsAntennaGain", dbOpenTable)

    Set rsFrequencyTbl = dbJet.OpenRecordset("IbfsFrequency", dbOpenTable)
    Set rsFreqCoordTbl = dbJet.OpenRecordset("IbfsFreqCoord", dbOpenTable)
    Set rsSpaceStationTbl = dbJet.OpenRecordset("IbfsSpaceStation", dbOpenTable)
    Set rsPtCommTbl = dbJet.OpenRecordset("IbfsPtComm", dbOpenTable)
    Set rsForm312Tbl = dbJet.OpenRecordset("IbfsForm312", dbOpenTable)
    Set rsSpaceStationTbl = dbJet.OpenRecordset("IbfsSpaceStation", dbOpenTable)

    Set rsSection214Tbl = dbJet.OpenRecordset("IbfsSection214", dbOpenTable)
    Set rsPtCommTbl = dbJet.OpenRecordset("IbfsPtComm", dbOpenTable)

    Set rsLice = dbJet.OpenRecordset("Lice", dbOpenTable)
    Set rsFreq = dbJet.OpenRecordset("Freq", dbOpenTable)
    'Set rsSiteInfo = dbJet.OpenRecordset("SiteTx", dbOpenTable)
    Set rsAntMain = dbJet.OpenRecordset("AntMain", dbOpenTable)
    Set rsSiteEsCoord = dbJet.OpenRecordset("SiteEsCoord", dbOpenTable)
    'Set rsSiteTblSpace = dbJet.OpenRecordset("SiteSpace", dbOpenTable)
    'Set rsSiteInfo = dbJet.OpenRecordset("SiteRx", dbOpenTable)
    Set rsAntMain = dbJet.OpenRecordset("AntMain", dbOpenTable)
    Set rsSiteEsCoord = dbJet.OpenRecordset("SiteEsCoord", dbOpenTable)
    Set rsSpaceStationIndex = dbJet.OpenRecordset("SpaceStationIndex", dbOpenTable)

    Set rsCondition = dbJet.OpenRecordset("IbfsCondition", dbOpenTable)
    Set rsAntennaCondition = dbJet.OpenRecordset("IbfsAntennaCondition", dbOpenTable)
    Set rsFrequencyCondition = dbJet.OpenRecordset("IbfsFrequencyCondition", dbOpenTable)
    Set rsLicenseCondition = dbJet.OpenRecordset("IbfsLicenseCondition", dbOpenTable)
    Set rsSiteCondition = dbJet.OpenRecordset("IbfsSiteCondition", dbOpenTable)

    Set rsSpcCndAnt = dbJet.OpenRecordset("SpcCndAnt", dbOpenTable)
    Set rsSpcCndFreq = dbJet.OpenRecordset("SpcCndFreq", dbOpenTable)
    Set rsSpcCndLice = dbJet.OpenRecordset("SpcCndLice", dbOpenTable)
    Set rsSpcCndSite = dbJet.OpenRecordset("SpcCndSite", dbOpenTable)
    Set rsNatOfSer = dbJet.OpenRecordset("IbfsNatureOfService", dbOpenTable)
    Set rsNatOfSerCod = dbJet.OpenRecordset("IbfsNatureOfServiceCode", dbOpenTable)
    Set rsClassOfStaCod = dbJet.OpenRecordset("IbfsClassOfStationCode", dbOpenTable)

    Set rsSiteSat = dbJet.OpenRecordset("SiteSat", dbOpenTable)

    Set rsMfgModList = dbJet.OpenRecordset("MfgModList", dbOpenTable)
    
    
    Set rsSiteInfo = dbJet.OpenRecordset("SiteInfo", dbOpenTable)
    
    Set rsPathRecord = dbJet.OpenRecordset("PathRecord", dbOpenTable)

    gxBeginDateTime = Now
    glBeginSeconds = GetTickCount()
    DoEvents

    Set rsSQL = dbJet.OpenRecordset(gtSql, dbOpenSnapshot)
    rsSQL.MoveLast
    glNumRecs = rsSQL.RecordCount
    rsSQL.MoveFirst
    'MsgBox Str(glNumRecs), , "glNumRecs"
    DoEvents

    frmStatus.lblStatus.Caption = "Populating MFF tables." & vbCrLf & "Please wait . . . . "
    frmStatus.lblStepCurrent.Caption = Str(giActionCounter)
    frmStatus.Refresh
    
    glRecCnt = 0
    frmStatus.lblTotalRecords.Caption = Format(glNumRecs, "###,##0")
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,##0")
    DoEvents
    
    gtPathSiteKey = "*^*"
    
    gtCallSign = "^*^"
    glSiteKey = 0
    glAntennaKey = 0
    gtPathSiteKey = "^*^"
    gtPathAntKey = "^*^"
    gtFrequencyLower = "^*^"
    gtFrequencyUpper = "^*^"
    gtTransModeFix = "^*^"

    giCntPath = 0
    giCntAnt = 0

    gtCallSignPre = "^*^"
    glSiteKeyPre = 0
    glAntennaKeyPre = 0
    gtPathSiteKeyPre = "^*^"
    gtPathAntKeyPre = "^*^"
    gtFrequencyLowerPre = "^*^"
    gtFrequencyUpperPre = "^*^"
    gtTransModeFixPre = "^*^"
    
    glFilingKeyPre = 0
    glFrequencyKeyPre = 0

    glFreqRecCnt = 0

    giTxEsCoordCnt = 0
    giRxEsCoordCnt = 0

    giEmissionFlag = 0
    giEmissionCnt = 0

    glFreqRecCnt = 1

    Do Until rsSQL.EOF
        
        glRecCnt = glRecCnt + 1
        If ((glRecCnt Mod 10) = 0) Then
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,##0")
            gsTemp = (glRecCnt / glNumRecs) * 100
            If (gsTemp >= 100) Then gsTemp = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsTemp, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsTemp
            DoEvents
        End If

        Call DecodeMainTbl

        If (gtFilingState = "2") Then GoTo SkipRecord

        Call DecodeSiteTbl
        Call DecodeAntennaTbl
        Call DecodeAntennaGainTbl
        Call DecodeFrequencyTbl
        Call DecodeFreqCoordTbl
        Call DecodeAddressTbl
        Call DecodeForm312Tbl
        
        Call DecodePtcomm
        Call DecodeSpaceStationTbl
    
        'Call DecodeSpaceStationVia214Tbl
        
        Select Case gtAppTypeCode
            Case Is = "AMD"    '  Licensed
                Select Case gtFilingState
                    Case Is = "0"    '  Pending
                        gtStatusCode = "6"
                    Case Is = "1"    '  Granted
                        gtStatusCode = "9"
                    Case Is = "3"    '  Tendered
                        gtStatusCode = "6"
                    Case Else
                        gtStatusCode = "0"
                End Select
            Case Is = "LIC"    '  Licensed
                Select Case gtFilingState
                    Case Is = "0"    '  Pending
                        gtStatusCode = "6"
                    Case Is = "1"    '  Granted
                        gtStatusCode = "9"
                    Case Is = "3"    '  Tendered
                        gtStatusCode = "6"
                    Case Else
                        gtStatusCode = "0"
                End Select
            Case Is = "MOD"    '  Modification
                Select Case gtFilingState
                    Case Is = "0"    '  Pending
                        gtStatusCode = "6"
                    Case Is = "1"    '  Granted
                        gtStatusCode = "9"
                    Case Is = "3"    '  Tendered
                        gtStatusCode = "6"
                    Case Else
                        gtStatusCode = "0"
                End Select
            Case Is = "REG"    '  Registered
                Select Case gtFilingState
                    Case Is = "0"    '  Pending
                        gtStatusCode = "6"
                    Case Is = "1"    '  Granted
                        gtStatusCode = "9"
                    Case Is = "3"    '  Tendered
                        gtStatusCode = "6"
                    Case Else
                        gtStatusCode = "0"
                End Select
            Case Is = "RWL"    '  Renewal
                Select Case gtFilingState
                    Case Is = "0"    '  Pending
                        gtStatusCode = "6"
                    Case Is = "1"    '  Granted
                        gtStatusCode = "9"
                    Case Is = "3"    '  Tendered
                        gtStatusCode = "6"
                    Case Else
                        gtStatusCode = "0"
                End Select
            Case Is = "STA"    '  Special Temperary Authority
                Select Case gtFilingState
                    Case Is = "0"    '  Pending
                        gtStatusCode = "6"
                    Case Is = "1"    '  Granted
                        gtStatusCode = "8"
                    Case Is = "3"    '  Tendered
                        gtStatusCode = "6"
                    Case Else
                        gtStatusCode = "0"
                End Select
            Case Else    '  Status unknown
                gtStatusCode = "0"
        End Select

        Call WriteLiceTable

        gtCallSign = rsSQL!CallSign
        glSiteKey = rsSQL!SiteKey
        gtTransModeFix = rsSQL!TransModeFix
        glAntennaKey = rsSQL!AntennaKey

        If (rsSQL!CallSign = gtCallSignPre) Then
            
            If (rsSQL!SiteKey = glSiteKeyPre) Then
                If (glAntennaKey = glAntennaKeyPre) Then
                Else
                    giCntAnt = giCntAnt + 1
                End If
            Else
                giCntPath = giCntPath + 1
                giCntAnt = 1
            End If
        
        Else
            '  Reset
            giCntPath = 1
            giCntAnt = 1

        End If

                '"0.00; -0.00; 0.00"
        
        gtPathSiteKey = "IB" & Trim(Format(rsSQL!FilingKey, "0000000000;-000000000;0000000000")) & "~" & _
                        Format(giCntPath, "00") & gtTransModeFix
        
        gtPathAntKey = "IB" & Trim(Format(rsSQL!FilingKey, "0000000000;-000000000;0000000000")) & "~" & _
                        Format(giCntPath, "00") & "~" & _
                        Format(giCntAnt, "00") & gtTransModeFix

        gtMsg = "CallSign:  " & rsSQL!CallSign & "  /  " & gtCallSignPre & vbCrLf & _
                "SiteKey:  " & Str(rsSQL!SiteKey) & "  /  " & Str(glSiteKeyPre) & vbCrLf & _
                "AntennaKey:  " & Str(rsSQL!AntennaKey) & "  /  " & Str(glAntennaKeyPre) & vbCrLf & _
                "PathSiteKey:  " & gtPathSiteKey & vbCrLf & _
                "PathAntKey:  " & gtPathAntKey

        'MsgBox gtMsg, , "In ES Populate Mff Tables"
        'DoEvents

        Call EsWriteSiteAntTables
        
        Call DecodeNatureOfServiceTbl
        
        Call EsWriteFreqTable

        'Call EsWriteFreqTable_Mod

        Call EsWriteSpcCndAntTable
        Call EsWriteSpcCndFreqTable
        Call EsWriteSpcCndLiceTable
        Call EsWriteSpcCndSiteTable

        Call WriteMfgModList("A", gtAntMfg, gtAntMod)

SkipRecord:

        gtCallSignPre = rsMainTbl!CallSign
        glFilingKeyPre = glFilingKey
        glSiteKeyPre = glSiteKey
        gtTransModeFixPre = gtTransModeFix
        glAntennaKeyPre = glAntennaKey
        glFrequencyKeyPre = glFrequencyKey

        gtPathSiteKeyPre = gtPathSiteKey
        gtPathAntKeyPre = gtPathAntKey

        rsSQL.MoveNext

    Loop

    Close (giIDFF)
    
            DoEvents

    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
            gsTemp = (glRecCnt / glNumRecs) * 100
            If (gsTemp >= 100) Then gsTemp = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsTemp, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsTemp
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,##0")
    DoEvents

    Call WriteProcessLog

    rsMainTbl.Close
    Set rsMainTbl = Nothing
    
    rsProcessLog.Close
    Set rsProcessLog = Nothing
    
    dbJet.Close

    'gtCompactMsg = "Compacting Database - Populating MFF tables."
    'Call CompactDB
    frmStatus.lblStatus.Caption = "Finished Populating MFF tables !"
    frmStatus.Refresh

    Exit Sub

EsPopulateMffTablesErr:

    gtMsg = "Error in EsPopulateMffTables" & vbCrLf
    gtMsg = gtMsg & "Error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    'Print #giBadDataFF, gtMsg
    MsgBox gtMsg

End Sub    '  EsPopulateMffTables

Sub FxPopulateSiteTables()

    gtSql = "SELECT Main.FilingKey, Main.CallSign, Main.FileNumber, Main.AppTypeCode, Main.DateGrant, Main.DateExpire, " & _
            "Address.AddressKey, Contact.ContactKey, " & _
            "Site.SiteKey, " & _
            "Antenna.AntennaKey, Antenna.AntennaId, " & _
            "Frequency.FrequencyKey, Frequency.TransModeFix, Frequency.FrequencyLower, Frequency.FrequencyUpper, Frequency.PolarizationCode, Frequency.Emission " & _
            "FROM ((Main INNER JOIN Site ON Main.FilingKey = Site.FilingKey) INNER JOIN Antenna ON Site.SiteKey = Antenna.SiteKey) INNER JOIN Frequency ON Antenna.AntennaKey = Frequency.AntennaKey " & _
            "Where (((Main.FilingState) = " & Chr(34) & "0" & Chr(34) & " Or (Main.FilingState) = " & Chr(34) & "1" & Chr(34) & ") And ((Main.SubsystemCode) = " & Chr(34) & "SES" & Chr(34) & " Or (Main.SubsystemCode) = " & Chr(34) & "SAT" & Chr(34) & ")) " & _
            "ORDER BY Main.CallSign, Main.FileNumber"

    gtSql = "SELECT IbfsMain.FilingKey, IbfsAddress.AddressKey, IbfsContact.ContactKey, IbfsSite.SiteKey, IbfsAntenna.AntennaKey, IbfsFrequency.FrequencyKey " & _
            "FROM ((((IbfsMain INNER JOIN IbfsSite ON IbfsMain.FilingKey = IbfsSite.FilingKey) INNER JOIN IbfsAntenna ON IbfsSite.SiteKey = IbfsAntenna.SiteKey) INNER JOIN IbfsFrequency ON Antenna.AntennaKey = IbfsFrequency.AntennaKey) INNER JOIN IbfsAddress ON IbfsMain.AddressKey = IbfsAddress.AddressKey) INNER JOIN IbfsContact ON IbfsMain.ContactKey = IbfsContact.ContactKey " & _
            "Where (((Main.FilingState) = " & Chr(34) & "0" & Chr(34) & " Or (Main.FilingState) = " & Chr(34) & "1" & Chr(34) & ") And ((Main.SubsystemCode) = " & Chr(34) & "SES" & Chr(34) & " Or (Main.SubsystemCode) = " & Chr(34) & "SAT" & Chr(34) & ")) " & _
            "ORDER BY Main.CallSign, Site.SiteKey, Antenna.AntennaKey, Frequency.FrequencyKey"
        'MsgBox gtSql
        'DoEvents

    Set dbJet = wsJet.OpenDatabase(gtOutputPathAndFilename)
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    
    Set rsMainTbl = dbJet.OpenRecordset("IbfsMain", dbOpenTable)
    Set rsAddressTbl = dbJet.OpenRecordset("IbfsAddress", dbOpenTable)
    Set rsContactTbl = dbJet.OpenRecordset("IbfsContact", dbOpenTable)
    Set rsSiteTbl = dbJet.OpenRecordset("IbfsSite", dbOpenTable)
    Set rsAntennaTbl = dbJet.OpenRecordset("IbfsAntenna", dbOpenTable)
    Set rsAntennaGainTbl = dbJet.OpenRecordset("IbfsAntennaGain", dbOpenTable)
    'Set rsAntennaTblConditionTbl = dbJet.OpenRecordset("IbfsAntennaTypeCodeMain", dbOpenTable)
    Set rsFrequencyTbl = dbJet.OpenRecordset("IbfsFrequency", dbOpenTable)
    'Set rsSpaceStationTbl = dbJet.OpenRecordset("IbfsSpaceStation", dbOpenTable)
    'Set rsPtCommTbl = dbJet.OpenRecordset("IbfsPtComm", dbOpenTable)

    Set rsLice = dbJet.OpenRecordset("Lice", dbOpenTable)
    Set rsFreq = dbJet.OpenRecordset("Freq", dbOpenTable)
    Set rsSiteInfo = dbJet.OpenRecordset("SiteTx", dbOpenTable)
    'Set rsSiteTblSpace = dbJet.OpenRecordset("SiteSpace", dbOpenTable)
    Set rsSiteInfo = dbJet.OpenRecordset("SiteRx", dbOpenTable)

    Set rsSpcCndAnt = dbJet.OpenRecordset("SpcCndAnt", dbOpenTable)
    Set rsSpcCndFreq = dbJet.OpenRecordset("SpcCndFreq", dbOpenTable)
    Set rsSpcCndLice = dbJet.OpenRecordset("SpcCndLice", dbOpenTable)
    Set rsSpcCndSite = dbJet.OpenRecordset("SpcCndSite", dbOpenTable)

    gxBeginDateTime = Now
    glBeginSeconds = GetTickCount()
    DoEvents
    
    frmStatus.lblStatus.Caption = "Creating SQL record set!  PLEASE wait, this will take some time . . . . "
    frmStatus.lblStepCurrent.Caption = Str(giActionCounter)
    frmStatus.Refresh
    
    Set rsSQL = dbJet.OpenRecordset(gtSql, dbOpenSnapshot)
    rsSQL.MoveLast
    glNumRecs = rsSQL.RecordCount
    rsSQL.MoveFirst
    DoEvents
    
    frmStatus.lblStatus.Caption = "Populating MFF tables.  Please wait . . . . "
    DoEvents
    
    glRecCnt = 0
    frmStatus.lblTotalRecords.Caption = Format(glNumRecs, "###,##0")
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,##0")
    DoEvents
    
    gtCallSign = "*^*"
    gtPathSiteKey = "*^*"
    gtSiteKey = "*^*"
    giCntPath = 0
    giCntSite = 0
    
    glFilingKeyPre = 0
    glSiteKeyPre = 0
    glAntennaKeyPre = 0
    glFrequencyKeyPre = 0

    glFreqRecCnt = 0
    
    Do Until rsSQL.EOF
        
        glRecCnt = glRecCnt + 1
        If ((glRecCnt Mod 10) = 0) Then
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,##0")
            gsTemp = (glRecCnt / glNumRecs) * 100
            If (gsTemp >= 100) Then gsTemp = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsTemp, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsTemp
            DoEvents
        End If

        rsMainTbl.Index = "idxFilingKey"
        rsMainTbl.Seek "=", rsSQL!FilingKey

        rsAddressTbl.Index = "idxAddressKey"
        rsAddressTbl.Seek "=", rsSQL!AddressKey

        'gtAddressKey = "IB" & Trim(Format(rsSQL!FilingKey, "0000000000;-000000000;0000000000"))

        If (Mid(rsAddressTbl!AddressId, 1, 2) = "IB") Then
            gtLicenseeIdKey = Trim(rsAddressTbl!AddressId)
        Else
            gtLicenseeIdKey = "IB~" & Trim(rsAddressTbl!AddressId)
        End If
'yyyy
        rsContactTbl.Index = "idxContactKey"
        rsContactTbl.Seek "=", rsSQL!ContactKey

        rsSiteTbl.Index = "idxSiteKey"
        rsSiteTbl.Seek "=", rsSQL!SiteKey

        rsAntennaTbl.Index = "idxAntennaKey"
        rsAntennaTbl.Seek "=", rsSQL!AntennaKey

        rsFrequencyTbl.Index = "idxFrequencyKey"
        rsFrequencyTbl.Seek "=", rsSQL!FrequencyKey
        
        Call WriteLiceTable

        gtCallSign = rsMainTbl!CallSign
        If (gtCallSign <> gtCallSignPre) Then
            giCntPath = 0
            giCntSite = 0
        End If

        glSiteKey = rsSQL!SiteKey
        If (glSiteKey <> glSiteKeyPre) Then
            giCntSite = giCntSite + 1
            giCntPath = 0
        Else
            giCntSite = giCntSite
            giCntPath = giCntPath
        End If
        gtSiteKey = gtCallSign & "~" & Format(giCntSite, "00")

        glAntennaKey = rsSQL!AntennaKey
        If (glAntennaKey <> glAntennaKeyPre) Then
            giCntPath = giCntPath + 1
        Else
            giCntPath = giCntPath
        End If
        'gtPathSiteKey = gtCallSign & "~" & Format(giCntPath, "00")
        
        'gtPathSiteKey = "IB" & Format(rsSQL!FilingKey, "00000000000") & "~" & _
                        Format(giCntPath, "00")
        
        gtPathSiteKey = "IB" & Trim(Format(rsSQL!FilingKey, "0000000000;-000000000;0000000000")) & "~" & _
                        Format(giCntPath, "00") & gtTransModeFix

        Call EsWriteSiteAntTables

        gtCallSignPre = rsMainTbl!CallSign
        glFilingKeyPre = glFilingKey
        glSiteKeyPre = glSiteKey
        glAntennaKeyPre = glAntennaKey
        glFrequencyKeyPre = glFrequencyKey

        rsSQL.MoveNext

    Loop
    Close (giIDFF)
    
    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    DoEvents

    gtActionText = "PopulateMainTable:  " & gtInputFileName
    'call WriteStatus
        
    rsMainTbl.Close
    Set rsMainTbl = Nothing
    
    rsProcessLog.Close
    Set rsProcessLog = Nothing
    dbJet.Close

    Exit Sub
    
PopulateMffTablesTerrestrialErr:
    
    gtMsg = "Error in PopulateMffTablesTerrestrial" & vbCrLf
    gtMsg = gtMsg & "Error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    'Print #giBadDataFF, gtMsg
    MsgBox gtMsg

End Sub    '  PopulateMffTablesTerrestrial

Sub WriteLiceTable()

    If (IsNull(rsAddressTbl!AddressId)) Then
        MsgBox "Null in WriteLiceTable"
    End If

    rsLice.Index = "idxLicenseeIdKey"
    rsLice.Seek "=", Trim(gtLicenseeIdKey)
    If (rsLice.NoMatch) Then
        'MsgBox "Record NOT Found"
        '  No record found
        BeginTrans
        rsLice.AddNew
            rsLice!LicenseeIdKey = Trim(gtLicenseeIdKey)
            'rsLice!LiceTin = ""
            rsLice!LiceName = gtLiceName
            rsLice!LiceDBA = Mid(gtLiceDBA, 1, 40)
            rsLice!LiceStreet2 = gtLiceStreet2
            rsLice!LiceStreet1 = Mid(gtLiceStreet1, 1, 60)
            'rsLice!LicePOB = ""
            rsLice!LiceCity = Mid(gtLiceCity, 1, 20)
            rsLice!LiceState = gtLiceState
            rsLice!LiceZipCode = gtLiceZipCode
            rsLice!LiceCountry = gtLiceCountry
            rsLice!LicePhone = gtLicePhone
            rsLice!LiceFax = gtLiceFaxNum
            rsLice!LiceEmail = gtLiceEmail
            rsLice!LiceAttn = gtLiceAttn
            rsLice!LiceType = gtLiceType
            rsLice!EntityType = "L"
            If (Len(Trim((gtLiceFrn))) > 0) Then
                rsLice!FccRegNum = gtLiceFrn
            End If
        rsLice.Update
        CommitTrans
        DoEvents
    Else
            'MsgBox "record found"
        '  Record found
    End If

End Sub    '  WriteLiceTable

Sub EsWriteSiteAntTables()

    gtTxStationClass = ""
    gtRxStationClass = ""

    gtTxEsCoordFlag = "0"
    gtRxEsCoordFlag = "0"

    If (rsFrequencyTbl!TransModeFix = "T") Then
        
        ' ==>  Site TX  <==
        
        gtClassOfStationCode = rsMainTbl!ClassOfStationCode
        
        rsClassOfStaCod.Index = "idxClassOfStationCode"
        rsClassOfStaCod.Seek "=", Trim(gtClassOfStationCode)
        If (Not rsClassOfStaCod.NoMatch) Then
            'Record found
            gtTxStationClass = rsClassOfStaCod!ClassOfStationCode
        Else
            gtTxStationClass = "IBU"
        End If

        GoTo SkipTxSiteInfo
        
        rsSiteInfo.Index = "idxPathSiteKey"
        rsSiteInfo.Seek "=", gtPathSiteKey
        If (rsSiteInfo.NoMatch) Then
            'MsgBox "Transmitter record not found!"
            'DoEvents
            BeginTrans
            rsSiteInfo.AddNew
            rsSiteInfo!PathSiteKey = gtPathSiteKey
            rsSiteInfo!LocationKey = "IB" & Trim(Format(glSiteKey, "0000000000;-000000000;0000000000"))
            rsSiteInfo!CallSign = gtCallSign
            'rsSiteInfo!FacIdNum = x
            rsSiteInfo!TowerReg = gtTowerReg
            rsSiteInfo!StructureType = ""
            
            'Select Case gtSatOrbitType
            '    Case Is = "G"
            '        gtTxStationClass = gtTxStationClass & "G"   ' "TC"
            '    Case Is = "N"
            '        gtTxStationClass = gtTxStationClass & "N"   ' "TC"
            '    Case Else
            '        gtTxStationClass = gtTxStationClass    ' "TC"
            'End Select
            
            rsSiteInfo!ClassStation = gtTxStationClass

            rsSiteInfo!Name = gtSiteId
            rsSiteInfo!Street = Mid(gtSiteStreet, 1, 80)
            rsSiteInfo!City = gtSiteCity
            rsSiteInfo!County = gtSiteCounty
            rsSiteInfo!State = gtSiteState
            rsSiteInfo!Country = "USA"
        
            If (Mid(gtSiteLatDMS, 2, 9) = "0000000.0") Then
            Else
                rsSiteInfo!LatDMS = gtSiteLatDMS     '  10)
            End If
            rsSiteInfo!LatSec = gtSiteLatSec
            If (Mid(gtSiteLonDMS, 2, 9) = "0000000.0") Then
            Else
                rsSiteInfo!LonDMS = gtSiteLonDMS        '  10)
            End If
            rsSiteInfo!LonSec = gtSiteLonSec
            
            'rsSiteInfo!LatDMSHi = ""
            'rsSiteInfo!LatSecHi = ""
            'rsSiteInfo!LonDMSHi = ""
            'rsSiteInfo!LonSecHi = ""
            rsSiteInfo!HorizDatum = gtSiteDatum
            rsSiteInfo!Nepa = gtEnvironEffectSw
            'rsSiteInfo!RadOfOp = ""
            rsSiteInfo!GrEl = gtSiteElevation
            rsSiteInfo!HgtStructure = gtHeightBldgAgl
            rsSiteInfo!HgtToTip = gtHeightMaxAgl
            rsSiteInfo.Update
            CommitTrans
            DoEvents
        Else
            'MsgBox "Transmitter record found!"
            'DoEvents
        End If

SkipTxSiteInfo:

        rsAntMain.Index = "idxPathAntKey"
        rsAntMain.Seek "=", gtPathAntKey
        If (rsAntMain.NoMatch) Then
            BeginTrans
            rsAntMain.AddNew
            rsAntMain!PathAntKey = gtPathAntKey
            rsAntMain!AntennaKey = "IB" & Trim(Format(glAntennaKey, "0000000000;-000000000;0000000000"))
            rsAntMain!LocationKey = "IB" & Trim(Format(glSiteKey, "0000000000;-000000000;0000000000"))
            rsAntMain!CallSign = gtCallSign
            
            If (Val(gtDiameterMajor) > Val(gtDiameter)) Then
                gsTxAntHgt = Val(gtHeightMaxAgl) - (Val(gtDiameterMajor) / 2)
            Else
                gsTxAntHgt = Val(gtHeightMaxAgl) - (Val(gtDiameter) / 2)
            End If
            gtTxAntHgt = Format(gsTxAntHgt, "0000.0; 000.0;0000.0")
            rsAntMain!AntHgt = gtTxAntHgt    '  Height to center of final radiating element AGL
            rsAntMain!AntPlr = gtPolarizationCode
            'rsAntMain!AntAzi = ""
            'rsAntMain!AntTlt = ""
            rsAntMain!AntMfg = gtAntMfg
            rsAntMain!AntMod = gtAntMod
            'rsAntMain!AntRPE = ""
            rsAntMain!AntGn = gtAntGn
            'rsAntMain!AntBw = ""
            If (Val(gtDiameterMajor) > Val(gtDiameter)) Then
                gtTxAntSize = gtDiameterMajor
            Else
                gtTxAntSize = gtDiameter
            End If
            rsAntMain!AntSize = gtTxAntSize
            rsAntMain.Update
            CommitTrans
            DoEvents
        End If

        If (Val(gtFreqLimitLow) > 0) Then
                gtTxEsCoordFlag = "1"

            If (gtPathSiteKey = gtPathSiteKeyPre) Then
                giTxEsCoordCnt = giTxEsCoordCnt + 1
            Else
                giTxEsCoordCnt = 1
            End If
            'rsSiteEsCoord.Index = "idxPathAntKey"
            'rsSiteEsCoord.Seek "=", gtPathAntKey
            'If (rsSiteEsCoord.NoMatch) Then
                BeginTrans
                rsSiteEsCoord.AddNew
                rsSiteEsCoord!PathAntKey = gtPathAntKey
                rsSiteEsCoord!Seq = giTxEsCoordCnt
                'rsSiteEsCoord!AntennaKey = "IB" & Trim(Format(AntennaKey, "0000000000;-000000000;0000000000"))
                rsSiteEsCoord!CallSign = rsMainTbl!CallSign
                rsSiteEsCoord!AzimuthEast = gtAzimuthEast
                rsSiteEsCoord!AzimuthWest = gtAzimuthWest
                rsSiteEsCoord!ElevationEast = gtElevationEast
                rsSiteEsCoord!ElevationWest = gtElevationWest
                rsSiteEsCoord!FreqLimitLow = gtFreqLimitLow
                rsSiteEsCoord!FreqLimitHigh = gtFreqLimitHigh
                rsSiteEsCoord!HorizMaxDensity = gtHorizMaxDensity
                rsSiteEsCoord!SatArcEast = gtSatArcEast
                rsSiteEsCoord!SatArcWest = gtSatArcWest
                rsSiteEsCoord!SatHemiEast = gtSatHemiEast
                rsSiteEsCoord!SatHemiWest = gtSatHemiWest
                rsSiteEsCoord!SatOrbitType = gtSatOrbitType
                rsSiteEsCoord.Update
                CommitTrans
                DoEvents
            'Else
            '    MsgBox ("Dup SiteEsCoord record:" & gtPathAntKey), , "in ES Write Site Ant Tables"
            '    DoEvents
            'End If
        End If

        gtTxTowerReg = gtTowerReg
        gtTxLocationKey = "IB" & Trim(Format(glSiteKey, "0000000000;-000000000;0000000000"))
        gtTxAntennaKey = "IB" & Trim(Format(glAntennaKey, "0000000000;-000000000;0000000000"))
        gtTxCall = gtCallSign
        If (Len(Trim(gtTxStationClass)) = 0) Then
            gtTxStationClass = " "
        Else
            gtTxStationClass = gtTxStationClass
        End If
        gtSiteTowerReg = gtTowerReg

        gtTxAntSiteKey = gtSiteAntSiteKey
        'gtRxAntSiteKey = ""

        Call WriteSiteInfo
        gtAntSiteKey = gtSiteAntSiteKey
        Call WriteAntSiteCallSign
        
        Call WritePathKey

    Else

        ' ==>  Site RX  <==
        
        gtClassOfStationCode = rsMainTbl!ClassOfStationCode
        rsClassOfStaCod.Index = "idxClassOfStationCode"
        rsClassOfStaCod.Seek "=", Trim(gtClassOfStationCode)
        If (Not rsClassOfStaCod.NoMatch) Then
            'Record found
            gtRxStationClass = rsClassOfStaCod!ClassOfStationCode
        Else
            gtRxStationClass = "IBU"
        End If

        GoTo SkipRxSiteInfo
        
        rsSiteInfo.Index = "idxPathSiteKey"
        rsSiteInfo.Seek "=", gtPathSiteKey
        If (rsSiteInfo.NoMatch) Then
            'MsgBox "Receiver record not found!"
            BeginTrans
            rsSiteInfo.AddNew
            rsSiteInfo!PathSiteKey = gtPathSiteKey
            rsSiteInfo!LocationKey = "IB" & Trim(Format(glSiteKey, "0000000000;-000000000;0000000000"))
            rsSiteInfo!CallSign = gtCallSign
            'rsSiteInfo!FacIdNum = x
            rsSiteInfo!TowerReg = gtTowerReg
            rsSiteInfo!StructureType = ""

            Select Case gtSatOrbitType
                Case Is = "G"
                    gtRxStationClass = gtRxStationClass & "G"   ' "TC"
                Case Is = "N"
                    gtRxStationClass = gtRxStationClass & "N"   ' "TC"
                Case Else
                    gtRxStationClass = gtRxStationClass   ' "TC"
            End Select
            'rsSiteInfo!ClassStation = gtRxStationClass
            
            rsSiteInfo!Name = gtSiteId
            rsSiteInfo!Street = Mid(gtSiteStreet, 1, 80)
            rsSiteInfo!City = gtSiteCity
            rsSiteInfo!County = gtSiteCounty
            rsSiteInfo!State = gtSiteState
            rsSiteInfo!Country = "USA"
            rsSiteInfo!LatDMS = gtSiteLatDMS
            rsSiteInfo!LatSec = gtSiteLatSec
            rsSiteInfo!LonDMS = gtSiteLonDMS
            rsSiteInfo!LonSec = gtSiteLonSec
            'rsSiteInfo!LatDMSHi = ""
            'rsSiteInfo!LatSecHi = ""
            'rsSiteInfo!LonDMSHi = ""
            'rsSiteInfo!LonSecHi = ""
            rsSiteInfo!HorizDatum = gtSiteDatum
            rsSiteInfo!Nepa = gtEnvironEffectSw
            'rsSiteInfo!RadOfOp = ""
            rsSiteInfo!GrEl = gtSiteElevation
            rsSiteInfo!HgtStructure = gtHeightBldgAgl
            rsSiteInfo!HgtToTip = gtHeightMaxAgl
            rsSiteInfo.Update
            CommitTrans
            DoEvents
        End If

SkipRxSiteInfo:

        rsAntMain.Index = "idxPathAntKey"
        rsAntMain.Seek "=", gtPathAntKey
        If (rsAntMain.NoMatch) Then
            BeginTrans
            rsAntMain.AddNew
            rsAntMain!PathAntKey = gtPathAntKey
            rsAntMain!AntennaKey = "IB" & Trim(Format(glAntennaKey, "0000000000;-000000000;0000000000"))
            rsAntMain!LocationKey = "IB" & Trim(Format(glSiteKey, "0000000000;-000000000;0000000000"))
            rsAntMain!CallSign = gtCallSign
            
            If (Val(gtDiameterMajor) > Val(gtDiameter)) Then
                gsRxAntHgt = Val(gtHeightMaxAgl) - (Val(gtDiameterMajor) / 2)
            Else
                gsRxAntHgt = Val(gtHeightMaxAgl) - (Val(gtDiameter) / 2)
            End If
            gtRxAntHgt = Trim(Format(gsRxAntHgt, "0000.0; 000.0;0000.0"))

            rsAntMain!AntHgt = gtRxAntHgt
            rsAntMain!AntPlr = gtPolarizationCode
            'rsAntMain!AntAzi = ""
            'rsAntMain!AntTlt = ""
            rsAntMain!AntMfg = gtAntMfg
            rsAntMain!AntMod = gtAntMod
            'rsAntMain!AntRPE = ""
            rsAntMain!AntGn = gtAntGn
            'rsAntMain!AntBw = ""
            If (Val(gtDiameterMajor) > Val(gtDiameter)) Then
                gtRxAntSize = gtDiameterMajor
            Else
                gtRxAntSize = gtDiameter
            End If
            rsAntMain!AntSize = gtRxAntSize
            rsAntMain.Update
            CommitTrans
            DoEvents
        End If
        
        If (Val(gtFreqLimitLow) > 0) Then
            
            gtRxEsCoordFlag = "1"
    
            If (gtPathSiteKey = gtPathSiteKeyPre) Then
                giRxEsCoordCnt = giRxEsCoordCnt + 1
            Else
                giRxEsCoordCnt = 1
            End If

            'rsSiteEsCoord.Index = "idxPathAntKey"
            'rsSiteEsCoord.Seek "=", gtPathAntKey
            'If (rsSiteEsCoord.NoMatch) Then
                BeginTrans
                rsSiteEsCoord.AddNew
                rsSiteEsCoord!PathAntKey = gtPathAntKey
                rsSiteEsCoord!Seq = giRxEsCoordCnt
                'rsSiteEsCoord!AntennaKey = "IB" & Trim(Format(AntennaKey, "0000000000;-000000000;0000000000"))
                rsSiteEsCoord!CallSign = gtCallSign
                rsSiteEsCoord!AzimuthEast = gtAzimuthEast
                rsSiteEsCoord!AzimuthWest = gtAzimuthWest
                rsSiteEsCoord!ElevationEast = gtElevationEast
                rsSiteEsCoord!ElevationWest = gtElevationWest
                rsSiteEsCoord!FreqLimitLow = gtFreqLimitLow
                rsSiteEsCoord!FreqLimitHigh = gtFreqLimitHigh
                'rsSiteEsCoord!HorizMaxDensity = gtHorizMaxDensity
                rsSiteEsCoord!SatArcEast = gtSatArcEast
                rsSiteEsCoord!SatArcWest = gtSatArcWest
                rsSiteEsCoord!SatHemiEast = gtSatHemiEast
                rsSiteEsCoord!SatHemiWest = gtSatHemiWest
                rsSiteEsCoord!SatOrbitType = gtSatOrbitType
                rsSiteEsCoord.Update
                CommitTrans
                DoEvents
                
                'MsgBox "pause in rsSiteEsCoord"
                'DoEvents
            'Else
            '    MsgBox ("Dup Site Rx Coord record: " & gtPathAntKey), , "in ES Write Site Ant Tables"
            '    DoEvents
            'End If
        End If

        gtRxTowerReg = gtTowerReg
        gtRxLocationKey = "IB" & Trim(Format(glSiteKey, "0000000000;-000000000;0000000000"))
        gtRxAntennaKey = "IB" & Trim(Format(glAntennaKey, "0000000000;-000000000;0000000000"))
        gtRxCall = gtCallSign

        If (Len(Trim(gtRxStationClass)) = 0) Then
            gtRxStationClass = " "
        Else
            gtRxStationClass = gtRxStationClass
        End If

        gtRxStationClass = gtRxStationClass

        gtSiteTowerReg = gtTowerReg
        
        'gtTxAntSiteKey = ""
        gtRxAntSiteKey = gtSiteAntSiteKey

        Call WriteSiteInfo
        gtAntSiteKey = gtSiteAntSiteKey
        Call WriteAntSiteCallSign
        
        Call WritePathKey
    
    End If

    rsSiteSat.Index = "idxPathSiteKey"
    rsSiteSat.Seek "=", gtPathSiteKey
    If (rsSiteEsCoord.NoMatch) Then
        BeginTrans
        rsSiteSat.AddNew
        rsSiteSat!PathSiteKey = gtPathSiteKey
        rsSiteSat!SatOrbitType = gtSatOrbitType
        rsSiteSat!OrbitLocation = gtOrbitLocation
        rsSiteSat!UsName = gtUsName
        rsSiteSat.Update
        CommitTrans
        DoEvents
    End If

    'MsgBox (gtAntMfg & vbCrLf & gtAntMod)
    'DoEvents

End Sub    '  EsWriteSiteAntTables

Sub EsWriteFreqTable()

        glFreqRecCnt = glFreqRecCnt + 1
        gtFreqKey = "IB" & Trim(Format(glFreqRecCnt, "00000000"))
        DoEvents

'MsgBox ("gtAddressFrn = " & gtAddressFrn), , "EsWriteFreqTable"
'DoEvents

        If (gtAddressFrn <> "0000000000") Then
            giAddressFlag = 1
        Else
            giAddressFlag = 0
        End If

'MsgBox ("gtContactFrn = " & gtContactFrn), , "EsWriteFreqTable"
'DoEvents
        
        If (gtContactFrn <> "0000000000") Then
            giContactFlag = 1
        Else
            giContactFlag = 0
        End If

        If (Len(Trim(gtAddressFrn)) = 0) Then
            gtFccRegNum = gtContactFrn
        Else
            gtFccRegNum = gtAddressFrn
        End If

'MsgBox ("gtAddressFrn = " & gtAddressFrn & vbCrLf & "gtContactFrn = " & gtContactFrn & vbCrLf & "gtFccRegNum = " & gtFccRegNum)
'DoEvents

        gtAddressFrn = ""
        gtContactFrn = ""
        
        BeginTrans
        rsFreq.AddNew
        rsFreq!FreqKey = gtFreqKey
        rsFreq!CsFnKey = gtCallSign
        rsFreq!PathSiteKey = gtPathSiteKey
        rsFreq!PathAntKey = gtPathAntKey
        rsFreq!LicenseeIdKey = Trim(gtLicenseeIdKey)
        'rsFreq!EquipKey = ""
        'rsFreq!WebIndexKey = ""
        rsFreq!FccRegNum = gtFccRegNum
        
        rsFreq!UniqueSystemIdentifier = glFilingKey
        rsFreq!FreqC = gtFrequencyLower
        rsFreq!FreqL = gtFrequencyLower
        rsFreq!FreqU = gtFrequencyUpper
        'rsFreq!ChannelNum = ""
        rsFreq!EmissionDesignator1 = Mid(gtEmission, 1, 7)
        'rsFreq!EmissionDesignator2 = ""
        'rsFreq!EmissionDesignator3 = ""
        'rsFreq!EmissionDesignator4 = ""

        'rsFreq!CarsEmissionCode = ""

        rsFreq!TxClassStation = gtTxStationClass    '  dbText, 4)
        rsFreq!RxClassStation = gtRxStationClass    '  dbText, 4)

        'rsFreq!FreqTol = ""
        'rsFreq!DigitalRate = ""
        'rsFreq!DigitalMod = x
        'rsFreq!OutputPwr = x
        'rsFreq!LineLoss = x
        'rsFreq!AntInputPwr = x
        rsFreq!TxEirp = Format(gtEirp, "0000.0; 000.0;0000.0")
        rsFreq!TxEirpUnit = "W"
        'rsFreq!SigLevel = x
        'rsFreq!LineLoss = x
        rsFreq!DateApp = gtDateFiled
        'rsFreq!DateFirstUse = x
        'rsFreq!DateIssue = x
        rsFreq!DateExpire = gtDateExpire
        rsFreq!AppFileNum = Trim(gtFileNumber)
        'rsFreq!PnFileNo = x
        rsFreq!FccRadSvc = gtRadSvc
        'rsFreq!FccDbIdNo = x
        rsFreq!RulePartElig = "25"
        rsFreq!StatusCode = gtStatusCode
        rsFreq!ControlPhone = gtContactPhoneNum
        
        rsFreq.Update
        CommitTrans


        Call WriteOutFreqList

End Sub    '  EsWriteFreqTable


Sub EsWriteFreqTable_Mod()

    Dim giFreqFlag_1 As Integer
    Dim giFreqFlag_2 As Integer

    giFreqFlag_1 = 0
    giFreqFlag_2 = 0

    If ((gtPathSiteKey = gtPathSiteKeyPre) And _
        (gtPathAntKey = gtPathAntKeyPre)) Then
        giFreqFlag_1 = 1
    Else
        giFreqFlag_1 = 0
    End If

    If ((gtFrequencyLower = gtFrequencyLowerPre) And _
        (gtFrequencyUpper = gtFrequencyUpperPre)) Then
        giFreqFlag_2 = 1
    Else
        giFreqFlag_2 = 0
    End If

    If ((giFreqFlag_1 = 1) And (giFreqFlag_2 = 1)) Then
        '  Same path/antenna and same frequency band
        '  Do NOT increment gtFreqKey
        giEmissionFlag = 0
        giEmissionCnt = giEmissionCnt + 1
    Else
        ' Differenct path/antenna or frequency band

        If ((giFreqFlag_1 = 1) And (giFreqFlag_2 = 0)) Then
            '  Same path/antenna and different frequency band
            '  Increment gtFreqKey
            glFreqRecCnt = glFreqRecCnt + 1
            giEmissionFlag = 1
            giEmissionCnt = 1
        Else
            If ((giFreqFlag_1 = 1)) Then
                '  Different path/antenna
                '  Increment gtFreqKey
                glFreqRecCnt = glFreqRecCnt + 1
                giEmissionFlag = 1
                giEmissionCnt = 1
            End If
        End If

    End If

    gtFreqKey = "IB" & Format(glFreqRecCnt, "00000000")

If ((gtTxCall = "KD75") Or (gtRxCall = "KD75")) Then
    MsgBox "Pause", , "in ES Write Freq Table _ Mod"
    DoEvents
End If

    'MsgBox ("EmissionFlag = " & Str(giEmissionFlag)), , "ES Write Freq Table"
    'DoEvents
    
    If (glRecCnt = 1) Then
        giEmissionFlag = 1
    End If
    
    If (giEmissionFlag = 0) Then
        
        rsFreq.Index = "idxFreqKey"
        rsFreq.Seek "=", gtFreqKeyPre
        If (Not rsFreq.NoMatch) Then
        '  Append additional Emission Designator to existing Freq record
        
            BeginTrans
            rsFreq.Edit
            Select Case giEmissionCnt
                Case Is = 2
                    rsFreq!EmissionDesignator2 = Mid(gtEmission, 1, 7)
                Case Is = 3
                    rsFreq!EmissionDesignator3 = Mid(gtEmission, 1, 7)
                Case Is = 4
                    rsFreq!EmissionDesignator4 = Mid(gtEmission, 1, 7)
                Case Is > 4
                    rsFreq!EmissionDesignator4 = Str(giEmissionCnt)
            End Select
            rsFreq.Update
            CommitTrans
        Else
            MsgBox ("FreqKey = " & gtFreqKey & " record not found"), , "in ES Write Freq Table"
            DoEvents
        End If
    Else
        ' New Freq Record
        BeginTrans
        rsFreq.AddNew
        rsFreq!FreqKey = gtFreqKey
        rsFreq!CsFnKey = gtCallSign
        rsFreq!PathSiteKey = gtPathSiteKey
        rsFreq!PathAntKey = gtPathAntKey
        rsFreq!LicenseeIdKey = Trim(gtLicenseeIdKey)
        'rsFreq!EquipKey = ""
        rsFreq!FreqC = gtFrequencyLower
        rsFreq!FreqL = gtFrequencyLower
        rsFreq!FreqU = gtFrequencyUpper
        'rsFreq!ChannelNum = ""
        rsFreq!EmissionDesignator1 = Mid(gtEmission, 1, 7)
        'rsFreq!EmissionDesignator2 = ""
        'rsFreq!EmissionDesignator3 = ""
        'rsFreq!EmissionDesignator4 = ""

        'rsFreq!CarsEmissionCode = ""

        rsFreq!ClassStation = gtTxStationClass    '  dbText, 4)
        rsFreq!ClassStation = gtRxStationClass    '  dbText, 4)

        'rsFreq!FreqTol = ""
        'rsFreq!DigitalRate = ""
        'rsFreq!DigitalMod = x
        'rsFreq!OutputPwr = x
        'rsFreq!LineLoss = x
        'rsFreq!AntInputPwr = x
        rsFreq!Eirp = Format(gtEirp, "0000.0; 000.0;-0000.0")
        rsFreq!EirpUnit = "W"
        'rsFreq!SigLevel = x
        'rsFreq!LineLoss = x
        rsFreq!DateApp = gtDateFiled
        'rsFreq!DateFirstUse = x
        'rsFreq!DateIssue = x
        rsFreq!DateExpire = gtDateExpire
        rsFreq!AppFileNum = Trim(gtFileNumber)
        'rsFreq!PnFileNo = x
        rsFreq!FccRadSvc = gtRadSvc
        'rsFreq!FccDbIdNo = x
        rsFreq!RulePartElig = "25"
        rsFreq!StatusCode = gtStatusCode
        rsFreq.Update
        CommitTrans
        gtFreqKeyPre = gtFreqKey

        DoEvents
    End If

    'gtCallSignPre = gtCallSign
    'glSiteKeyPre = glSiteKey
    'glAntennaKeyPre = glAntennaKey
    'gtTransModeFixPre = gtTransModeFix
    gtFrequencyLowerPre = gtFrequencyLower
    gtFrequencyUpperPre = gtFrequencyUpper
    'gtFreqKeyPre = gtFreqKey

End Sub    '  EsWriteFreqTable_Mod

Sub DecodeMainTbl()

    rsMainTbl.Index = "idxFilingKey"
    rsMainTbl.Seek "=", rsSQL!FilingKey
    If (Not rsMainTbl.NoMatch) Then
        'Record found
        'gtFilingKey = rsMainTbl!FilingKey
        gtFilingState = rsMainTbl!FilingState
        gtCallSign = Trim(rsMainTbl!CallSign)
        gtFileNumber = Trim(rsMainTbl!FileNumber)
        gtSubsystemCode = rsMainTbl!SubsystemCode
        gtStatusCode = rsMainTbl!StatusCode
        gtStatusDate = rsMainTbl!StatusDate
        'gtLastAction = rsMainTbl!LastAction
        'gtLastActionDate = rsMainTbl!LastActionDate
        'gtMtsNumber = rsMainTbl!MtsNumber
        gtDateFiled = Trim(rsMainTbl!DateFiled)
        'gtMellonDate = rsMainTbl!MellonDate
        'gtDateGrant = rsMainTbl!DateGrant
        'gtDateDeny = rsMainTbl!DateDeny
        'gtDateDismiss = rsMainTbl!DateDismiss
        'gtDateSurrender = rsMainTbl!DateSurrender
        'gtDateBegin = rsMainTbl!DateBegin
        gtDateExpire = Trim(rsMainTbl!DateExpire)
        'gtDateLastUpdate = rsMainTbl!DateLastUpdate
        'gtAffPubNoticeSw = rsMainTbl!AffPubNoticeSw
        'gtAffPubNoticeDate = rsMainTbl!AffPubNoticeDate
        'gtActPubNoticeSw = rsMainTbl!ActPubNoticeSw
        'gtActPubNoticeDate = rsMainTbl!ActPubNoticeDate
        'gtSubmissionId = rsMainTbl!SubmissionId
        'gtFeeControlNumber = rsMainTbl!FeeControlNumber
        gtAppTypeCode = Trim(rsMainTbl!AppTypeCode)
        'gtFilingOtherTxt = rsMainTbl!FilingOtherTxt
        'gtKeyWord1 = rsMainTbl!KeyWord1
        'gtKeyWord2 = rsMainTbl!KeyWord2
        'gtTowerClearedSw = rsMainTbl!TowerClearedSw
        'gtDateBlocked = rsMainTbl!DateBlocked
        'gtBlockedReasonCode = rsMainTbl!BlockedReasonCode
        'gtBlockedReason = rsMainTbl!BlockedReason
        gtLiceType = Mid(Trim(rsMainTbl!TypeApplicantCode), 1, 1)
        'gtApplicantOtherText = rsMainTbl!ApplicantOtherText
        gtClassOfStationCode = Trim(rsMainTbl!ClassOfStationCode)
        'gtClassOtherText = rsMainTbl!ClassOtherText
        'gtSignerName = rsMainTbl!SignerName
        'gtSignerTitle = rsMainTbl!SignerTitle
        'gtDateSigned = rsMainTbl!DateSigned
        'gtDescription = rsMainTbl!Description
        'gtAddressKey = rsMainTbl!AddressKey
        'gtLiceContact = Trim(rsMainTbl!AddressAttention)
        'gtLicePhone = Mid(Trim(rsMainTbl!AddressPhoneNum), 1, 12)
        'gtLiceFaxNum = rsMainTbl!AddressFaxNum
        'gtLiceEmail = rsMainTbl!AddressEMail
        'gtContactKey = rsMainTbl!ContactKey
        'gtContactAttention = rsMainTbl!ContactAttention
        'gtContactRelationship = rsMainTbl!ContactRelationship
        gtContactPhoneNum = Trim(rsMainTbl!ContactPhoneNum)
        'gtContactFaxNum = rsMainTbl!ContactFaxNum
        'gtContactEMail = rsMainTbl!ContactEMail
        'gtOtherPurposeText = rsMainTbl!OtherPurposeText
        
        If (((Mid(gtContactPhoneNum, 1, 1) >= "a") And (Mid(gtContactPhoneNum, 1, 1) <= "z")) Or _
            ((Mid(gtContactPhoneNum, 1, 1) >= "A") And (Mid(gtContactPhoneNum, 1, 1) <= "Z"))) Then
            gtContactPhoneNum = " "
        Else
            If (Mid(gtContactPhoneNum, 1, 1) = "1") Then
                gtContactPhoneNum = Mid(gtContactPhoneNum, 2)
            End If
            If (Mid(gtContactPhoneNum, 1, 2) = "1-") Then
                gtContactPhoneNum = Mid(gtContactPhoneNum, 3)
            End If
            
            giCnt = Len(gtContactPhoneNum)
            Select Case giCnt
                Case Is = 0
                    gtContactPhoneNum = " "
                Case Is = 10    '  xxxxxxxxxx
                    gtContactPhoneNum = gtContactPhoneNum
                Case Is = 11
                    gtContactPhoneNum = Mid(gtContactPhoneNum, 1, 3) & _
                                        Mid(gtContactPhoneNum, 5)
                Case Is = 12    '  xxx-xxx-xxxx
                    gtContactPhoneNum = Mid(gtContactPhoneNum, 1, 3) & _
                                        Mid(gtContactPhoneNum, 5, 3) & _
                                        Mid(gtContactPhoneNum, 9, 4)
                Case Is = 13    '  (xxx)xxx-xxxx
                    gtContactPhoneNum = Mid(gtContactPhoneNum, 2, 3) & _
                                        Mid(gtContactPhoneNum, 6, 3) & _
                                        Mid(gtContactPhoneNum, 10, 4)
                Case Is = 14    '  (xxx) xxx-xxxx)
                    gtContactPhoneNum = Mid(gtContactPhoneNum, 2, 3) & _
                                        Mid(gtContactPhoneNum, 7, 3) & _
                                        Mid(gtContactPhoneNum, 11, 4)
                Case Is >= 15    '  xxx-xxx-xxxx  zzz
                    gtContactPhoneNum = Mid(gtContactPhoneNum, 1, 3) & _
                                        Mid(gtContactPhoneNum, 5, 3) & _
                                        Mid(gtContactPhoneNum, 9, 4)
                Case Else
                    'MsgBox gtContactPhoneNum
                    DoEvents
                    gtContactPhoneNum = ""
            End Select
        End If
        
    Else
        'gtFilingKey = ""
        'gtFilingState = ""
        gtCallSign = ""
        gtFileNumber = ""
        'gtSubsystemCode = ""
        'gtStatusCode = ""
        'gtStatusDate = ""
        'gtLastAction = ""
        'gtLastActionDate = ""
        'gtMtsNumber = ""
        gtDateFiled = ""
        'gtMellonDate = ""
        'gtDateGrant = ""
        'gtDateDeny = ""
        'gtDateDismiss = ""
        'gtDateSurrender = ""
        'gtDateBegin = ""
        gtDateExpire = ""
        'gtDateLastUpdate = ""
        'gtAffPubNoticeSw = ""
        'gtAffPubNoticeDate = ""
        'gtActPubNoticeSw = ""
        'gtActPubNoticeDate = ""
        'gtSubmissionId = ""
        'gtFeeControlNumber = ""
        gtAppTypeCode = ""
        'gtFilingOtherTxt = ""
        'gtKeyWord1 = ""
        'gtKeyWord2 = ""
        'gtTowerClearedSw = ""
        'gtDateBlocked = ""
        'gtBlockedReasonCode = ""
        'gtBlockedReason = ""
        gtLiceType = ""
        'gtApplicantOtherText = ""
        gtClassOfStationCode = ""
        'gtClassOtherText = ""
        'gtSignerName = ""
        'gtSignerTitle = ""
        'gtDateSigned = ""
        'gtDescription = ""
        'gtAddressKey = ""
        gtLiceContact = ""
        gtLicePhone = ""
        'gtLiceFaxNum = ""
        'gtLiceEmail = ""
        'gtContactKey = ""
        'gtContactAttention = ""
        'gtContactRelationship = ""
        gtContactPhoneNum = ""
        'gtContactFaxNum = ""
        'gtContactEMail = ""
        'gtOtherPurposeText = ""

        gtStatusDate = ""
    End If

End Sub    '  DecodeMainTbl

Sub DecodeNatureOfServiceTbl()

    ' aka FCC Radio Service
    rsNatOfSer.Index = "idxFilingKey"
    rsNatOfSer.Seek "=", rsSQL!FilingKey
    If (Not rsNatOfSer.NoMatch) Then
        'Record found
        gtNatureOfServiceCode = rsNatOfSer!NatureOfServiceCode
        rsNatOfSerCod.Index = "idxNatureOfServiceCode"
        rsNatOfSerCod.Seek "=", Trim(gtNatureOfServiceCode)
        If (Not rsNatOfSerCod.NoMatch) Then
            'Record found
            gtRadSvc = rsNatOfSerCod!RadSvcCode
        Else
            gtNatureOfServiceCode = "?1"
        End If
    Else
        gtNatureOfServiceCode = "?2"
    End If

End Sub    '  DecodeNatureOfServiceTbl

Sub DecodePtcomm()

    rsPtCommTbl.Index = "idxSiteKey"
    rsPtCommTbl.Seek "=", rsSQL!SiteKey
    If (Not rsPtCommTbl.NoMatch) Then
        'Record found
        glPtcommKey = rsPtCommTbl!PtCommKey
        glSpaceStationKey = rsPtCommTbl!SpaceStationKey
    Else
        glPtcommKey = 0
        glSpaceStationKey = 0
     End If

End Sub    '  DecodePtcomm

Sub DecodeSiteTbl()

    rsSiteTbl.Index = "idxSiteKey"
    rsSiteTbl.Seek "=", rsSQL!SiteKey
    If (Not rsSiteTbl.NoMatch) Then
        'Record found
        glSiteKey = rsSiteTbl!SiteKey
        'gtFilingKey = rsSiteTbl!FilingKey
        gtSiteId = rsSiteTbl!SiteId
        'gtSiteDescription = rsSiteTbl!SiteDescription
        'gtContactPerson = rsSiteTbl!ContactPerson
        gtSiteStreet1 = rsSiteTbl!SiteStreet1
        gtSiteStreet2 = rsSiteTbl!SiteStreet2
        gtSiteCity = rsSiteTbl!SiteCity
        gtSiteCounty = rsSiteTbl!SiteCounty
        gtSiteState = rsSiteTbl!SiteState
        'gtSiteZipcode = rsSiteTbl!SiteZipcode
        'gtSiteTelephone = rsSiteTbl!SiteTelephone
        gtSiteElevation = rsSiteTbl!SiteElevation    '  Letter "a" of the antenna structure figure
        gtSiteGrEl = rsSiteTbl!SiteElevation   '  Letter "a" of the antenna structure figure
        gtSiteLatDMS = rsSiteTbl!SiteLatDMS
        gtSiteLatSec = rsSiteTbl!SiteLatSec
        gtSiteLonDMS = rsSiteTbl!SiteLonDMS
        gtSiteLonSec = rsSiteTbl!SiteLonSec
        gtNadInd = rsSiteTbl!NadInd
        'gtNumVsatsBuilt = rsSiteTbl!NumVsatsBuilt
        'gtVsatReportDate = rsSiteTbl!VsatReportDate
        'gtFaaCoordSw = rsSiteTbl!FaaCoordSw
        'gtComply25209aSw = rsSiteTbl!Comply25209aSw
        'gtComply25209a2Sw = rsSiteTbl!Comply25209a2Sw
        'gtRemoteControlSw = rsSiteTbl!RemoteControlSw
        'gtForeignFreqCoordReqSw = rsSiteTbl!ForeignFreqCoordReqSw
        'gtFreqCoordReqSw = rsSiteTbl!FreqCoordReqSw
        
        'gtAreaOfOperationCode = rsSiteTbl!AreaOfOperationCode
        'gtFaaCoordNotReqSw = rsSiteTbl!FaaCoordNotReqSw
        'gtComply25211Sw = rsSiteTbl!Comply25211Sw
        
        If (Len(Trim(gtSiteStreet2)) > 0) Then
            gtSiteStreet = Trim(gtSiteStreet1) & " / " & Trim(gtSiteStreet2)
        Else
            gtSiteStreet = Trim(gtSiteStreet1)
        End If

        Select Case Trim(gtNadInd)
            Case Is = "0"
                gtSiteDatum = "NAD27"    '  "?????"
            Case Is = "27"
                gtSiteDatum = "NAD27"
            Case Is = "83"
                gtSiteDatum = "NAD83"
            Case Else
                gtSiteDatum = "NAD27"    '  "?????"
        End Select

        If (IsNull(rsSiteTbl!TowerSiteKey)) Then
            gtSiteAntSiteKey = ""
        Else
            gtSiteAntSiteKey = rsSiteTbl!TowerSiteKey   ' dbText, 20)
        End If
        If (IsNull(rsSiteTbl!TowerSiteKey)) Then
            gtTowerFlag = ""
        Else
            gtTowerFlag = rsSiteTbl!TowerSiteKey   ' dbText, 1)
        End If

    Else
        'glSiteKey = ""
        'gtFilingKey = ""
        'gtSiteId = ""
        'gtSiteDescription = ""
        'gtContactPerson = ""
        gtSiteStreet1 = ""
        'gtSiteStreet2 = ""
        gtSiteCity = ""
        gtSiteCounty = ""
        gtSiteState = ""
        'gtSiteZipcode = ""
        'gtSiteTelephone = ""
        gtSiteElevation = ""
        gtSiteLatDMS = ""
        gtSiteLatSec = ""
        gtSiteLonDMS = ""
        gtSiteLonSec = ""
        gtNadInd = ""
        'gtNumVsatsBuilt = ""
        'gtVsatReportDate = ""
        'gtFaaCoordSw = ""
        'gtComply25209aSw = ""
        'gtComply25209a2Sw = ""
        'gtRemoteControlSw = ""
        'gtForeignFreqCoordReqSw = ""
        'gtFreqCoordReqSw = ""
        gtAreaOfOperationCode = ""
        gtFaaCoordNotReqSw = ""
        gtComply25211Sw = ""
    
        gtTowerSiteKey = ""
        gtTowerFlag = ""
    
    
    End If

End Sub    '  DecodeSiteTbl

Sub DecodeAntennaTbl()

    Dim gtAntMfgTmp As String
    Dim gtAntModTmp As String

    rsAntennaTbl.Index = "idxAntennaKey"
    rsAntennaTbl.Seek "=", rsSQL!AntennaKey
    If (Not rsAntennaTbl.NoMatch) Then
        'Record found
        glAntennaKey = rsAntennaTbl!AntennaKey
        'gtAntennaId = rsAntennaTbl!AntennaId
        glSiteKey = rsAntennaTbl!SiteKey
        gtDiameter = rsAntennaTbl!Diameter
        gtDiameterMinor = rsAntennaTbl!DiameterMinor
        gtDiameterMajor = rsAntennaTbl!DiameterMajor
        gtHeightBldgAgl = rsAntennaTbl!HeightBldgAgl    '  Letter "b" of the antenna structure figure
        gtHeightMaxAgl = rsAntennaTbl!HeightMaxAgl      '  Letter "c" of the antenna structure figure
        gtHeightMaxAmsl = rsAntennaTbl!HeightMaxAmsl    '  Letter "c" of the antenna structure figure
        'gtHeightMaxARoof = rsAntennaTbl!HeightMaxARoof  ' = ( c - b) of the antenna structure figure
        gtAntMfgTmp = Trim(rsAntennaTbl!Manufacturer)
        'gtMaxInputPower = rsAntennaTbl!MaxInputPower
        'gtMaxOutputEirp = rsAntennaTbl!MaxOutputEirp
        gtAntModTmp = Trim(rsAntennaTbl!Model)
        'gtQuantity = rsAntennaTbl!Quantity
        gtTowerReg = rsAntennaTbl!TowerId
        'gtTowerClearedSw = rsAntennaTbl!TowerClearedSw

        gtAntMod = gtAntModTmp
        giX = InStr(1, gtAntMfgTmp, "MODEL", 1)
        If (giX > 0) Then
            gtAntMfg = Trim(Mid(gtAntMfgTmp, 1, (giX - 1)))
            gtAntMod = Trim(Mid(gtAntMfgTmp, (giX + 5)) & gtAntMod)
        Else
            gtAntMfg = gtAntMfgTmp
        End If

        giY = InStr(1, gtAntMod, "ODEL", 1)
        If (giY > 1) Then
            gtAntMod = Mid(gtAntMod, (giY + 4))
        End If

        giZ = InStr(1, gtAntMod, "NO.", 1)
        If (giZ > 0) Then
            gtAntMod = Mid(gtAntMod, (giZ + 3))
        End If

        gtAntMfg = Mid(gtAntMfg, 1, 25)
        gtAntMod = Mid(gtAntMod, 1, 25)

        'If ((giX > 0) Or (giY > 0)) Then
        'If ((giZ > 0)) Then
        '    MsgBox (gtAntMfgTmp & " | " & gtAntModTmp & vbCrLf & vbCrLf & _
                    gtAntMfg & " | " & gtAntMod)
        '    DoEvents
        'End If
    Else
        'glAntennaKey = ""
        'gtAntennaId = ""
        'gtSiteKey = ""
        gtDiameter = ""
        'gtDiameterMinor = ""
        'gtDiameterMajor = ""
        gtHeightBldgAgl = ""
        gtHeightMaxAgl = ""
        'gtHeightMaxAmsl = ""
        'gtHeightMaxARoof = ""
        gtAntMfg = ""
        gtAntMod = ""
        'gtMaxInputPower = ""
        'gtMaxOutputEirp = ""
        gtAntMod = ""
        gtAntMod = ""
        gtAntMod = ""
        'gtQuantity ""
        gtTowerReg = ""
        'gtTowerClearedSw = ""
    End If

End Sub    '  DecodeAntennaTbl

Sub DecodeAntennaGainTbl()

    If (IsNull(rsSQL!AntennaKey)) Then
        gtAntGn = ""
        MsgBox "pause", , "DecodeAntennaGainTbl"
        DoEvents
        Exit Sub
    End If
    rsAntennaGainTbl.Index = "idxAntennaKey"
    rsAntennaGainTbl.Seek "=", rsSQL!AntennaKey
    If (Not rsAntennaGainTbl.NoMatch) Then
        'Record found
        'gtGainKey = rsAntennaGain!GainKey
        'gtAntennaKey = "IB" & str(rsAntennaGain!AntennaKey)
        gtAntGn = rsAntennaGainTbl!Gain
        'gtFrequency = rsAntennaGain!Frequency
        'If (IsNull(rsAntennaGainTbl!TransMode)) Then
        '    gtTransMode = ""
        'Else
        '    gtTransMode = rsAntennaGainTbl!TransMode
        'End If
    Else
        'gtGainKey = ""
        'gtAntennaKey = ""
        gtAntGn = ""
        'gtFrequency = ""
        gtTransMode = ""
    End If

End Sub    '  DecodeAntennaGainTbl

Sub DecodeFrequencyTbl()

    rsFrequencyTbl.Index = "idxFrequencyKey"
    rsFrequencyTbl.Seek "=", rsSQL!FrequencyKey

    If (Not rsFrequencyTbl.NoMatch) Then
        '  Record found
        'glFrequencyKey = rsFrequencyTbl!Frequency
        'glAntennaKey = rsFrequencyTbl!AntennaKey
        gtPolarizationCode = rsFrequencyTbl!PolarizationCode
        gtEirp = rsFrequencyTbl!Eirp
        'gtEirpDensity = rsFrequencyTbl!EirpDensity
        gtEmission = rsFrequencyTbl!Emission
        gtFrequencyLower = rsFrequencyTbl!FrequencyLower
        gtFrequencyUpper = rsFrequencyTbl!FrequencyUpper
        gtTransMode = rsFrequencyTbl!TransMode
        gtTransModeFix = rsFrequencyTbl!TransModeFix
        'gtModulation = rsFrequencyTbl!Modulation
        
        'gtFrequencyLowerDisplay = rsFrequencyTbl!FrequencyLowerDisplay
        'gtFrequencyUpperDisplay = rsFrequencyTbl!FrequencyUpperDisplay
        'gtUnitOfMeasure = rsFrequencyTbl!UnitOfMeasure
    Else
        'glFrequencyKey = ""
        'glAntennaKey = ""
        gtPolarizationCode = ""
        gtEirp = ""
        'gtEirpDensity = ""
        gtEmission = ""
        gtFrequencyLower = ""
        gtFrequencyUpper = ""
        gtTransMode = ""
        gtTransModeFix = ""
        'gtModulation = ""
        gtFrequencyLowerDisplay = ""
        gtFrequencyUpperDisplay = ""
        gtUnitOfMeasure = ""
    End If

End Sub    '  DecodeFrequencyTbl

Sub DecodeFreqCoordTbl()

    rsFreqCoordTbl.Index = "idxAntennaKey"
    rsFreqCoordTbl.Seek "=", rsSQL!AntennaKey
    If (Not rsFreqCoordTbl.NoMatch) Then
        'Record found
            'glCoordKey = rsFreqCoordTbl!CoordKey
            'glAntennaKey = rsFreqCoordTbl!AntennaKey
        gtAzimuthEast = rsFreqCoordTbl!AzimuthEast
        gtAzimuthWest = rsFreqCoordTbl!AzimuthWest
        gtElevationEast = rsFreqCoordTbl!ElevationEast
        gtElevationWest = rsFreqCoordTbl!ElevationWest
        gtFreqLimitLow = rsFreqCoordTbl!FreqLimitLow
        gtFreqLimitHigh = rsFreqCoordTbl!FreqLimitHigh
        If (Not IsNull(rsFreqCoordTbl!HorizMaxDensity)) Then
            'gtHorizMaxDensity = rsFreqCoordTbl!HorizMaxDensity
        End If
        gtSatArcEast = rsFreqCoordTbl!SatArcEast
        gtSatArcWest = rsFreqCoordTbl!SatArcWest
        gtSatHemiEast = rsFreqCoordTbl!SatHemiEast
        gtSatHemiWest = rsFreqCoordTbl!SatHemiWest
        gtSatOrbitType = rsFreqCoordTbl!SatOrbitType
    Else
        'glCoordKey = ""
        'glAntennaKey = ""
        gtAzimuthEast = ""
        gtAzimuthWest = ""
        gtElevationEast = ""
        gtElevationWest = ""
        gtFreqLimitLow = ""
        gtFreqLimitHigh = ""
        gtHorizMaxDensity = ""
        gtSatArcEast = ""
        gtSatArcWest = ""
        gtSatHemiEast = ""
        gtSatHemiWest = ""
        gtSatOrbitType = ""
    End If

End Sub     '  DecodeFrequencyCoordTbl

Sub DecodeAddressTbl()

    rsAddressTbl.Index = "idxAddressKey"
    rsAddressTbl.Seek "=", rsSQL!AddressKey
    If (Not rsAddressTbl.NoMatch) Then
        'Record found
        gtAddressKey = rsAddressTbl!AddressKey
        If (Mid(rsAddressTbl!AddressId, 1, 2) = "IB") Then
            gtLicenseeIdKey = Trim(rsAddressTbl!AddressId)
        Else
            gtLicenseeIdKey = "IB~" & Trim(rsAddressTbl!AddressId)
        End If
        gtLiceName = rsAddressTbl!AddressName
        gtLiceDBA = rsAddressTbl!DbaName
        gtLiceStreet1 = rsAddressTbl!Street1
        gtLiceStreet2 = rsAddressTbl!Street2
        gtLiceCity = rsAddressTbl!City
        gtLiceState = rsAddressTbl!StateCode
        gtLiceZipCode = rsAddressTbl!ZipCode
        gtLiceCountry = rsAddressTbl!CountryCode
        gtLiceFrn = rsAddressTbl!Frn

        gtAddressFrn = rsAddressTbl!Frn

        If (IsNull(rsAddressTbl!Redlight)) Then
            gtRedlight = ""
        Else
            gtRedlight = rsAddressTbl!Redlight
        End If
    Else
        'gtAddressKey = ""
        gtLicenseeIdKey = ""
        gtLiceName = ""
        gtLiceDBA = ""
        gtLiceStreet1 = ""
        gtLiceStreet2 = ""
        gtLiceCity = ""
        gtLiceState = ""
        gtLiceZipCode = ""
        gtLiceCountry = ""
        gtLiceFrn = ""
        gtRedlight = ""
    End If

End Sub    '  DecodeAddressTbl

Sub DecodeForm312Tbl()

    rsForm312Tbl.Index = "idxFilingKey"
    rsForm312Tbl.Seek "=", rsSQL!FilingKey
    If (rsForm312Tbl.NoMatch) Then
        'Not Record found
        gtEnvironEffectSw = ""
    Else
        gtEnvironEffectSw = rsForm312Tbl!EnvironEffectSw
    End If

End Sub    '  DecodeForm312Tbl

Sub DecodeSpaceStationTbl()

    rsSpaceStationTbl.Index = "idxSpaceStationKey"
    rsSpaceStationTbl.Seek "=", glSpaceStationKey
    If (Not rsSpaceStationTbl.NoMatch) Then
        'Record found
        'glSpaceStationKey = rsSpaceStationTbl!SpaceStationKey
        gtUsName = rsSpaceStationTbl!UsName
        gtItuName = rsSpaceStationTbl!ItuName
        gtOrbitLocation = rsSpaceStationTbl!OrbitLocation
        gtVerbose = rsSpaceStationTbl!Verbose
        gtInactiveDate = rsSpaceStationTbl!InactiveDate
        gtLongHemi = rsSpaceStationTbl!LongHemi
                
    Else
        'glSpaceStationKey = 0
        gtUsName = ""
        gtItuName = ""
        gtOrbitLocation = ""
        gtVerbose = ""
        gtInactiveDate = ""
        gtLongHemi = ""
    End If

End Sub    '  DecodeSpaceStationTbl

Sub DecodeSpaceStationVia214Tbl()

    rsSection214Tbl.Index = "idxFilingKey"
    rsSection214Tbl.Seek "=", glFilingKey
    If (Not rsSection214Tbl.NoMatch) Then
        glSpaceStationKey = rsSection214Tbl!SpaceStationKey
        rsSpaceStationTbl.Index = "idxSpaceStationKey"
        rsSpaceStationTbl.Seek "=", glSpaceStationKey
        If (Not rsSpaceStationTbl.NoMatch) Then
            'Record found
            'glSpaceStationKey = rsSpaceStationTbl!SpaceStationKey
            gtUsName = rsSpaceStationTbl!UsName
            gtItuName = rsSpaceStationTbl!ItuName
            gtOrbitLocation = rsSpaceStationTbl!OrbitLocation
            gtVerbose = rsSpaceStationTbl!Verbose
            gtInactiveDate = rsSpaceStationTbl!InactiveDate
        Else
            'glSpaceStationKey = 0
            gtUsName = ""
            gtItuName = ""
            gtOrbitLocation = ""
            gtVerbose = ""
            gtInactiveDate = ""
        End If
    Else
        glSpaceStationKey = 0
        gtUsName = ""
        gtItuName = ""
        gtOrbitLocation = ""
        gtVerbose = ""
        gtInactiveDate = ""
    End If

End Sub    '  DecodeSpaceStationVia214Tbl

Sub PopulateEarthStationStaTable()

    Dim gtInputDataArray

    Set dbJet = wsJet.OpenDatabase(gtOutputPathAndFilename)
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    Set rsEarthStationSta = dbJet.OpenRecordset("IbfsEarthStationSta", dbOpenTable)

    gtActionText = gtActionTextMsg & "Populate Earth Station STA Table!"
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)

    gxBeginDateTime = Now
    glBeginSeconds = GetTickCount()
    giMaxFldCnt = 13
    gtTableName = "IbfsEarthStationSta"
    gtInputFileName = "earth_sta.dat"
    frmStatus.lblStatus.Caption = "Populating 'EarthStationSta' table with  < " & gtInputFileName & " >  data !"
    frmStatus.lblStepCurrent.Caption = Str(giActionCounter)
    frmStatus.Refresh
    'Print #giBadDataFF, ""
    'Print #giBadDataFF, "=====>  " & gtInputFileName & "  <====="
    'Print #giBadDataFF, ""
    
    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh

    giIDFF = FreeFile
    Open (gtInputFilePath & gtInputFileName) For Input As giIDFF
    glLengthOfFile = LOF(giIDFF)

    frmStatus.lblFileSize.Caption = Format(glLengthOfFile, "###,###,###0")
    frmStatus.Refresh
    glRecCnt = 0
    glRecLen = 0

    Do While Not EOF(giIDFF)
        glRecCnt = glRecCnt + 1
        glRecLen = glRecLen + Len(gtInputData) + 2
        If ((glRecCnt Mod 100) = 0) Then
            frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
            gsPercentComplete = (glRecLen / glLengthOfFile) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
        End If
        Line Input #giIDFF, gtInputData
        gtInputData = Trim(gtInputData)
        
        If (Len(gtInputData) = 0) Then GoTo EarthStationStaTag

        Call NewLineRepair

        gtInputDataArray = ""
        gtInputDataArray = Split(gtInputData, "|", giMaxFldCnt, 1)
        
        BeginTrans
        rsEarthStationSta.AddNew
        rsEarthStationSta!FilingKey = Val(gtInputDataArray(0))
        rsEarthStationSta!TypeStaCode = Trim(gtInputDataArray(1))
            Call ConvertDate(Trim(gtInputDataArray(2)), gtOutputDate)
        rsEarthStationSta!RequestedDate = gtOutputDate
        rsEarthStationSta!City = Trim(gtInputDataArray(3))
        rsEarthStationSta!StateCode = Trim(gtInputDataArray(4))
        rsEarthStationSta!LatDeg = Val(gtInputDataArray(5))
        rsEarthStationSta!LatMin = Val(gtInputDataArray(6))
        rsEarthStationSta!LatSec = Val(gtInputDataArray(7))
        rsEarthStationSta!LatHemi = Trim(gtInputDataArray(8))
        rsEarthStationSta!LonDeg = Val(gtInputDataArray(9))
        rsEarthStationSta!LonMin = Val(gtInputDataArray(10))
        rsEarthStationSta!LonSec = Val(gtInputDataArray(11))
        rsEarthStationSta!LonHemi = Trim(gtInputDataArray(12))
        rsEarthStationSta.Update
        CommitTrans
        DoEvents

EarthStationStaTag:
    
    Loop
    Close (giIDFF)
    
    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    DoEvents

    Call WriteProcessLog

    rsEarthStationSta.Close
    Set rsEarthStationSta = Nothing
    rsProcessLog.Close
    Set rsProcessLog = Nothing
    dbJet.Close

    'gtCompactMsg = "Compacting Database  < " & gtInputFileName & " >"
    'Call CompactDB
    'frmStatus.lblStatus.Caption = "Finished processing  <  " & gtInputFileName & "  >  data !"
    DoEvents

    Exit Sub
    
PopulateEarthStationStaTableErr:
    
    gtMsg = "Error in PopulateEarthStationStaTable" & vbCrLf
    gtMsg = gtMsg & "Error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    'Print #giBadDataFF, gtMsg
    MsgBox gtMsg

End Sub    '  PopulateEarthStationStaTable

Sub PopulateForm312Table()
    
    Dim gtInputDataArray

    Set dbJet = wsJet.OpenDatabase(gtOutputPathAndFilename)
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    Set rsForm312Tbl = dbJet.OpenRecordset("IbfsForm312", dbOpenTable)

    gtActionText = gtActionTextMsg & "Populate Form 312 Table!"
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)

    gxBeginDateTime = Now
    glBeginSeconds = GetTickCount()
    
    'giMaxFldCnt = 29
    giMaxFldCnt = 36
    
    gtTableName = "IbfsForm312"
    gtInputFileName = "form_312.dat"
    frmStatus.lblStatus.Caption = "Populating 'Form312' table with  < " & gtInputFileName & " >  data !"
    frmStatus.lblStepCurrent.Caption = Str(giActionCounter)
    frmStatus.Refresh
    'Print #giBadDataFF, ""
    'Print #giBadDataFF, "=====>  " & gtInputFileName & "  <====="
    'Print #giBadDataFF, ""
    
    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh

    giIDFF = FreeFile
    Open (gtInputFilePath & gtInputFileName) For Input As giIDFF
    glLengthOfFile = LOF(giIDFF)

    frmStatus.lblFileSize.Caption = Format(glLengthOfFile, "###,###,###0")
    frmStatus.Refresh
    glRecCnt = 0
    glRecLen = 0

    Do While Not EOF(giIDFF)
        glRecCnt = glRecCnt + 1
        glRecLen = glRecLen + Len(gtInputData) + 2
        If ((glRecCnt Mod 100) = 0) Then
            frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
            gsPercentComplete = (glRecLen / glLengthOfFile) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
        End If
        Line Input #giIDFF, gtInputData
        gtInputData = Trim(gtInputData)
        
        If (Len(gtInputData) = 0) Then GoTo Form312Tag

        Call NewLineRepair

        gtInputDataArray = ""
        gtInputDataArray = Split(gtInputData, "|", giMaxFldCnt, 1)

        BeginTrans
        rsForm312Tbl.AddNew
        rsForm312Tbl!FilingKey = Val(gtInputDataArray(0))
        rsForm312Tbl!FileNumRef = gtInputDataArray(1)
            Call ConvertDate(Trim(gtInputDataArray(2)), gtOutputDate)
        rsForm312Tbl!FileNumDate = gtOutputDate
            Call ConvertDate(Trim(gtInputDataArray(3)), gtOutputDate)
        rsForm312Tbl!RequiredConstructionDate = gtOutputDate
            Call ConvertDate(Trim(gtInputDataArray(4)), gtOutputDate)
        rsForm312Tbl!CompletedConstructionDate = gtOutputDate
        rsForm312Tbl!BlanketCallSignSw = gtInputDataArray(5)
        rsForm312Tbl!CommonCarrierSw = gtInputDataArray(6)
        rsForm312Tbl!USSatSw = gtInputDataArray(7)
        rsForm312Tbl!NonUSSatSw = gtInputDataArray(8)
        rsForm312Tbl!TypeOfFacility = gtInputDataArray(9)
        rsForm312Tbl!EnvironEffectSw = gtInputDataArray(10)
        rsForm312Tbl!ForeignGovtRepSw = gtInputDataArray(11)
        rsForm312Tbl!AlienApplicantSw = gtInputDataArray(12)
        rsForm312Tbl!ForeignCorpSw = gtInputDataArray(13)
        rsForm312Tbl!AlienOfficerSw = gtInputDataArray(14)
        rsForm312Tbl!ForeignControlSw = gtInputDataArray(15)
        rsForm312Tbl!WaiversReqSw = gtInputDataArray(16)
        rsForm312Tbl!RevokedSw = gtInputDataArray(17)
        rsForm312Tbl!FelonySw = gtInputDataArray(18)
        rsForm312Tbl!MonopolySw = gtInputDataArray(19)
        rsForm312Tbl!PublicSwitchSw = gtInputDataArray(20)
        rsForm312Tbl!PendActionSw = gtInputDataArray(21)
        rsForm312Tbl!DrugAbuseSw = gtInputDataArray(22)
            rsForm312Tbl!NatureOfServiceOtherText = ""    '  Initialize "Memo" field
        rsForm312Tbl!NatureOfServiceOtherText.AppendChunk Trim(gtInputDataArray(23))
        rsForm312Tbl!SatCommonName = gtInputDataArray(24)
        rsForm312Tbl!OrbitLocation = gtInputDataArray(25)
        rsForm312Tbl!NonUSLicSatSw = gtInputDataArray(26)
            rsForm312Tbl!Administration = ""    '  Initialize "Memo" field
        rsForm312Tbl!Administration.AppendChunk Trim(gtInputDataArray(27))

' Begin New Code
        '    Call ConvertDate(Trim(gtInputDataArray(28)), gtOutputDate)
        'rsForm312Tbl!OperationStartDate = gtOutputDate
        'rsForm312Tbl!OrbitLocationAssigned = gtInputDataArray(29)
        '    Call ConvertDate(Trim(gtInputDataArray(30)), gtOutputDate)
        'rsForm312Tbl!DateLaunched = gtOutputDate
        'rsForm312Tbl!CallsignReplaced = gtInputDataArray(31)
        'rsForm312Tbl!LongHemi = gtInputDataArray(32)
        'rsForm312Tbl!LongHemiAssigned = gtInputDataArray(33)
        'rsForm312Tbl!ClassOfSatStation = gtInputDataArray(34)
' End New Code
        
        rsForm312Tbl.Update
        CommitTrans
        DoEvents

Form312Tag:
    Loop
    Close (giIDFF)
    
    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    DoEvents

    Call WriteProcessLog

    rsForm312Tbl.Close
    Set rsForm312Tbl = Nothing
    rsProcessLog.Close
    Set rsProcessLog = Nothing
    dbJet.Close

    'gtCompactMsg = "Compacting Database  < " & gtInputFileName & " >"
    'Call CompactDB
    'frmStatus.lblStatus.Caption = "Finished processing  <  " & gtInputFileName & "  >  data !"
    DoEvents

    Exit Sub
    
PopulateForm312TableErr:
    
    gtMsg = "Error in PopulateForm312Table" & vbCrLf
    gtMsg = gtMsg & "Error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    'Print #giBadDataFF, gtMsg
    MsgBox gtMsg

End Sub    '  PopulateForm312Table

Sub PopulateSection214Table()

    Dim gtInputDataArray

    Set dbJet = wsJet.OpenDatabase(gtOutputPathAndFilename)
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    Set rsSection214Tbl = dbJet.OpenRecordset("IbfsSection214", dbOpenTable)
    
    gtActionText = gtActionTextMsg & "Populate Section 214 Table!"
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    
    gxBeginDateTime = Now
    glBeginSeconds = GetTickCount()
    
    giMaxFldCnt = 27
    
    gtTableName = "IbfsSection214"
    gtInputFileName = "sect_214.dat"
    frmStatus.lblStatus.Caption = "Populating 'Section214' table with  < " & gtInputFileName & " >  data !"
    frmStatus.lblStepCurrent.Caption = Str(giActionCounter)
    frmStatus.Refresh
    'Print #giBadDataFF, ""
    'Print #giBadDataFF, "=====>  " & gtInputFileName & "  <====="
    'Print #giBadDataFF, ""
    
    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh

    giIDFF = FreeFile
    Open (gtInputFilePath & gtInputFileName) For Input As giIDFF
    glLengthOfFile = LOF(giIDFF)

    frmStatus.lblFileSize.Caption = Format(glLengthOfFile, "###,###,###0")
    frmStatus.Refresh
    glRecCnt = 0
    glRecLen = 0

    Do While Not EOF(giIDFF)
        glRecCnt = glRecCnt + 1
        glRecLen = glRecLen + Len(gtInputData) + 2
        If ((glRecCnt Mod 100) = 0) Then
            frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
            gsPercentComplete = (glRecLen / glLengthOfFile) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
        End If
        Line Input #giIDFF, gtInputData
        gtInputData = Trim(gtInputData)
        
        If (Len(gtInputData) = 0) Then GoTo Section214Tag

        Call NewLineRepair

        gtInputDataArray = ""
        gtInputDataArray = Split(gtInputData, "|", giMaxFldCnt, 1)

        BeginTrans
        rsSection214Tbl.AddNew
        
        rsSection214Tbl!FilingKey = Val(gtInputDataArray(0))
        rsSection214Tbl!DaNumber = Trim(gtInputDataArray(1))
                
            rsSection214Tbl!PlaceOfIncorp = ""    '  Initialize "Memo" field
        rsSection214Tbl!PlaceOfIncorp.AppendChunk Trim(gtInputDataArray(2))    '  Varchar(100)
     
            rsSection214Tbl!Destination = ""    '  Initialize "Memo" field
        rsSection214Tbl!Destination.AppendChunk Trim(gtInputDataArray(3))    '  Varchar(255)
     
        rsSection214Tbl!StreamlinedRequestSw = Trim(gtInputDataArray(4))
        rsSection214Tbl!StreamlinedSw = Trim(gtInputDataArray(5))
        rsSection214Tbl!AlienApplicantSw = Trim(gtInputDataArray(6))
        rsSection214Tbl!MultAlienApplicantSw = Trim(gtInputDataArray(7))
        rsSection214Tbl!DrugAbuseSw = Trim(gtInputDataArray(8))
        rsSection214Tbl!SpecialConcessionsSw = Trim(gtInputDataArray(9))
        rsSection214Tbl!CommonCarrierSw = Trim(gtInputDataArray(10))
        rsSection214Tbl!TenGreaterFo = Trim(gtInputDataArray(11))
        rsSection214Tbl!InterlockingDirectorates = Trim(gtInputDataArray(12))
        rsSection214Tbl!ForeignCarrierCountry = Trim(gtInputDataArray(13))
        rsSection214Tbl!NonDominant = Trim(gtInputDataArray(14))
        rsSection214Tbl!DominantCarrierSafeguardsSw = Trim(gtInputDataArray(15))
        rsSection214Tbl!CosumateCert = Trim(gtInputDataArray(16))
        rsSection214Tbl!ProFormaCert = Trim(gtInputDataArray(17))
     
            Call ConvertDate(Trim(gtInputDataArray(18)), gtOutputDate)
        rsSection214Tbl!ScheduledConsumateDate = gtOutputDate     '  Datetime
        rsSection214Tbl!GoodFaithCert = Trim(gtInputDataArray(19))
            Call ConvertDate(Trim(gtInputDataArray(20)), gtOutputDate)
        rsSection214Tbl!DateBocInitiated = gtOutputDate    '  Datetime
            Call ConvertDate(Trim(gtInputDataArray(21)), gtOutputDate)
        rsSection214Tbl!DateBocFiled = gtOutputDate     '  Datetime
        rsSection214Tbl!CiteGranting271 = Trim(gtInputDataArray(22))
            Call ConvertDate(Trim(gtInputDataArray(23)), gtOutputDate)
        rsSection214Tbl!Date271Granted = gtOutputDate    '  Datetime
            Call ConvertDate(Trim(gtInputDataArray(24)), gtOutputDate)
        rsSection214Tbl!FalseField = gtOutputDate    '  Datetime
        rsSection214Tbl!BocStateCodev = Trim(gtInputDataArray(25))
        rsSection214Tbl!TrafficReporting = Trim(gtInputDataArray(26))
        
        rsSection214Tbl.Update
        CommitTrans
        DoEvents

Section214Tag:
    Loop
    Close (giIDFF)
    
    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    DoEvents

    Call WriteProcessLog

    rsSection214Tbl.Close
    Set rsSection214Tbl = Nothing
    rsProcessLog.Close
    Set rsProcessLog = Nothing
    dbJet.Close

    'gtCompactMsg = "Compacting Database  < " & gtInputFileName & " >"
    'Call CompactDB
    'frmStatus.lblStatus.Caption = "Finished processing  <  " & gtInputFileName & "  >  data !"
    DoEvents

    Exit Sub
    
PopulateSection214TableErr:
    
    gtMsg = "Error in PopulateSection214Table" & vbCrLf
    gtMsg = gtMsg & "Error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    'Print #giBadDataFF, gtMsg
    MsgBox gtMsg

End Sub    '  PopulateSection214Table

Sub PopulateSection214Table_Org()

    Dim gtInputDataArray

    Set dbJet = wsJet.OpenDatabase(gtOutputPathAndFilename)
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    Set rsSection214Tbl = dbJet.OpenRecordset("IbfsSection214", dbOpenTable)
    
    gtActionText = gtActionTextMsg & "Populate Section 214 Table!"
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    
    gxBeginDateTime = Now
    glBeginSeconds = GetTickCount()
    giMaxFldCnt = 11
    gtTableName = "IbfsSection214"
    gtInputFileName = "sect_214.dat"
    frmStatus.lblStatus.Caption = "Populating 'Section214' table with  < " & gtInputFileName & " >  data !"
    frmStatus.lblStepCurrent.Caption = Str(giActionCounter)
    frmStatus.Refresh
    'Print #giBadDataFF, ""
    'Print #giBadDataFF, "=====>  " & gtInputFileName & "  <====="
    'Print #giBadDataFF, ""
    
    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh

    giIDFF = FreeFile
    Open (gtInputFilePath & gtInputFileName) For Input As giIDFF
    glLengthOfFile = LOF(giIDFF)

    frmStatus.lblFileSize.Caption = Format(glLengthOfFile, "###,###,###0")
    frmStatus.Refresh
    glRecCnt = 0
    glRecLen = 0

    Do While Not EOF(giIDFF)
        glRecCnt = glRecCnt + 1
        glRecLen = glRecLen + Len(gtInputData) + 2
        If ((glRecCnt Mod 100) = 0) Then
            frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
            gsPercentComplete = (glRecLen / glLengthOfFile) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
        End If
        Line Input #giIDFF, gtInputData
        gtInputData = Trim(gtInputData)
        
        If (Len(gtInputData) = 0) Then GoTo Section214Tag

        Call NewLineRepair

        gtInputDataArray = ""
        gtInputDataArray = Split(gtInputData, "|", giMaxFldCnt, 1)

        BeginTrans
        rsSection214Tbl.AddNew
        rsSection214Tbl!FilingKey = Val(gtInputDataArray(0))
        rsSection214Tbl!DaNumber = Trim(gtInputDataArray(1))
        rsSection214Tbl!Section214ServiceCode = Mid(Trim(gtInputDataArray(2)), 1, 4)
        rsSection214Tbl!SpaceStationKey = Val(gtInputDataArray(3))
        rsSection214Tbl!PlaceOfIncorp = Trim(gtInputDataArray(4))
        rsSection214Tbl!CountryCode = Trim(gtInputDataArray(5))
        rsSection214Tbl!StreamlinedSw = Trim(gtInputDataArray(6))
        rsSection214Tbl!AlienApplicantSw = Trim(gtInputDataArray(7))
        rsSection214Tbl!MultAlienApplicantSw = Trim(gtInputDataArray(8))
        rsSection214Tbl!DrugAbuseSw = Trim(gtInputDataArray(9))
        rsSection214Tbl.Update
        CommitTrans
        DoEvents

Section214Tag:
    Loop
    Close (giIDFF)
    
    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    DoEvents

    Call WriteProcessLog

    rsSection214Tbl.Close
    Set rsSection214Tbl = Nothing
    rsProcessLog.Close
    Set rsProcessLog = Nothing
    dbJet.Close

    'gtCompactMsg = "Compacting Database  < " & gtInputFileName & " >"
    'Call CompactDB
    'frmStatus.lblStatus.Caption = "Finished processing  <  " & gtInputFileName & "  >  data !"
    DoEvents

    Exit Sub
    
PopulateSection214TableErr:
    
    gtMsg = "Error in PopulateSection214Table" & vbCrLf
    gtMsg = gtMsg & "Error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    'Print #giBadDataFF, gtMsg
    MsgBox gtMsg

End Sub    '  PopulateSection214Table

Sub EsWriteSpcCndAntTable()

    Dim glAntennaKeyTemp As Long

    Dim gtSpecCondAnt As String

    gtSpecCondAnt = ""
    
    rsAntennaCondition.Index = "idxAntennaKey"
    rsAntennaCondition.Seek "=", glAntennaKey
    
    If (rsAntennaCondition.NoMatch) Then
        'gtMsg = "Record NOT found in AntennaCondition table"
        'MsgBox gtMsg
        'doevents
        Exit Sub
    Else
        gtMsg = "Record found in AntennaCondition table"
        'MsgBox gtMsg
        DoEvents
        Do
            rsCondition.Index = "idxConditionCode"
            rsCondition.Seek "=", rsAntennaCondition!ConditionCode
            If (rsCondition.NoMatch) Then
                'MsgBox "Record NOT found in Condition table"
                gtSpecCondAnt = gtSpecCondAnt & "Entry NOT found in Condition table:  " & _
                                " AntennaKey = " & Str(rsAntennaCondition!AntennaKey)
                'Exit Sub
            Else
                'MsgBox "Record FOUND in Condition table"
                gtSpecCondAnt = gtSpecCondAnt & "Text: " & Trim(rsCondition!ConditionText) & " {/n} "
                If (Len(Trim(rsCondition!ConditionNote)) > 0) Then
                    gtSpecCondAnt = gtSpecCondAnt & "Note: " & Trim(rsCondition!ConditionNote) & " {/n} "
                End If
            End If
            rsAntennaCondition.MoveNext
            If (rsAntennaCondition.EOF) Then GoTo SpcCntAnt
            If (IsNull(rsAntennaCondition!AntennaKey)) Then
                glAntennaKeyTemp = 0
            Else
                glAntennaKeyTemp = rsAntennaCondition!AntennaKey
            End If
        Loop While glAntennaKey = glAntennaKeyTemp
    End If
SpcCntAnt:
    giX = Len(gtSpecCondAnt)
    If (giX = 0) Then Exit Sub
    gtSpecCondAnt = Mid(gtSpecCondAnt, 1, (giX - 7))
        
    BeginTrans
    rsSpcCndAnt.AddNew
    rsSpcCndAnt!PathAntKey = gtPathAntKey
        rsSpcCndAnt!SpecCond = ""    '  Initialize "Memo" field
    rsSpcCndAnt!SpecCond = gtSpecCondAnt
    rsSpcCndAnt.Update
    CommitTrans
        DoEvents

End Sub    '  EsWriteSpcCndAntTable

Sub EsWriteSpcCndFreqTable()

    Dim gtSpecCondFreq As String

    gtSpecCondFreq = ""

    rsFrequencyCondition.Index = "idxFrequencyKey"
    rsFrequencyCondition.Seek "=", glFrequencyKey
    
    If (rsFrequencyCondition.NoMatch) Then
        gtMsg = "Record NOT found in FrequencyCondition table"
        'MsgBox gtMsg
        Exit Sub
    Else
        gtMsg = "Record found in FrequencyCondition table"
        'MsgBox gtMsg
        DoEvents
        Do
            rsCondition.Index = "idxConditionCode"
            rsCondition.Seek "=", rsFrequencyCondition!ConditionCode
            If (rsCondition.NoMatch) Then
                'MsgBox "Record NOT found in Condition table"
                gtSpecCondFreq = gtSpecCondFreq & "Entry NOT found in Condition table:  " & _
                                " FrequencyKey = " & Str(rsFrequencyCondition!FrequencyKey) & _
                                "  /  " & _
                                " ConditionCode = " & Str(rsCondition!ConditionCode)
                'Exit Sub
            Else
                'MsgBox "Record FOUND in Condition table"
                gtSpecCondFreq = gtSpecCondFreq & "Text: " & Trim(rsCondition!ConditionText) & " {/n} "
                If (Len(Trim(rsCondition!ConditionNote)) > 0) Then
                    gtSpecCondFreq = gtSpecCondFreq & "Note: " & Trim(rsCondition!ConditionNote) & " {/n} "
                End If
            End If
            rsFrequencyCondition.MoveNext
            If (rsFrequencyCondition.EOF) Then GoTo SpcCntFreq
        Loop While glFrequencyKey = rsFrequencyCondition!FrequencyKey
    End If
SpcCntFreq:
    giX = Len(gtSpecCondFreq)
    If (giX = 0) Then Exit Sub
    gtSpecCondFreq = Mid(gtSpecCondFreq, 1, (giX - 7))
        
    BeginTrans
    rsSpcCndAnt.AddNew
    rsSpcCndAnt!FreqKey = gtFreqKey
        rsSpcCndAnt!SpecCond = ""    '  Initialize "Memo" field
    rsSpcCndAnt!SpecCond = gtSpecCondFreq
    rsSpcCndAnt.Update
    CommitTrans
        DoEvents

End Sub    '  EsWriteSpcCndFreqTable
        
Sub EsWriteSpcCndLiceTable()
    
    Dim gtSpecCondLice As String

    gtSpecCondLice = ""
    
    rsLicenseCondition.Index = "idxFilingKey"
    rsLicenseCondition.Seek "=", glFilingKey
    
    If (rsLicenseCondition.NoMatch) Then
        gtMsg = "Record NOT found in LicenseCondition table"
        'MsgBox gtMsg
        Exit Sub
    Else
        gtMsg = "Record found in LicenseCondition table"
        'MsgBox gtMsg
        DoEvents
        Do
            rsCondition.Index = "idxConditionCode"
            rsCondition.Seek "=", rsLicenseCondition!ConditionCode
            If (rsCondition.NoMatch) Then
                'MsgBox "Record NOT found in Condition table"
                gtSpecCondLice = gtSpecCondLice & "Entry NOT found in Condition table:  " & _
                                " FilingKey = " & Str(rsLicenseCondition!FilingKey) & _
                                "  /  " & _
                                " ConditionCode = " & Str(rsCondition!ConditionCode)
                'Exit Sub
            Else
                'MsgBox "Record FOUND in Condition table"
                gtSpecCondLice = gtSpecCondLice & "Text: " & Trim(rsCondition!ConditionText) & " {/n} "
                If (Len(Trim(rsCondition!ConditionNote)) > 0) Then
                    gtSpecCondLice = gtSpecCondLice & "Note: " & Trim(rsCondition!ConditionNote) & " {/n} "
                End If
            End If
            rsLicenseCondition.MoveNext
            If (rsLicenseCondition.EOF) Then GoTo SpcCntLice
        Loop While glFilingKey = rsLicenseCondition!FilingKey
    End If
SpcCntLice:
    giX = Len(gtSpecCondLice)
    If (giX = 0) Then Exit Sub
    gtSpecCondLice = Mid(gtSpecCondLice, 1, (giX - 7))
        
    BeginTrans
    rsSpcCndAnt.AddNew
    rsSpcCndAnt!CsFnKey = gtCallSign
        rsSpcCndAnt!SpecCond = ""    '  Initialize "Memo" field
    rsSpcCndAnt!SpecCond = gtSpecCondLice
    rsSpcCndAnt.Update
    CommitTrans
        DoEvents

End Sub    '  EsWriteSpcCndLiceTable
        
Sub EsWriteSpcCndSiteTable()
    
    Dim gtSpecCondSite As String

    gtSpecCondSite = ""
    
    rsSiteCondition.Index = "idxSiteKey"
    rsSiteCondition.Seek "=", glSiteKey
    
    If (rsSiteCondition.NoMatch) Then
        gtMsg = "Record NOT found in SiteCondition table"
        'MsgBox gtMsg
        Exit Sub
    Else
        gtMsg = "Record found in SiteCondition table"
        'MsgBox gtMsg
        DoEvents
        Do
            rsCondition.Index = "idxConditionCode"
            rsCondition.Seek "=", rsSiteCondition!ConditionCode
            If (rsCondition.NoMatch) Then
                'MsgBox "Record NOT found in Condition table"
                gtSpecCondSite = gtSpecCondSite & "Entry NOT found in Condition table:  " & _
                                " SiteKey = " & Str(rsSiteCondition!SiteKey) & _
                                "  /  " & _
                                " ConditionCode = " & Str(rsCondition!ConditionCode)
                'Exit Sub
            Else
                'MsgBox "Record FOUND in Condition table"
                gtSpecCondSite = gtSpecCondSite & "Text: " & Trim(rsCondition!ConditionText) & " {/n} "
                If (Len(Trim(rsCondition!ConditionNote)) > 0) Then
                    gtSpecCondSite = gtSpecCondSite & "Note: " & Trim(rsCondition!ConditionNote) & " {/n} "
                End If
            End If
            rsSiteCondition.MoveNext
            If (rsSiteCondition.EOF) Then GoTo SpcCntSite
        Loop While glSiteKey = rsSiteCondition!SiteKey
    End If
SpcCntSite:
    giX = Len(gtSpecCondSite)
    If (giX = 0) Then Exit Sub
    gtSpecCondSite = Mid(gtSpecCondSite, 1, (giX - 7))
        
    BeginTrans
    rsSpcCndAnt.AddNew
    rsSpcCndAnt!PathSiteKey = gtPathSiteKey
        rsSpcCndAnt!SpecCond = ""    '  Initialize "Memo" field
    rsSpcCndAnt!SpecCond = gtSpecCondSite
    rsSpcCndAnt.Update
    CommitTrans
        DoEvents

End Sub    '  EsWriteSpcCndSiteTable

Sub PopulateDataSource()

    Dim gtDataArray
    Dim gtFileDateTime As String
    Dim gtDate As String
    Dim gtDateY As String
    Dim gtDateM As String
    Dim gtDateD As String
    Dim gtDate1 As String
    Dim gtTime As String
    Dim gtTime1 As String
    Dim gtTime2 As String

    Set dbJet = wsJet.OpenDatabase(gtOutputPathAndFilename)
    Set rsDataSource = dbJet.OpenRecordset("DataSource", dbOpenTable)
    gtFileDateTime = FileDateTime(gtInputDataTableMain)   ' Returns "2/12/93 4:35:47 PM".
    
    giMaxFldCnt = 3
    gtDataArray = ""
    gtDataArray = Split(gtFileDateTime, " ", giMaxFldCnt, 1)
    gtDate1 = gtDataArray(0)
    gtTime1 = gtDataArray(1)
    gtTime2 = gtDataArray(2)
    gtTime = gtTime1 & " " & gtTime2
    gtDataArray = ""
    gtDataArray = Split(gtDate1, "/", giMaxFldCnt, 1)
    gtDateY = Format(Val(gtDataArray(2)), "00")
    If (Len(gtDateY) <> 4) Then
        gtDateY = "20" & gtDateY
    End If
    gtDateM = Format(Val(gtDataArray(0)), "00")
    gtDateD = Format(Val(gtDataArray(1)), "00")
    gtDate = gtDateY & "." & gtDateM & "." & gtDateD
    'MsgBox "pause"
    'DoEvents
    
    BeginTrans
    rsDataSource.AddNew
    rsDataSource!ExportDatabase = "IBFS"
    rsDataSource!ExportDate = gtDate
    rsDataSource!ExportTime = gtTime
    rsDataSource.Update
    CommitTrans
    DoEvents
    rsDataSource.Close
    Set rsDataSource = Nothing
    Set rsProcessLog = Nothing
    dbJet.Close

End Sub    '  PopulateDataSource

Sub WriteProcessLog()
    
    Dim giMdbFF As Integer
    DoEvents
    gxCurrentDateTime = Now

    giMdbFF = FreeFile
    Open (gtOutputPathAndFilename) For Input As giMdbFF
    glMdbSize = LOF(giMdbFF)
    Close giMdbFF
    DoEvents

    BeginTrans
    rsProcessLog.AddNew
    rsProcessLog!ActionCounter = giActionCounter
    rsProcessLog!ActionText = Mid(gtActionText, 1, 50)
    rsProcessLog!CurrentDateTime = gxCurrentDateTime
    rsProcessLog!MdbSize = glMdbSize
    rsProcessLog!InputFileSize = glLengthOfFile
    rsProcessLog!RecordsProcessed = glRecCnt
    rsProcessLog.Update
    CommitTrans
    DoEvents

End Sub    '  WriteProcessLog

Sub WriteMfgModList(gtEquipAntFlag As String, gtMfg As String, gtMod As String)

    Dim gtMfgMod As String

    'Call WriteMfgModList("E", gtTxEquipMfg, gtTxEquipMod)

    gtMfg = Trim(Mid(gtMfg, 1, 25))
    gtMod = Trim(Mid(gtMod, 1, 25))
    If ((Len(gtMfg) > 0) Or (Len(gtMod) > 0)) Then
        gtMfgMod = gtMfg & "^" & gtMod
        rsMfgModList.Index = "idxMfgMod"
        rsMfgModList.Seek "=", Trim(gtMfgMod)
        If (rsMfgModList.NoMatch) Then
            'MsgBox "No match"
            BeginTrans
            rsMfgModList.AddNew
            rsMfgModList!EquipAntFlag = gtEquipAntFlag   '  "A" or "E"
            rsMfgModList!MfgMod = gtMfgMod
            rsMfgModList!Mfg = gtMfg
            rsMfgModList!Mod = gtMod
            rsMfgModList.Update
            CommitTrans
            'MsgBox (gtEquipAntFlag & vbCrLf & gtMfgMod), , "Writing MfgModList"
            'DoEvents
        Else
            'MsgBox (gtEquipAntFlag & vbCrLf & gtMfgMod), , "Duplicate Mfg/Mod record !"
            'DoEvents
        End If
    End If

End Sub    '  WriteMfgModList

Sub WritePathKey()

    rsPathRecord.Index = "idxPathSiteKey"    ' Define current index.
    rsPathRecord.Seek "=", gtPathSiteKey
    If (Not rsPathRecord.NoMatch) Then
        'MsgBox "RX Match"
        BeginTrans
        rsPathRecord.Edit
        'rsPathRecord!PathSiteKey = gtPathSiteKey    '  20
        'rsPathRecord!FacIdNum = glFacIdNum
        If (rsFrequencyTbl!TransModeFix = "T") Then
        
            rsPathRecord!TxAntSiteKey = gtTxAntSiteKey   '  10
            'rsPathRecord!TxTowerSiteKey = gtTxTowerSiteKey   '  10
        
            'If (Len(Trim(gtTxTowerReg)) > 0) Then
            '    rsPathRecord!TowerReg = gtTxTowerReg   '  10)
            'If (Len(Trim(gtTxTowerReg)) > 0) Then
            '    rsPathRecord!TowerReg = gtTxTowerReg   '  10)
            'End If
            'rsPathRecord!TxLocationKey = gtTxLocationKey   '  20
            rsPathRecord!TxAntennaKey = gtTxAntennaKey   '  20
            rsPathRecord!TxCall = gtTxCall   '  10)
            rsPathRecord!TxStationClass = gtTxStationClass
            rsPathRecord!TxEsCoordFlag = gtTxEsCoordFlag
            rsPathRecord!TxAreaOfOpCode = ""   '  1)
            rsPathRecord!TxRadOfOp = ""   '  6)

        Else
                'rsPathRecord!Pr1TowerReg = gtPr1TowerReg   '  10)
                'rsPathRecord!Pr1LocationKey = gtPr1LocationKey   '  20
                'rsPathRecord!Pr1AntennaKey = gtPr1AntennaKey   '  20
                'rsPathRecord!Pr2TowerReg = gtPr2TowerReg   '  10)
                'rsPathRecord!Pr2LocationKey = gtPr2LocationKey   '  20
                'rsPathRecord!Pr2AntennaKey = gtPr2AntennaKey   '  20
                'rsPathRecord!Pr3TowerReg = gtPr3TowerReg   '  10)
                'rsPathRecord!Pr3LocationKey = gtPr3LocationKey   '  20
                'rsPathRecord!Pr3AntennaKey = gtPr3AntennaKey   '  20
                'rsPathRecord!Pr4TowerReg = gtPr4TowerReg   '  10)
                'rsPathRecord!Pr4LocationKey = gtPr4LocationKey   '  20
                'rsPathRecord!Pr4AntennaKey = gtPr4AntennaKey   '  20
            rsPathRecord!RxAntSiteKey = gtRxAntSiteKey   '  10
            'rsPathRecord!RxTowerSiteKey = gtRxTowerSiteKey   '  10
            'rsPathRecord!RxTowerReg = gtRxTowerReg   '  10)
            'rsPathRecord!RxLocationKey = gtRxLocationKey   '  20
            rsPathRecord!RxAntennaKey = gtRxAntennaKey   '  20
            rsPathRecord!RxCall = gtRxCall   '  10)
            rsPathRecord!RxStationClass = gtRxStationClass
            rsPathRecord!RxEsCoordFlag = gtRxEsCoordFlag
            rsPathRecord!RxAreaOfOpCode = ""   '  1)
            rsPathRecord!RxRadOfOp = ""    '  6)

        End If
        rsPathRecord.Update
        CommitTrans
        DoEvents
    Else
        'MsgBox "No RX Match add record"
        BeginTrans
        rsPathRecord.AddNew
        rsPathRecord!PathSiteKey = gtPathSiteKey    '  20
        'rsPathRecord!FacIdNum = glFacIdNum
        If (rsFrequencyTbl!TransModeFix = "T") Then
            'If (Len(Trim(gtTxTowerReg)) > 0) Then
            '    rsPathRecord!TxTowerReg = gtTxTowerReg   '  10)
            'End If
            'rsPathRecord!TxLocationKey = gtTxLocationKey   '  20
            rsPathRecord!TxAntennaKey = gtTxAntennaKey   '  20
            'rsPathRecord!TxCallSign = gtTxCall   '  10)
            rsPathRecord!TxStationClass = gtTxStationClass
            rsPathRecord!TxEsCoordFlag = gtTxEsCoordFlag
        Else
                'rsPathRecord!Pr1TowerReg = gtPr1TowerReg   '  10)
                'rsPathRecord!Pr1LocationKey = gtPr1LocationKey   '  20
                'rsPathRecord!Pr1AntennaKey = gtPr1AntennaKey   '  20
                'rsPathRecord!Pr2TowerReg = gtPr2TowerReg   '  10)
                'rsPathRecord!Pr2LocationKey = gtPr2LocationKey   '  20
                'rsPathRecord!Pr2AntennaKey = gtPr2AntennaKey   '  20
                'rsPathRecord!Pr3TowerReg = gtPr3TowerReg   '  10)
                'rsPathRecord!Pr3LocationKey = gtPr3LocationKey   '  20
                'rsPathRecord!Pr3AntennaKey = gtPr3AntennaKey   '  20
                'rsPathRecord!Pr4TowerReg = gtPr4TowerReg   '  10)
                'rsPathRecord!Pr4LocationKey = gtPr4LocationKey   '  20
                'rsPathRecord!Pr4AntennaKey = gtPr4AntennaKey   '  20
            'rsPathRecord!RxTowerReg = gtRxTowerReg   '  10)
            'rsPathRecord!RxLocationKey = gtRxLocationKey   '  20
            rsPathRecord!RxAntennaKey = gtRxAntennaKey   '  20
            'rsPathRecord!RxCallSign = gtRxCall   '  10)
            rsPathRecord!RxStationClass = gtRxStationClass
            rsPathRecord!RxEsCoordFlag = gtRxEsCoordFlag
        End If
        rsPathRecord.Update
        CommitTrans
        DoEvents
    End If

End Sub    '  WritePathKey

Sub PopulateLicenseeHistoryTable()

    Dim gtInputDataArray

    Set dbJet = wsJet.OpenDatabase(gtOutputPathAndFilename)
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    Set rsLisHistTbl = dbJet.OpenRecordset("IbfsLicenseeHistory", dbOpenTable)
    
    gtActionText = gtActionTextMsg & "Populate Licensee History Table!"
    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    
    gxBeginDateTime = Now
    glBeginSeconds = GetTickCount()
    
    giMaxFldCnt = 8
    
    gtTableName = "IbfsSite"
    gtInputFileName = "licensee_history.dat"
    frmStatus.lblStatus.Caption = "Populating 'Licensee History' table with  < " & gtInputFileName & " >  data !"
    frmStatus.lblStepCurrent.Caption = Str(giActionCounter)
    frmStatus.Refresh
    'Print #giBadDataFF, ""
    'Print #giBadDataFF, "=====>  " & gtInputFileName & "  <====="
    'Print #giBadDataFF, ""
    
    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh

    giIDFF = FreeFile
    Open (gtInputFilePath & gtInputFileName) For Input As giIDFF
    glLengthOfFile = LOF(giIDFF)

    frmStatus.lblFileSize.Caption = Format(glLengthOfFile, "###,###,###0")
    frmStatus.Refresh
    glRecCnt = 0
    glRecLen = 0

    Do While Not EOF(giIDFF)
        glRecCnt = glRecCnt + 1
        glRecLen = glRecLen + Len(gtInputData) + 2
        If ((glRecCnt Mod 100) = 0) Then
            frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
            gsPercentComplete = (glRecLen / glLengthOfFile) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
        End If
        Line Input #giIDFF, gtInputData
        gtInputData = Trim(gtInputData)
        
        If (Len(gtInputData) = 0) Then GoTo SiteTag

        Call NewLineRepair

        gtInputDataArray = ""
        gtInputDataArray = Split(gtInputData, "|", giMaxFldCnt, 1)

        BeginTrans
        rsLisHistTbl.AddNew
        rsLisHistTbl!FilingKey = Val(Trim(gtInputDataArray(0)))    '  dbLong
        rsLisHistTbl!AssignFilingKey = Val(Trim(gtInputDataArray(1)))    '  dbLong
        rsLisHistTbl!LicenseeKey = Val(Trim(gtInputDataArray(2)))    '  dbLong
        rsLisHistTbl!LicenseeAttention = Trim(gtInputDataArray(3))    '  VarChar(80)
        rsLisHistTbl!LicenseePhoneNum = Trim(gtInputDataArray(4))    ' char25)
        rsLisHistTbl!LicenseeFaxNum = Trim(gtInputDataArray(5))    ' char25)
        rsLisHistTbl!LicenseeEMail = Trim(gtInputDataArray(6))    '  VarChar(40)
        
        rsLisHistTbl.Update
        CommitTrans
        DoEvents

SiteTag:
    Loop
    Close (giIDFF)
    
    frmStatus.lblAmtProcessed.Caption = Format(glRecLen, "###,###,##0")
    gsPercentComplete = (glRecLen / glLengthOfFile) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    DoEvents

    Call WriteProcessLog

    rsLisHistTbl.Close
    Set rsLisHistTbl = Nothing
    rsProcessLog.Close
    Set rsProcessLog = Nothing
    dbJet.Close

    'gtCompactMsg = "Compacting Database  < " & gtInputFileName & " >"
    'Call CompactDB
    frmStatus.lblStatus.Caption = "Finished processing  <  " & gtInputFileName & "  >  data !"
    DoEvents

    Exit Sub
    
PopulateLicenseeHistoryTableErr:
    
    gtMsg = "Error in PopulateLicenseeHistoryTable" & vbCrLf
    gtMsg = gtMsg & "Error " & Str(Err.Number) & "  ---  " & Err.Description & vbCrLf
    'Print #giBadDataFF, gtMsg
    MsgBox gtMsg

End Sub    '  PopulateLicenseeHistoryTable


Sub BuildAntSiteDataSet_A_B()


'MsgBox "In BuildAntSiteDataSet_A_B : 1"
'DoEvents

    frmCnvIbfs.Refresh
    frmStatus.Show
    frmStatus.Refresh

    frmStatus.lblStatus.Caption = "Processing 'Site - AntSite A' data !  Please wait . . . ."
    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh


    '  Open database

    Set wsJet = DBEngine.Workspaces(0)

    Set dbJet = wsJet.OpenDatabase(gtOutputPathAndFilename)
    Set rsIbfsSite = dbJet.OpenRecordset("IbfsSite", dbOpenTable)
    gtActionText = gtActionTextMsg & "IbfsSite data!"

    rsIbfsSite.MoveLast
    glNumRecs = rsIbfsSite.RecordCount
    rsIbfsSite.MoveFirst
    frmStatus.lblTotalRecords.Caption = Format(glNumRecs, "###,###,##0")

    '  ==> a <==
    '   Coordinates -- Point
    Set dbJetAntSite_A = wsJet.OpenDatabase(gtTwrLocMdbFileA)
    Set rsAntSite_A = dbJetAntSite_A.OpenRecordset("AntSite_A", dbOpenTable)

    '  ==> B <==
    '   Coordinates -- Point
    Set dbJetAntSite_B = wsJet.OpenDatabase(gtTwrLocMdbFileB)
    Set rsAntSite_B = dbJetAntSite_B.OpenRecordset("AntSite_B", dbOpenTable)


    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)

    glRecCnt = 0

'MsgBox "In BuildAntSiteDataSet_A_B : 2"
'DoEvents

    Do While Not rsIbfsSite.EOF

        glRecCnt = glRecCnt + 1
        If ((glRecCnt Mod 100) = 0) Then
            frmStatus.lblAmtProcessed.Caption = Format(glNumRecs, "###,###,##0")
            gsPercentComplete = (glRecCnt / glNumRecs) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
        End If

        gtTowerFlag = "0"

        Call DecodeSiteTable

        'MsgBox (gtSiteLatDMS & vbCrLf & _
            gtSiteLatSec & vbCrLf & _
            gtSiteLonDMS & vbCrLf & _
            gtSiteLonSec)
        'DoEvents
         
        If ((Val(gtLatSec) = 0) And _
            (Val(gtLatSec) = 0)) Then
'MsgBox "In BuildAntSiteDataSet_A_B : 3"
'DoEvents
            GoTo SkipTowerA3
        End If


        gtTowerSiteInfo1 = gtLatDMS & "|" & gtLonDMS & "|" & _
                            gtDatum & "|" & gtGrEl

        If (giTowerRegFlag <= 0) Then
            '  Invalid Antenna Structure Registration (ASR) number.
            '  Skip record -- a Ant Site B, C, D or E record
'MsgBox "In BuildAntSiteDataSet_A_B : 4"
'DoEvents
            GoTo SkipTowerA1
        Else
            rsAntSite_A.Index = "idxTowerRegA"
            rsAntSite_A.Seek "=", Trim(gtRegistrationNumber) '' gtRegistrationNumber
            If (Not rsAntSite_A.NoMatch) Then
                '  A ASR match
                If (Trim(gtTowerSiteInfo1) <> rsAntSite_A!TowerSiteInfoA) Then
                    '  Check to see if coordiates match
                    'MsgBox ("Coordinates do NOT match -- Tower A" & vbCrLf & _
                            gtTowerSiteInfo1 & " - Ibfs Site" & vbCrLf & rsAntSite_A!TowerSiteInfoA & " - ASR")
                    'DoEvents
                    DoEvents
                    BeginTrans
                    rsIbfsSite.Edit
                        rsIbfsSite!TowerFlag = "9"
                        gtTowerFlag = "9"
                    rsIbfsSite.Update
                    CommitTrans
                    DoEvents
                    GoTo SkipTowerA2
MsgBox "In BuildAntSiteDataSet_A_B : 5"
DoEvents
                Else
                    'MsgBox "Coordinates match"
                    'DoEvents
                    '  Edit a record
                    BeginTrans
                    rsIbfsSite.Edit
                        rsIbfsSite!TowerSiteKey = "A" & Trim(gtTowerReg)
                        rsIbfsSite!TowerFlag = "1"
                        gtTowerFlag = "1"
                    rsIbfsSite.Update
                    CommitTrans
                    DoEvents
                    
                    BeginTrans
                    rsAntSite_A.Edit
                    If (IsNull(rsAntSite_A!AntSite_CountA)) Then
                        glAntSite_CountA = 0    '  Long
                    Else
                        glAntSite_CountA = rsAntSite_A!AntSite_CountA
                    End If
                    rsAntSite_A!AntSite_CountA = glAntSite_CountA + 1  ' dbLong
                    rsAntSite_A.Update
                    CommitTrans
                    DoEvents
                    GoTo SkipTowerA3
                    MsgBox "ASR match and coordinates match"
                    DoEvents
MsgBox "In BuildAntSiteDataSet_A_B : 6"
DoEvents
                End If
            Else
                'MsgBox "NOT as ASR match"
                'DoEvents
                GoTo SkipTowerA1
            End If
        End If

SkipTowerA1:

        rsAntSite_A.Index = "idxTowerSiteInfoA"
        rsAntSite_A.Seek "=", Trim(gtTowerSiteInfo1)
        If (Not rsAntSite_A.NoMatch) Then
            '  Found in A -- Edit record
            BeginTrans
            rsIbfsSite.Edit
                rsIbfsSite!TowerSiteKey = (rsAntSite_A!TowerSiteKeyA)
                    rsIbfsSite!TowerFlag = "1"
                    gtTowerFlag = "1"
            rsIbfsSite.Update
            CommitTrans
            DoEvents
'MsgBox "In BuildAntSiteDataSet_A_B : 7"
'DoEvents
            GoTo SkipTowerA3
        End If

SkipTowerA2:

        '  Point  -- Tower B

        'gtTowerSiteInfo1 = gtLatDMS & "|" & gtLonDMS & "|" & gtDatum

        rsAntSite_B.Index = "idxTowerSiteInfoB"
        rsAntSite_B.Seek "=", Trim(gtTowerSiteInfo2)
        If (Not rsAntSite_B.NoMatch) Then

            '  Found in B -- Edit record
            BeginTrans
            rsAntSite_B.Edit
            rsAntSite_B!AntSite_CountB = rsAntSite_B!AntSite_CountB + 1  ' dbInteger
            rsAntSite_B.Update
            CommitTrans
            DoEvents

            BeginTrans
            rsIbfsSite.Edit
            rsIbfsSite!TowerSiteKey = (rsAntSite_B!TowerSiteKeyB)
            rsIbfsSite!TowerFlag = "2"
            gtTowerFlag = "2"
            rsIbfsSite.Update
            CommitTrans
            DoEvents
MsgBox "In BuildAntSiteDataSet_A_B : 8"
DoEvents
        End If

SkipTowerA3:

        rsIbfsSite.MoveNext

    Loop

    frmStatus.lblStatus.Caption = "FINISHED processing 'Site - AntSite A' data !"

            frmStatus.lblAmtProcessed.Caption = Format(glNumRecs, "###,###,##0")
            gsPercentComplete = (glRecCnt / glNumRecs) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
    DoEvents

    Call WriteProcessLog

    rsIbfsSite.Close
    Set rsIbfsSite = Nothing
    dbJet.Close
    Set dbJet = Nothing
    wsJet.Close
    Set wsJet = Nothing

    frmStatus.lblStatus.Caption = "Finished processing  <  " & gtTwrLocMdbFileA & "  >  data !" & vbCrLf & "  Step  1  of  12"
    'DoEvents

'MsgBox "Exiting BuildAntSiteDataSet_A_B"
'DoEvents

End Sub    '  BuildAntSiteDataSet_A_B

Sub BuildAntSiteDataSet_C_D_E()

    Dim gtTowerSiteKey As String
    Dim glNumRecsC As Long
    Dim glNumRecsD As Long
    Dim glNumRecsE As Long
    
    'Dim gtLocationState As String
    'Dim gtLocationCounty As String
    'Dim gtLocationCity As String
    'Dim gtLocationAddress As String
    Dim glAntSite_CountC As Long
    Dim glAntSite_CountD As Long
    Dim glAntSite_CountE As Long

    frmCnvIbfs.Refresh
    frmStatus.Show
    frmStatus.Refresh

    frmStatus.lblStatus.Caption = "Processing 'Site - AntSite C && D && E' data !  Please wait . . . ."
    frmStatus.lblTotalRecords.Caption = ""
    frmStatus.fraTotalRecords.Visible = False
    frmStatus.lblRecordCount.Caption = ""
    frmStatus.lblPercentCompleted.Caption = ""
    frmStatus.ProgressBar1.Value = 0
    frmStatus.lblFileSize.Caption = ""
    frmStatus.lblAmtProcessed.Caption = ""
    frmStatus.Refresh

    Set wsJet = DBEngine.Workspaces(0)

    Set dbJet = wsJet.OpenDatabase(gtOutputPathAndFilename)
        Set rsIbfsSite = dbJet.OpenRecordset("IbfsSite", dbOpenTable)
        gtActionText = gtActionTextMsg & "Ibfs Site data!"

    rsIbfsSite.MoveLast
    glNumRecs = rsIbfsSite.RecordCount
    rsIbfsSite.MoveFirst
    frmStatus.lblTotalRecords.Caption = Format(glNumRecs, "###,###,##0")

    '  Open databases C, D and E

    '  ==> C <==
    '   Coordinates -- Point and Point/Radius
    
    Set dbJetAntSite_C = wsJet.OpenDatabase(gtTwrLocMdbFileC)
    Set rsAntSite_C = dbJetAntSite_C.OpenRecordset("AntSite_C", dbOpenTable)
    If (rsAntSite_C.BOF) Then
        glNumRecsC = 0
    Else
        rsAntSite_C.MoveLast
        glNumRecsC = rsAntSite_C.RecordCount
        rsAntSite_C.MoveFirst
    End If
    glNumRecsC = 1000000 + glNumRecsC

    ' ==> D <==
    '  No coordinates -- City and City/Radius
    
    Set dbJetAntSite_D = wsJet.OpenDatabase(gtTwrLocMdbFileD)
    Set rsAntSite_D = dbJetAntSite_D.OpenRecordset("AntSite_D", dbOpenTable)
    If (rsAntSite_D.BOF) Then
        glNumRecsD = 0
    Else
        rsAntSite_D.MoveLast
        glNumRecsD = rsAntSite_D.RecordCount
        rsAntSite_D.MoveFirst
    End If
    glNumRecsD = 1000000 + glNumRecsD

    '  ==> E <==
    '  Box
    
    Set dbJetAntSite_E = wsJet.OpenDatabase(gtTwrLocMdbFileE)
    Set rsAntSite_E = dbJetAntSite_E.OpenRecordset("AntSite_E", dbOpenTable)
    If (rsAntSite_E.BOF) Then
        glNumRecsE = 0
    Else
        rsAntSite_E.MoveLast
        glNumRecsE = rsAntSite_E.RecordCount
        rsAntSite_E.MoveFirst
    End If
    glNumRecsE = 1000000 + glNumRecsE

    Set rsProcessLog = dbJet.OpenRecordset("ProcessLog", dbOpenTable)
    glRecCnt = 0


    Do While Not rsIbfsSite.EOF

        glRecCnt = glRecCnt + 1
        If ((glRecCnt Mod 100) = 0) Then
            frmStatus.lblAmtProcessed.Caption = Format(glNumRecs, "###,###,##0")
            gsPercentComplete = (glRecCnt / glNumRecs) * 100
            If (gsPercentComplete >= 100) Then gsPercentComplete = 100
            frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
            frmStatus.ProgressBar1.Value = gsPercentComplete
            frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
            DoEvents
        End If

        Call DecodeSiteTable

    'MsgBox (gtSiteLatDMS & vbCrLf & _
            gtSiteLatSec & vbCrLf & _
            gtSiteLonDMS & vbCrLf & _
            gtSiteLonSec)
    DoEvents

        If ((gtTowerFlag = "1") Or (gtTowerFlag = "2")) Then
            'MsgBox "a Tower A or B"
            'DoEvents
            GoTo SkipRecord_C_D_E
        End If


        '  Point  -- Tower C
        
        gtTowerSiteInfo2 = gtLatDMS & "|" & gtLonDMS & "|" & _
                            gtDatum & "|" & gtGrEl & "|"

        '  City Area of Operation and City with Radius of Operation  -- Tower D

        gtTowerSiteInfo3 = gtLocationState & "|" & gtLocationCounty & "|" & gtLocationCity & "|" & gtLocationAddress & "|" & _
                            gtGrEl & "|" & gtHgtStructure & "|" & gtHgtToTip & "|" & gtStructureType & "|" & _
                            gtLocationTypeCode & "|" & gtLocationClassCode & "|" & "|"

        '  Box Area of Operation -- Tower E
        
        GoTo SkipTowerE
        
        gtTowerSiteInfo4 = gtLatDMS & "|" & gtLonDMS & "|" & _
                            gtLatDMSHi & "|" & gtLonDMSHi & "|" & gtDatum

        '  ==>  Testing to see if Box Area of Operation -- Tower E  <==

        
        If (Abs((Val(Format(Val(rsIbfsSite!MaxLatDeg), "000") & Format(Val(rsIbfsSite!MaxLatMin), "00") & Left(Format(Val(rsIbfsSite!MaxLatSec), "00.0"), 4))) >= 0.1) And _
                Abs((Val(Format(Val(rsIbfsSite!MaxLonDeg), "000") & Format(Val(rsIbfsSite!MaxLonMin), "00") & Left(Format(Val(rsIbfsSite!MaxLonSec), "00.0"), 4))) >= 0.1)) Then
            
            rsAntSite_E.Index = "idxTowerSiteInfoE"
            rsAntSite_E.Seek "=", Trim(gtTowerSiteInfo4)
            If (Not rsAntSite_E.NoMatch) Then
                BeginTrans
                rsAntSite_E.Edit
                    If (IsNull(rsAntSite_E!AntSite_CountE)) Then
                        glAntSite_CountE = 0
                    Else
                        glAntSite_CountE = rsAntSite_E!AntSite_CountE
                    End If
                    rsAntSite_E!AntSite_CountE = glAntSite_CountE + 1 ' dbInteger
                rsAntSite_E.Update
                CommitTrans
                DoEvents

                BeginTrans
                rsIbfsSite.Edit
                    rsIbfsSite!TowerSiteKey = Trim(rsAntSite_E!TowerSiteKeyE)
                    rsIbfsSite!TowerFlag = "5"
                rsIbfsSite.Update
                CommitTrans
                DoEvents

                'MsgBox "Edit E record"
                'DoEvents
            Else
                '  Create a Tower E record
                glNumRecsE = glNumRecsE + 1
                BeginTrans
                rsAntSite_E.AddNew
                    rsAntSite_E!TowerSiteKeyE = Trim("E" & Trim(Format(glNumRecsE, "0000000")))
                    rsAntSite_E!TowerSiteInfoE = Trim(gtTowerSiteInfo4)
                    'rsAntSite_E!TowerRegE= Trim(gtTowerReg)    'dbText, 10)
                    rsAntSite_E!AntSite_CountE = 1   ' dbInteger
                rsAntSite_E.Update
                CommitTrans
                DoEvents
                BeginTrans
                rsIbfsSite.Edit
                    rsIbfsSite!TowerSiteKey = "E" & Trim(Format(glNumRecsE, "0000000"))
                    rsIbfsSite!TowerFlag = "5"
                rsIbfsSite.Update
                CommitTrans
                DoEvents
            End If

            GoTo SkipRecord_C_D_E
        End If

SkipTowerE:

        '  ==>  Testing to see if in Tower D -- City and City/Radius<==
        
        If ((Abs(Val(gtLatSec)) = 0) And _
            (Abs(Val(gtLonSec)) = 0)) Then
            'MsgBox "pause"
            'DoEvents
            
            rsAntSite_D.Index = "idxTowerSiteInfoD"
            rsAntSite_D.Seek "=", Trim(gtTowerSiteInfo3)
            If (Not rsAntSite_D.NoMatch) Then
            '  Tower D record found
                BeginTrans
                rsAntSite_D.Edit
                    If (IsNull(rsAntSite_D!AntSite_CountD)) Then
                        glAntSite_CountD = 0
                    Else
                        glAntSite_CountD = rsAntSite_D!AntSite_CountD
                    End If
                    rsAntSite_D!AntSite_CountD = glAntSite_CountD + 1  ' dbInteger
                rsAntSite_D.Update
                CommitTrans
                DoEvents

                BeginTrans
                rsIbfsSite.Edit
                    rsIbfsSite!TowerSiteKey = Trim(rsAntSite_D!TowerSiteKeyD)
                    rsIbfsSite!TowerFlag = "4"
                rsIbfsSite.Update
                CommitTrans
                DoEvents
            Else
                '  Create a Tower D record
                glNumRecsD = glNumRecsD + 1
                BeginTrans
                rsAntSite_D.AddNew
                    rsAntSite_D!TowerSiteKeyD = Trim("D" & Trim(Format(glNumRecsD, "0000000")))
                    rsAntSite_D!TowerSiteInfoD = Mid(Trim(gtTowerSiteInfo3), 1, 30)
                    rsAntSite_D!AntSite_CountD = 1   ' dbInteger
                rsAntSite_D.Update
                CommitTrans
                DoEvents
                BeginTrans
                rsIbfsSite.Edit
                    rsIbfsSite!TowerSiteKey = "D" & Trim(Format(glNumRecsD, "0000000"))
                    rsIbfsSite!TowerFlag = "4"
                rsIbfsSite.Update
                CommitTrans
                DoEvents
            End If
            GoTo SkipRecord_C_D_E
            
        Else
        
            'MsgBox "pause"
            DoEvents

        End If

        
        '  Record is NOT in D, therefore must be C --

        'If (Abs((Val(gtLatSec)) >= 0.1) Or _
            Abs((Val(gtLonSec)) >= 0.1)) Then
                
                rsAntSite_C.Index = "idxTowerSiteInfoC"
                rsAntSite_C.Seek "=", Trim(gtTowerSiteInfo2)
                If (Not rsAntSite_C.NoMatch) Then

                    '  Found in C -- Edit record
                    BeginTrans
                    rsAntSite_C.Edit
                        rsAntSite_C!AntSite_CountC = rsAntSite_C!AntSite_CountC + 1  ' dbInteger
                    rsAntSite_C.Update
                    CommitTrans
                    DoEvents

                    BeginTrans
                    rsIbfsSite.Edit
                        rsIbfsSite!TowerSiteKey = (rsAntSite_C!TowerSiteKeyC)
                    rsIbfsSite!TowerFlag = "3"
                    rsIbfsSite.Update
                    CommitTrans
                    DoEvents

                Else
                    '  Create a Tower B record
                    glNumRecsC = glNumRecsC + 1
                    BeginTrans
                    rsAntSite_C.AddNew
                        rsAntSite_C!TowerSiteKeyC = Trim("C" & Trim(Format(glNumRecsC, "0000000")))
                        rsAntSite_C!TowerSiteInfoC = Trim(gtTowerSiteInfo2)
                        'rsAntSite_C!TowerRegB = Trim(gtTowerReg)    'dbText, 10)
                        rsAntSite_C!AntSite_CountC = 1   ' dbInteger
                        rsAntSite_C.Update
                    CommitTrans
                    DoEvents
                    BeginTrans
                    rsIbfsSite.Edit
                        rsIbfsSite!TowerSiteKey = "C" & Trim(Format(glNumRecsC, "0000000"))
                    rsIbfsSite!TowerFlag = "3"
                    rsIbfsSite.Update
                    CommitTrans
                    DoEvents
                End If
            
        'Else
        '    MsgBox "Record not matched:"
        '    DoEvents
        'End If

SkipRecord_C_D_E:

        rsIbfsSite.MoveNext

    Loop

    frmStatus.lblStatus.Caption = "FINISHED processing 'Site - AntSite B && C && D' data !"
    
    frmStatus.lblAmtProcessed.Caption = Format(glNumRecs, "###,###,##0")
    gsPercentComplete = (glRecCnt / glNumRecs) * 100
    If (gsPercentComplete >= 100) Then gsPercentComplete = 100
    frmStatus.lblPercentCompleted.Caption = Format(gsPercentComplete, "  ##0.0")
    frmStatus.ProgressBar1.Value = gsPercentComplete
    frmStatus.lblRecordCount.Caption = Format(glRecCnt, "###,###,##0")
    DoEvents

    Call WriteProcessLog

    rsIbfsSite.Close
    Set rsIbfsSite = Nothing
    dbJet.Close
    Set dbJet = Nothing
    wsJet.Close
    Set wsJet = Nothing

    frmStatus.lblStatus.Caption = "Finished processing  <  " & gtTwrLocMdbFileA & "  >  data !" & vbCrLf & "  Step  1  of  12"
    'DoEvents

'MsgBox "Exiting BuildAntSiteDataSet_C_D_E"
'DoEvents

End Sub    '  BuildAntSiteDataSet_C_D_E


Sub DecodeSiteTable()

    '   Table  "IbfsSite"


    '  "SiteKey", dbLong)
    '  "FilingKey", dbLong)
    '  "SiteId", dbText, 20)
    '  "SiteDescription", dbMemo)     '  255
    '  "ContactPerson", dbText, 40)
    '  "SiteStreet1", dbText, 40)
    '  "SiteStreet2", dbText, 40)
    '  "SiteCity", dbText, 20)
    '  "SiteCounty", dbText, 22)
    '  "SiteState", dbText, 2)
    '  "SiteZipcode", dbText, 10)
    '  "SiteTelephone", dbText, 25)
    '  "SiteElevation", dbText, 6)   '  float
    '  "SiteLatDMS", dbText, 10)
    '  "SiteLatSec", dbText, 10)
    '  "SiteLonDMS", dbText, 10)
    '  "SiteLonSec", dbText, 10)
    '  "NadInd", dbText, 2)
    '  "NumVsatsBuilt", dbText, 6)
    '  "VsatReportDate", dbText, 8)
    '  "FaaCoordSw", dbText, 1)
    '  "Comply25209aSw", dbText, 1)
    '  "Comply25209a2Sw", dbText, 1)
    '  "RemoteControlSw", dbText, 1)
    '  "ForeignFreqCoordReqSw", dbText, 1)
    '  "FreqCoordReqSw", dbText, 1)
    '  "AreaOfOperationCode", dbText, 2)
    '  "FaaCoordNotReqSw", dbText, 1)
    '  "Comply25211Sw", dbText, 1)
    '  "TowerSiteKey", dbText, 20)
    '  "TowerFlag", dbText, 1)

    glSiteKey = rsIbfsSite!SiteKey    '  dbLong)
    glFilingKey = rsIbfsSite!FilingKey    '  dbLong)
    gtSiteId = rsIbfsSite!SiteId    '  dbText, 20)
    gtSiteDescription = rsIbfsSite!SiteDescription    '  dbMemo)     '  255
    gtContactPerson = rsIbfsSite!ContactPerson    '  dbText, 40)
    gtSiteStreet1 = rsIbfsSite!SiteStreet1    '  dbText, 40)
    gtSiteStreet2 = rsIbfsSite!SiteStreet2    '  dbText, 40)
    gtSiteCity = rsIbfsSite!SiteCity    '  dbText, 20)
    gtSiteCounty = rsIbfsSite!SiteCounty    '  dbText, 22)
    gtSiteState = rsIbfsSite!SiteState    '  dbText, 2)
    gtSiteZipcode = rsIbfsSite!SiteZipcode    '  dbText, 10)
    gtSiteTelephone = rsIbfsSite!SiteTelephone    '  dbText, 25)
    gtSiteElevation = rsIbfsSite!SiteElevation    '  dbText, 6)   '  float
    gtSiteLatDMS = rsIbfsSite!SiteLatDMS    '  dbText, 10)
    gtSiteLatSec = rsIbfsSite!SiteLatSec    '  dbText, 10)
    gtSiteLonDMS = rsIbfsSite!SiteLonDMS    '  dbText, 10)
    gtSiteLonSec = rsIbfsSite!SiteLonSec    '  dbText, 10)
    gtNadInd = rsIbfsSite!NadInd    '  dbText, 2)
    gtNumVsatsBuilt = rsIbfsSite!NumVsatsBuilt    '  dbText, 6)
    gtVsatReportDate = rsIbfsSite!VsatReportDate    '  dbText, 8)
    gtFaaCoordSw = rsIbfsSite!FaaCoordSw    '  dbText, 1)
    gtComply25209aSw = rsIbfsSite!Comply25209aSw    '  dbText, 1)
    gtomply25209a2Sw = rsIbfsSite!Comply25209a2Sw    '  dbText, 1)
    gtRemoteControlSw = rsIbfsSite!RemoteControlSw    '  dbText, 1)
    gtForeignFreqCoordReqSw = rsIbfsSite!ForeignFreqCoordReqSw    '  dbText, 1)
    gtFreqCoordReqSw = rsIbfsSite!FreqCoordReqSw    '  dbText, 1)
    If (IsNull(rsIbfsSite!AreaOfOperationCode)) Then
        gtAreaOfOperationCode = ""
    Else
        gtAreaOfOperationCode = rsIbfsSite!AreaOfOperationCode    '  dbText, 2)
    End If
    If (IsNull(rsIbfsSite!FaaCoordNotReqSw)) Then
        gtFaaCoordNotReqSw = ""
    Else
        gtFaaCoordNotReqSw = rsIbfsSite!FaaCoordNotReqSw    '  dbText, 1)
    End If
    If (IsNull(rsIbfsSite!Comply25211Sw)) Then
        gtComply25211Sw = ""
    Else
        gtComply25211Sw = rsIbfsSite!Comply25211Sw    '  dbText, 1)
    End If
    If (IsNull(rsIbfsSite!TowerSiteKey)) Then
        gtTowerSiteKey = ""
    Else
        gtTowerSiteKey = rsIbfsSite!TowerSiteKey    '  dbText, 20)
    End If
    If (IsNull(rsIbfsSite!TowerFlag)) Then
        gtTowerFlag = ""
    Else
        gtTowerFlag = rsIbfsSite!TowerFlag     '  dbText, 1)
    End If

    Select Case gtNadInd
        Case Is = "83"
            gtDatum = "NAD83"
        Case Is = "27"
            gtDatum = "NAD27"
        Case Else
            gtDatum = "NAD27"
    End Select

giTowerRegFlag = 0
gtDatum = gtDatum
gtGrEl = gtSiteElevation
gtHgtStructure = ""
gtHgtToTip = ""
gtLatDMS = gtSiteLatDMS
gtLatDMSHi = ""
gtLatSec = gtSiteLatSec
gtLocationAddress = Trim(gtSiteStreet1)
If (Len(Trim(gtSiteStreet2)) > 0) Then
    gtLocationAddress = gtLocationAddress & " / " & Trim(gtSiteStreet2)
End If
gtLocationCity = gtSiteCity
gtLocationClassCode = ""
gtLocationCounty = gtSiteCounty
gtLocationState = gtSiteState
'gtLocationZipcode = gtSiteZipcode         '  dbText, 10)
gtLocationTypeCode = ""
gtLonDMS = gtSiteLonDMS
gtLonDMSHi = ""
gtLonSec = gtSiteLonSec
gtRegistrationNumber = ""
gtStructureType = ""
'gtTowerFlag
'gtTowerReg = ""

'gtSiteLatDMS
'gtSiteLatSec
'gtSiteLonDMS
'gtSiteLonSec

'If (Val(gtSiteLatSec) = 0) Then
'MsgBox "pause", , "DecodeSiteTable"
'DoEvents
'End If

End Sub    '  DecodeSiteTable

Sub WriteSiteInfo()

    rsSiteInfo.Index = "idxAntSiteKey"    ' Define current index.
    rsSiteInfo.Seek "=", gtSiteAntSiteKey
    If (rsSiteInfo.NoMatch) Then

        BeginTrans
        rsSiteInfo.AddNew

        rsSiteInfo!AntSiteKey = gtSiteAntSiteKey   '  20/11

        'rsSiteInfo!StructureOwner = gtSiteStructureOwner   '  20 *
        'rsSiteInfo!TowerArrayFlag = gtSiteTowerArrayFlag   '  1  *

        If (Val(gtSiteTowerReg) > 0) Then
            rsSiteInfo!TowerReg = gtSiteTowerReg   '  10)
        End If
        rsSiteInfo!StructureType = ""    '  gtSiteStructureType   '  9
        rsSiteInfo!Name = ""    '  gtSiteName   '  20)
        rsSiteInfo!Street = Mid(gtSiteStreet, 1, 80) '  80)
        rsSiteInfo!City = gtSiteCity   '  20)
        rsSiteInfo!County = gtSiteCounty   '  30)
        rsSiteInfo!State = gtSiteState   '  2)
        rsSiteInfo!Country = "USA"    '  5)

        rsSiteInfo!FipsCode = gtSiteFipsCode

        If (Mid(gtSiteLatDMS, 2, 9) = "0000000.0") Then
        Else
            rsSiteInfo!LatDMS = gtSiteLatDMS     '  10)
        End If
        rsSiteInfo!LatSec = gtSiteLatSec
        If (Mid(gtSiteLonDMS, 2, 9) = "0000000.0") Then
        Else
            rsSiteInfo!LonDMS = gtSiteLonDMS        '  10)
        End If
        rsSiteInfo!LonSec = gtSiteLonSec

        'rsSiteInfo!LatDMSHi = gtSiteLatDMSHi    '  10)
        'rsSiteInfo!LatSecHi = gtSiteLatSecHi
        'rsSiteInfo!LonDMSHi = gtSiteLonDMSHi         '  10)
        'rsSiteInfo!LonSecHi = gtSiteLonSecHi

        rsSiteInfo!HorizDatum = gtSiteDatum    '  6)
        rsSiteInfo!Nepa = gtSiteNepa   '  1)
        
        rsSiteInfo!GrEl = gtSiteGrEl  '  8)
        rsSiteInfo!HgtStructure = gtSiteHgtStructure   '  8)
        rsSiteInfo!HgtToTip = gtSiteHgtToTip   '  8)

        rsSiteInfo.Update
        CommitTrans
        'MsgBox "Writing Site Info"
        'DoEvents

        gtGroup = Mid(gtSiteAntSiteKey, 1, 1)

        ' AntSiteInfo  TABLE

        rsAntSiteInfo.Index = "idxAntSiteKey"    ' Define current index.
        rsAntSiteInfo.Seek "=", gtSiteAntSiteKey
        If (rsAntSiteInfo.NoMatch) Then
            BeginTrans
            rsAntSiteInfo.AddNew
            rsAntSiteInfo!Group = gtGroup
            rsAntSiteInfo!AntSiteKey = gtSiteAntSiteKey  '   dbText, 20)
            'rsAntSiteInfo!StructureOwnerKey = gtTx  '   dbText, 20)
            'rsAntSiteInfo!TowerArrayFlag = gtTx  '   dbText, 1)
            If (Val(gtSiteTowerReg) > 0) Then
                rsAntSiteInfo!TowerReg = gtSiteTowerReg   '  10)
            End If
            rsAntSiteInfo!StructureType = ""    '  gtSiteStructureType   '  9)
            rsAntSiteInfo!Name = ""    '  gtSiteName   '  20)
            rsAntSiteInfo!Street = Mid(gtSiteStreet, 1, 80) '  80)
            rsAntSiteInfo!City = gtSiteCity  '   dbText, 20)
            rsAntSiteInfo!County = gtSiteCounty  '   dbText, 30)
            rsAntSiteInfo!State = gtSiteState  '   dbText, 2)
            rsAntSiteInfo!Country = "USA"  '   dbText, 5)
            'rsAntSiteInfo!FipsCode = gtTx  '   dbText, 5)
            
            If (Mid(gtSiteLatDMS, 2, 9) = "0000000.0") Then
            Else
                rsAntSiteInfo!LatDMS = gtSiteLatDMS     '  10)
            End If
            rsAntSiteInfo!LatSec = gtSiteLatSec
            If (Mid(gtSiteLonDMS, 2, 9) = "0000000.0") Then
            Else
                rsAntSiteInfo!LonDMS = gtSiteLonDMS        '  10)
            End If
            rsAntSiteInfo!LonSec = gtSiteLonSec

            rsAntSiteInfo!HorizDatum = gtSiteDatum  '   dbText, 6)
            rsAntSiteInfo!Nepa = gtSiteNepa  '   dbText, 1)
            rsAntSiteInfo!GrEl = gtSiteGrEl  '   dbText, 6)
            rsAntSiteInfo!HgtStructure = gtSiteHgtStructure  '   dbText, 6)
            rsAntSiteInfo!HgtToTip = gtSiteHgtToTip  '   dbText, 6)
            rsAntSiteInfo!StatusDate = gtStatusDate
            rsAntSiteInfo.Update
            CommitTrans
            'MsgBox "Writing Site Info"
            'DoEvents
        Else
        
            If (gtStatusDate > rsAntSiteInfo!StatusDate) Then
            BeginTrans
            rsAntSiteInfo.Edit
            rsAntSiteInfo!Group = gtGroup
            rsAntSiteInfo!AntSiteKey = gtSiteAntSiteKey  '   dbText, 20)
            'rsAntSiteInfo!StructureOwnerKey = gtTx  '   dbText, 20)
            'rsAntSiteInfo!TowerArrayFlag = gtTx  '   dbText, 1)
            If (Val(gtSiteTowerReg) > 0) Then
                rsAntSiteInfo!TowerReg = gtSiteTowerReg   '  10)
            End If
            rsAntSiteInfo!StructureType = ""    '  gtSiteStructureType   '  9)
            rsAntSiteInfo!Name = ""    '  gtSiteName   '  20)
            rsAntSiteInfo!Street = Mid(gtSiteStreet, 1, 80) '  80)
            rsAntSiteInfo!City = gtSiteCity  '   dbText, 20)
            rsAntSiteInfo!County = gtSiteCounty  '   dbText, 30)
            rsAntSiteInfo!State = gtSiteState  '   dbText, 2)
            rsAntSiteInfo!Country = "USA"  '   dbText, 5)
            'rsAntSiteInfo!FipsCode = gtTx  '   dbText, 5)
            
            If (Mid(gtSiteLatDMS, 2, 9) = "0000000.0") Then
            Else
                rsAntSiteInfo!LatDMS = gtSiteLatDMS     '  10)
            End If
            rsAntSiteInfo!LatSec = gtSiteLatSec
            If (Mid(gtSiteLonDMS, 2, 9) = "0000000.0") Then
            Else
                rsAntSiteInfo!LonDMS = gtSiteLonDMS        '  10)
            End If
            rsAntSiteInfo!LonSec = gtSiteLonSec

            rsAntSiteInfo!HorizDatum = gtSiteDatum  '   dbText, 6)
            rsAntSiteInfo!Nepa = gtSiteNepa  '   dbText, 1)
            rsAntSiteInfo!GrEl = gtSiteGrEl  '   dbText, 6)
            rsAntSiteInfo!HgtStructure = gtSiteHgtStructure  '   dbText, 6)
            rsAntSiteInfo!HgtToTip = gtSiteHgtToTip  '   dbText, 6)
            rsAntSiteInfo!StatusDate = gtStatusDate
            rsAntSiteInfo.Update
            CommitTrans
            End If
        
        
            'MsgBox Trim(rsUlsLo!TowerSiteKey), , "Duplicate 'Tower Site Key' record !"
            'DoEvents
        End If

    Else

        'MsgBox Trim(rsUlsLo!TowerSiteKey), , "Duplicate 'Tower Site Key FM' record !"
        'DoEvents

    End If
        'gtcallsign
    
    'Call CheckLatLon

    
End Sub    '  WriteSiteInfo

Sub CheckLatLon()

    Dim giBadDataCode As Integer
    
    Dim gdLatDegT As Double
    Dim gdLatSecB As Double
    
    Dim gdLonDegL As Double
    Dim gdLonSecR As Double
    
    Dim gdLonDegLW As Double
    Dim gdLonSecRW As Double
    
    Dim gdLonDegLE As Double
    Dim gdLonSecRE As Double

    Dim gdLatDegTmp As Double
    Dim gdLonDegTmp As Double
    

    giBadDataCode = 0

        'gtCallsign = Trim(gtDataArray(4))    ' Char(14)
        'gtLocationTypeCode = Trim(gtDataArray(6))    ' Char(1)
        'gtLocationClassCode = Trim(gtDataArray(7))    ' Char(1)
        'gtLocationState = Trim(gtDataArray(14))  ' Char(2)
        
        '  ==>  Lat  <==
        'gtLatDeg = Format(Val(Trim(gtDataArray(19))), "00")    ' Char(2)
        'gtLatMin = Format(Val(Trim(gtDataArray(20))), "00")    ' Char(2)
        'gtLatSec = Format(Val(Trim(gtDataArray(21))), "00.0")    ' Char(4)
        'gtLatDir = Trim(gtDataArray(22))    ' Char(1)
        'gtLatDMS = gtLatDir & gtLatDeg & gtLatMin & gtLatSec

        '  ==>  Lon  <==
        'gtLonDeg = Format(Val(Trim(gtDataArray(23))), "000")    ' Char(3)
        'gtLonMin = Format(Val(Trim(gtDataArray(24))), "00")    ' Char(2)
        'gtLonSec = Format(Val(Trim(gtDataArray(25))), "00.0")    ' Char(4)
        'gtLonDir = gtDataArray(26)    ' Char(1)
        'gtLonDMS = gtLonDir & gtLonDeg & gtLonMin & gtLonSec

    'gtMsg = "Callsign = " & Trim(gtCallSign) & vbCrLf & _
            "LocationTypeCode = " & Trim(gtLocationTypeCode) & vbCrLf & _
            "LocationClassCode = " & Trim(gtLocationClassCode) & vbCrLf & _
            "LocationState = " & Trim(gtLocationState) & vbCrLf & _
            "TowerRegistrationNumber = " & Trim(gtTowerRegistrationNumber) & vbCrLf & _
            "LatDMS = " & Trim(gtLatDMS) & vbCrLf & _
            "LonDMS = " & Trim(gtLonDMS)

    Select Case gtLocationState
        Case Is = "AK"    '  Alaska| Lat 5120'N to 7150'N / Lon 130W to 172E
            gdLatDegT = 1 * ((71) + (50 / 60))
            gdLatSecB = 1 * ((51) + (20 / 60))

            gdLonDegLE = 1 * ((172))
            gdLonSecRE = 1 * ((180))
            
            gdLonDegLW = -1 * 180
            gdLonSecRW = -1 * ((130))
            GoTo LatLonBoxTest
        Case Is = "AL"    '  Alabama| Lat 30 11? N to 35 N / Lon 84 53? W to 88 28? W
            gdLatDegT = 1 * ((35))
            gdLatSecB = 1 * ((30) + (11 / 60))
            gdLonDegL = -1 * ((88) + (28 / 60))
            gdLonSecR = -1 * ((84) + (53 / 60))
            GoTo LatLonBoxTest
        Case Is = "AR"    '  Arkansas|  Lat 33 00? N to 36 30? N / Lon 89 39? W to 94 37? W
            gdLatDegT = 1 * ((36) + (30 / 60))
            gdLatSecB = 1 * ((33) + (11 / 60))
            gdLonDegL = -1 * ((94) + (37 / 60))
            gdLonSecR = -1 * ((89) + (39 / 60))
            GoTo LatLonBoxTest
        Case Is = "AZ"    '  Arizona| Lat 31 20? N to 37 N / Lon 109 3? W to 114 49? W
            gdLatDegT = 1 * ((37))
            gdLatSecB = 1 * ((31) + (20 / 60))
            gdLonDegL = -1 * ((114) + (49 / 60))
            gdLonSecR = -1 * ((109) + (3 / 60))
            GoTo LatLonBoxTest
        Case Is = "CA"    '  California| Lat 32 32? N to 42 N / Lon 114 8? W to 124 26? W
            gdLatDegT = 1 * ((42))
            gdLatSecB = 1 * ((3) + (32 / 60))
            gdLonDegL = -1 * ((124) + (26 / 60))
            gdLonSecR = -1 * ((114) + (8 / 60))
            GoTo LatLonBoxTest
        Case Is = "CO"    '  Colorado|  Lat 37N to 41N / Lon 10203'W to 10903'W
            gdLatDegT = 1 * ((41))
            gdLatSecB = 1 * ((37))
            gdLonDegL = -1 * ((109) + (3 / 60))
            gdLonSecR = -1 * ((102) + (3 / 60))
            GoTo LatLonBoxTest
        Case Is = "CT"    '  Connecticut| Lat 4058? N to 4203? N / Lon 7147? W to 7344? W
            gdLatDegT = 1 * ((42) + (3 / 60))
            gdLatSecB = 1 * ((40) + (58 / 60))
            gdLonDegL = -1 * ((73) + (44 / 60))
            gdLonSecR = -1 * ((71) + (47 / 60))
            GoTo LatLonBoxTest
        Case Is = "DC"    '  District of Columbia|139680|140400|276840|277800
            gdLatDegT = 1 * ((39))
            gdLatSecB = 1 * ((38.78))
            gdLonDegL = -1 * ((77.12))
            gdLonSecR = -1 * ((76.9))
            GoTo LatLonBoxTest
        Case Is = "DE"    '  Delaware| Lat 38 27? N to 39 50? N / Lon 75 3? W to 75 47? W
            gdLatDegT = 1 * ((39) + (50 / 60))
            gdLatSecB = 1 * ((38) + (27 / 60))
            gdLonDegL = -1 * ((75) + (47 / 60))
            gdLonSecR = -1 * ((75) + (3 / 60))
            GoTo LatLonBoxTest
        Case Is = "FL"    '  Florida| Lat 2427? N to 31 N / Lon 8002? W to 8738? W
            gdLatDegT = 1 * ((31))
            gdLatSecB = 1 * ((24) + (27 / 60))
            gdLonDegL = -1 * ((87) + (38 / 60))
            gdLonSecR = -1 * ((80) + (2 / 60))
            GoTo LatLonBoxTest
        Case Is = "GA"    '  Georgia| Lat 30.356 - 34.985 N / Lon 80.840 - 85.605 W
            gdLatDegT = 1 * ((34.985))
            gdLatSecB = 1 * ((30.356))
            gdLonDegL = -1 * ((85.605))
            gdLonSecR = -1 * ((80.84))
            GoTo LatLonBoxTest

        Case Is = "GM"    '  Gulf of Mexico|93600|108180|288000|352800
            GoTo ExitCheckLatLon
        Case Is = "HI"    '  Hawaii|  Lat 18 55? N to 28 27? N / Lon 154 48? W to 178 22? W
            gdLatDegT = 1 * ((28) + (27 / 60))
            gdLatSecB = 1 * ((18) + (55 / 60))
            gdLonDegL = -1 * ((178) + (22 / 60))
            gdLonSecR = -1 * ((154) + (48 / 60))
            GoTo LatLonBoxTest
        Case Is = "IA"    '  Iowa| Lat 40 23? N to 43 30? N / Lon 90 8? W to 96 38? W
            gdLatDegT = 1 * ((43) + (30 / 60))
            gdLatSecB = 1 * ((40) + (23 / 60))
            gdLonDegL = -1 * ((96) + (38 / 60))
            gdLonSecR = -1 * ((90) + (8 / 60))
            GoTo LatLonBoxTest
        Case Is = "ID"    '  Idaho| Lat 42 N to 49 N / Long 11103? W to 11715? W
            gdLatDegT = 1 * ((49))
            gdLatSecB = 1 * ((42))
            gdLonDegL = -1 * ((117) + (15 / 60))
            gdLonSecR = -1 * ((111) + (3 / 60))
            GoTo LatLonBoxTest
        Case Is = "IL"    '  Illinois| Lat 36 58? N to 42 30? N / Lon 87 30? W to 91 31? W
            gdLatDegT = 1 * ((42) + (30 / 60))
            gdLatSecB = 1 * ((36) + (58 / 60))
            gdLonDegL = -1 * ((91) + (31 / 60))
            gdLonSecR = -1 * ((87) + (30 / 60))
            GoTo LatLonBoxTest
        Case Is = "IN"    '  Indiana| Lat 37 46? N to 41 46? N / Lon 84 47? W to 88 6? W
            gdLatDegT = 1 * ((41) + (46 / 60))
            gdLatSecB = 1 * ((37) + (46 / 60))
            gdLonDegL = -1 * ((88) + (6 / 60))
            gdLonSecR = -1 * ((84) + (47 / 60))
            GoTo LatLonBoxTest
        Case Is = "KS"    '  Kansas|  Lat 37 N to 40 N / Lon 94 35? W to 102 3? W
            gdLatDegT = 1 * ((40))
            gdLatSecB = 1 * ((37))
            gdLonDegL = -1 * ((102) + (3 / 60))
            gdLonSecR = -1 * ((94) + (35 / 60))
            GoTo LatLonBoxTest
        Case Is = "KY"    '  Kentucky| Lat 36 30? N to 39 09? N / Lon 81 58? W to 89 34? W
            gdLatDegT = 1 * ((39) + (9 / 60))
            gdLatSecB = 1 * ((36) + (30 / 60))
            gdLonDegL = -1 * ((89) + (34 / 60))
            gdLonSecR = -1 * ((81) + (58 / 60))
            GoTo LatLonBoxTest
        Case Is = "LA"    '  Louisiana| Lat 28 56? N to 33 01? N / Lon 88 49? W to 94 03? W
            gdLatDegT = 1 * ((33) + (1 / 60))
            gdLatSecB = 1 * ((28) + (56 / 60))
            gdLonDegL = -1 * ((94) + (3 / 60))
            gdLonSecR = -1 * ((88) + (49 / 60))
            GoTo LatLonBoxTest
        Case Is = "MA"    '  Massachusetts| Lat 41 14? N to 42 53? N / Lon 69 56? W to 73 30? W
            gdLatDegT = 1 * ((42) + (53 / 60))
            gdLatSecB = 1 * ((41) + (14 / 60))
            gdLonDegL = -1 * ((73) + (30 / 60))
            gdLonSecR = -1 * ((69) + (56 / 60))
            GoTo LatLonBoxTest
        Case Is = "MD"    '  Maryland|  Lat 37 53? N to 39 43? N / Lon 75 03? W to 79 29? W
            gdLatDegT = 1 * ((39) + (43 / 60))
            gdLatSecB = 1 * ((37) + (53 / 60))
            gdLonDegL = -1 * ((79) + (29 / 60))
            gdLonSecR = -1 * ((75) + (3 / 60))
            GoTo LatLonBoxTest
        Case Is = "ME"    '  Maine| Lat 42 58? N to 47 28? N / Lon 66 57? W to 71 5? W
            gdLatDegT = 1 * ((47) + (28 / 60))
            gdLatSecB = 1 * ((42) + (58 / 60))
            gdLonDegL = -1 * ((71) + (5 / 60))
            gdLonSecR = -1 * ((66) + (57 / 60))
            GoTo LatLonBoxTest
        Case Is = "MI"    '  Michigan|  Lat 41 41' N to 48 18' N  Lon 82 7' W to 90 25' W
            gdLatDegT = 1 * ((48) + (18 / 60))
            gdLatSecB = 1 * ((41) + (41 / 60))
            gdLonDegL = -1 * ((90) + (25 / 60))
            gdLonSecR = -1 * ((82) + (7 / 60))
            GoTo LatLonBoxTest
        Case Is = "MN"    '  Minnesota| Lat 43 30? N to 49 23? N / Lon 89 29? W to 97 14? W
            gdLatDegT = 1 * ((49) + (23 / 60))
            gdLatSecB = 1 * ((43) + (30 / 60))
            gdLonDegL = -1 * ((97) + (14 / 60))
            gdLonSecR = -1 * ((89) + (29 / 60))
            GoTo LatLonBoxTest
        Case Is = "MO"    '  Missouri|  Lat 36 N to 40 37? N / Lon 89 6? W to 95 46? W
            gdLatDegT = 1 * ((40) + (37 / 60))
            gdLatSecB = 1 * ((36))
            gdLonDegL = -1 * ((95) + (46 / 60))
            gdLonSecR = -1 * ((89) + (6 / 60))
            GoTo LatLonBoxTest
        Case Is = "MS"    '  Mississippi| Lat 30 12? N to 35 N / Lon 88 06? W to 91 39? W
            gdLatDegT = 1 * ((35))
            gdLatSecB = 1 * ((30) + (12 / 60))
            gdLonDegL = -1 * ((91) + (39 / 60))
            gdLonSecR = -1 * ((88) + (6 / 60))
            GoTo LatLonBoxTest
        Case Is = "MT"    '  Montana| Lat 44 21? N to 49 N / Lon 104 2? W to 116 3? W
            gdLatDegT = 1 * ((49))
            gdLatSecB = 1 * ((44) + (21 / 60))
            gdLonDegL = -1 * ((116) + (3 / 60))
            gdLonSecR = -1 * ((104) + (2 / 60))
            GoTo LatLonBoxTest
        Case Is = "NC"    '  North Carolina| Lat 33 50? N to 36 35? N / Lon 75 28? W to 84 19? W
            gdLatDegT = 1 * ((36) + (35 / 60))
            gdLatSecB = 1 * ((33) + (50 / 60))
            gdLonDegL = -1 * ((84) + (19 / 60))
            gdLonSecR = -1 * ((75) + (28 / 60))
            GoTo LatLonBoxTest
        Case Is = "ND"    '  North Dakota| Lat 45 56? N to 49 00? N / Lon 96 33? W to 104 03? W
            gdLatDegT = 1 * ((49))
            gdLatSecB = 1 * ((45) + (56 / 60))
            gdLonDegL = -1 * ((104) + (3 / 60))
            gdLonSecR = -1 * ((96) + (33 / 60))
            GoTo LatLonBoxTest
        Case Is = "NE"    '  Nebraska| Lat 40 N to 43 N / Lon 95 19' W to 104 03' W
            gdLatDegT = 1 * ((43))
            gdLatSecB = 1 * ((40))
            gdLonDegL = -1 * ((104) + (3 / 60))
            gdLonSecR = -1 * ((95) + (19 / 60))
            GoTo LatLonBoxTest
        Case Is = "NH"    '  New Hampshire|Lat 42 42? N to 45 18? N / Lon 70 36? W to 72 33? W
            gdLatDegT = 1 * ((45) + (18 / 60))
            gdLatSecB = 1 * ((42) + (42 / 60))
            gdLonDegL = -1 * ((72) + (33 / 60))
            gdLonSecR = -1 * ((70) + (36 / 60))
            GoTo LatLonBoxTest
        Case Is = "NJ"    '  New Jersey|Lat 38 56? N to 41 21? N / Lon 73 54? W to 75 34? W
            gdLatDegT = 1 * ((41) + (21 / 60))
            gdLatSecB = 1 * ((38) + (56 / 60))
            gdLonDegL = -1 * ((75) + (34 / 60))
            gdLonSecR = -1 * ((73) + (54 / 60))
            GoTo LatLonBoxTest
        Case Is = "NM"    '  New Mexico|Lat 31 20? N to 37 N / Lon  103 W to 109 3? W
            gdLatDegT = 1 * ((37))
            gdLatSecB = 1 * ((31) + (20 / 60))
            gdLonDegL = -1 * ((109) + (3 / 60))
            gdLonSecR = -1 * ((103))
            GoTo LatLonBoxTest
        Case Is = "NV"    '  Nevada|Lat 35 N to 42 N / Lon 114 2? W to 120 W
            gdLatDegT = 1 * ((42))
            gdLatSecB = 1 * ((35))
            gdLonDegL = -1 * ((120))
            gdLonSecR = -1 * ((114) + (2 / 60))
            GoTo LatLonBoxTest
        Case Is = "NY"    '  New York| Lat 40 30? N to 45 1? N / Lon 71 51? W to 79 46? W
            gdLatDegT = 1 * ((45) + (1 / 60))
            gdLatSecB = 1 * ((40) + (30 / 60))
            gdLonDegL = -1 * ((79) + (46 / 60))
            gdLonSecR = -1 * ((71) + (51 / 60))
            GoTo LatLonBoxTest
        Case Is = "OH"    '  Ohio| Lat 38 24? N to 41 59? N / Lon 80 31? W to 84 49? W
            gdLatDegT = 1 * ((41) + (59 / 60))
            gdLatSecB = 1 * ((38) + (24 / 60))
            gdLonDegL = -1 * ((79) + (84 * 49))
            gdLonSecR = -1 * ((80) + (31 / 60))
            GoTo LatLonBoxTest
        Case Is = "OK"    '  Oklahoma|  Lat 3337' N to 37 N / Lon 94 26' W to 103 W
            gdLatDegT = 1 * ((37))
            gdLatSecB = 1 * ((33) + (37 / 60))
            gdLonDegL = -1 * ((103) + (0 * 49))
            gdLonSecR = -1 * ((94) + (26 / 60))
            GoTo LatLonBoxTest
        Case Is = "OR"    '  Oregon|  Lat 42 N to 46 18? N / Lon 116 28? W to 124 38? W
            gdLatDegT = 1 * ((46) + (18 / 60))
            gdLatSecB = 1 * ((42))
            gdLonDegL = -1 * ((124) + (38 * 49))
            gdLonSecR = -1 * ((116) + (28 / 60))
            GoTo LatLonBoxTest
        Case Is = "PA"    '  Pennsylvania| Lat 3943? N to 4216? N / Lon 7441? W to 8031? W
            gdLatDegT = 1 * ((42) + (16 / 60))
            gdLatSecB = 1 * ((39) + (43 / 60))
            gdLonDegL = -1 * ((80) + (31 * 49))
            gdLonSecR = -1 * ((74) + (41 / 60))
            GoTo LatLonBoxTest
        Case Is = "PR"    '  Puerto Rico|Lat 17.7 N to 18.6 N / Lon 65.1 to 67.6 W
            gdLatDegT = 1 * ((18.6))
            gdLatSecB = 1 * ((17.7))
            gdLonDegL = -1 * ((67.6) + (0 * 49))
            gdLonSecR = -1 * ((65.1))
            GoTo LatLonBoxTest
        Case Is = "RI"    '  Rhode Island| Lat 41 09' N to 42 01' N / Lon 71 07' W to 71 53' W
            gdLatDegT = 1 * ((42) + (1 / 60))
            gdLatSecB = 1 * ((41) + (9 / 60))
            gdLonDegL = -1 * ((71) + (53 / 60))
            gdLonSecR = -1 * ((71) + (7 / 60))
            GoTo LatLonBoxTest
        Case Is = "SC"    '  South Carolina| Lat 32 2? N to 35 13? N / Lon 78 32? W to 83 21? W
            gdLatDegT = 1 * ((35) + (13 / 60))
            gdLatSecB = 1 * ((32) + (2 / 60))
            gdLonDegL = -1 * ((83) + (21 / 60))
            gdLonSecR = -1 * ((78) + (7 / 60))
            GoTo LatLonBoxTest
        Case Is = "SD"    '  South Dakota| Lat 42 29? N to 45 56? N / Lon 96 26? W to 104 03? W
            gdLatDegT = 1 * ((45) + (56 / 60))
            gdLatSecB = 1 * ((42) + (29 / 60))
            gdLonDegL = -1 * ((104) + (3 / 60))
            gdLonSecR = -1 * ((96) + (26 / 60))
            GoTo LatLonBoxTest
        Case Is = "TN"    '  Tennessee|  Lat 34 59? N to 36 41? N / Lon 81 39? W to 90 19? W
            gdLatDegT = 1 * ((36) + (41 / 60))
            gdLatSecB = 1 * ((34) + (59 / 60))
            gdLonDegL = -1 * ((90) + (19 / 60))
            gdLonSecR = -1 * ((81) + (39 / 60))
            GoTo LatLonBoxTest
        Case Is = "TX"    '  Texas| Lat  25 50? N to 36 30? N  / Lon 93 31? W to 106 39? W
            gdLatDegT = 1 * ((36) + (30 / 60))
            gdLatSecB = 1 * ((25) + (50 / 60))
            gdLonDegL = -1 * ((106) + (39 / 60))
            gdLonSecR = -1 * ((93) + (31 / 60))
            GoTo LatLonBoxTest
        Case Is = "UT"    '  Utah|  Lat 37 N to 42 N / Lon 109 3? W to 114 3? W
            gdLatDegT = 1 * ((42))
            gdLatSecB = 1 * ((37))
            gdLonDegL = -1 * ((114) + (3 / 60))
            gdLonSecR = -1 * ((109) + (3 / 60))
            GoTo LatLonBoxTest
        Case Is = "VA"    '  Virginia| Lat 36 32? N to 39 28? N / Lon 75 15? W to 83 41? W
            gdLatDegT = 1 * ((41) + (28 / 60))
            gdLatSecB = 1 * ((36) + (32 / 60))
            gdLonDegL = -1 * ((83) + (3 / 60))
            gdLonSecR = -1 * ((75) + (15 / 60))
            GoTo LatLonBoxTest
        Case Is = "VI"    '  [United States] Virgin Islands -- unincorporated territory consisting of three districts: St. Croix, St. John, and St. Thomas|63600|66240|232380|234360"
                            ' N 17.65 to 18.5 / W 65.5 to W64.5
            gdLatDegT = 1 * ((18.5))
            gdLatSecB = 1 * ((17.6))
            gdLonDegL = -1 * ((65.5))
            gdLonSecR = -1 * ((64.5))
            GoTo LatLonBoxTest
        Case Is = "VT"    '  Vermont|  Lat 42 44? N to 45 1? N / Lon 71 28? W to 73 26? W
            gdLatDegT = 1 * ((45) + (1 / 60))
            gdLatSecB = 1 * ((42) + (44 / 60))
            gdLonDegL = -1 * ((73) + (26 / 60))
            gdLonSecR = -1 * ((71) + (28 / 60))
            GoTo LatLonBoxTest
        Case Is = "WA"    '  Washington| Lat 45 33? N to 49 N / Lon 116 55? W to 124 46? W
            gdLatDegT = 1 * ((49))
            gdLatSecB = 1 * ((45) + (33 / 60))
            gdLonDegL = -1 * ((124) + (46 / 60))
            gdLonSecR = -1 * ((116) + (55 / 60))
            GoTo LatLonBoxTest
        Case Is = "WI"    '  Wisconsin| Lat 42 30? N to 47 05? N / Lon 86 46? W to 92 53? W
            gdLatDegT = 1 * ((47) + (53 / 60))
            gdLatSecB = 1 * ((42) + (30 / 60))
            gdLonDegL = -1 * ((92) + (46 / 60))
            gdLonSecR = -1 * ((86) + (46 / 60))
            GoTo LatLonBoxTest
        Case Is = "WV"    '  West Virginia| Lat 37 12? N to 40 39? N / Lon 77 43? W to 82 39? W
            gdLatDegT = 1 * ((40) + (39 / 60))
            gdLatSecB = 1 * ((37) + (12 / 60))
            gdLonDegL = -1 * ((82) + (39 / 60))
            gdLonSecR = -1 * ((77) + (43 / 60))
            GoTo LatLonBoxTest
        Case Is = "WY"    '  Wyoming| Lat 41N to 45N / Lon    104 104'W to 1113'W
            gdLatDegT = 1 * ((45))
            gdLatSecB = 1 * ((41))
            gdLonDegL = -1 * ((111) + (3 / 60))
            gdLonSecR = -1 * ((104) + (3 / 60))
            GoTo LatLonBoxTest

        'Case Is = "AA"    '  Armed Forces-Americas (excluding Canada)||||
        'Case Is = "AE"    '  Armed Forces-Eur., Mid. East, Afr., Can.||||
        'Case Is = "AP"    '  Armed Forces - Pacific||||
        
        Case Is = "AS"    '  American Samoa  unincorporated territory |0|324000|0|648000
                            ' S14.20, S14.40 / W170.86, W170.54
            gdLatDegT = -1 * ((14.2))
            gdLatSecB = -1 * ((14.4))
            gdLonDegL = -1 * ((170.86))
            gdLonSecR = -1 * ((170.54))
            GoTo LatLonBoxTest

        Case Is = "GU"    '  Guam   unincorporated territory |47520|49200|520200|522000
                            ' N13.20, N13.75 /E 144.50, E 145.15
            gdLatDegT = 1 * ((13.75))
            gdLatSecB = 1 * ((13.2))
            gdLonDegL = 1 * ((144.5))
            gdLonSecR = 1 * ((145.15))
            GoTo LatLonBoxTest
            
        Case Is = "MP"    '  Commonwealth of the Northern Mariana Islands (CNMI)
                        '  consists of fifteen islands   1408' to 2033'N, 14454 to 14604'E
            gdLatDegT = 1 * ((20) + (33 / 60))
            gdLatSecB = 1 * ((14) + (8 / 60))
            gdLonDegL = 1 * ((146) + (4 / 60))
            gdLonSecR = 1 * ((144) + (54 / 60))
            GoTo LatLonBoxTest
        'Case Is = "UM"    '  United States Minor Outlying Islands|0|324000|0|648000"
            ' Pacific Ocean:  Baker Island, Howland Island, Jarvis Island, Johnston Atoll, Kingman Reef, Midway Islands, Navassa Island, Palmyra Atoll, and Wake Island.
            ' Caribbean Sea:  Bajo Nuevo Bank and Serranilla Bank

'  Not part of USA
        'Case Is = "MH"    '  Republic of the Marshall Islands (RMI)"
                            ' N7.62 , N7.24 / E168.5 , E169.0
        '    gdLatDegT = 1 * ((45) )
        '    gdLatSecB = 1 * ((41) )
        '    gdLonDegL = -1 * ((111) + (3/ 60))
        '    gdLonSecR = -1 * ((104) + (3/ 60))
        '    GoTo LatLonBoxTest
        'Case Is = "PW"    '  Republic of Palau||||"
        '    gdLatDegT = 1 * ((45) )
        '    gdLatSecB = 1 * ((41) )
        '    gdLonDegL = -1 * ((111) + (3/ 60))
        '    gdLonSecR = -1 * ((104) + (3/ 60))
        '    GoTo LatLonBoxTest
        'Case Is = "FM"    '  Federated States of Micronesia||||
        '    gdLatDegT = 1 * ((45) )
        '    gdLatSecB = 1 * ((41) )
        '    gdLonDegL = -1 * ((111) + (3/ 60))
        '    gdLonSecR = -1 * ((104) + (3/ 60))
        '    GoTo LatLonBoxTest
    Case Else
        
        'gtMsg = "CallSign = " & gtCallSign & vbCrLf & _
                "TowerReg = " & Trim(gtTowerRegistrationNumber) & vbCrLf & _
                "StaCla = " & Trim(gtLocationTypeCode) & vbCrLf & _
                "LocationState = " & gtLocationState & vbCrLf & _
                "LatDMS = " & gtLatDMS & vbCrLf & _
                "LonDMS = " & gtLonDMS
        'MsgBox gtMsg, , "Location State NULL"
        DoEvents
        giBadDataCode = 1
        GoTo BadData
    End Select

LatLonBoxTest:
    
    If (gtLocationState = "AK") Then
    
    gdLatDegTmp = Val(gtSiteLatSec) / 3600
    gdLonDegTmp = Val(gtSiteLonSec) / 3600
    
        If (((gdLatDegTmp <= gdLatDegT) And (gdLatDegTmp >= gdLatSecB)) And _
            (((gdLonDegTmp >= gdLonDegLW) And (gdLonDegTmp <= gdLonSecRW)) Or _
            ((gdLonDegTmp >= gdLonDegLE) And (gdLonDegTmp <= gdLonSecRE)))) Then
            ' OK
            GoTo ExitCheckLatLon
        Else
            giBadDataCode = 2
        End If
    Else
        If (((gdLatDegTmp <= gdLatDegT) And (gdLatDegTmp >= gdLatSecB)) And _
            ((gdLonDegTmp >= gdLonDegL) And (gdLonDegTmp <= gdLonSecR))) Then
            ' OK
            GoTo ExitCheckLatLon
        Else
            giBadDataCode = 2
        End If
    End If

BadData:
    
    'gtMsg = "CallSign = " & gtCallSign & vbCrLf & _
                    "TowerReg = " & Trim(gtTowerRegistrationNumber) & vbCrLf & _
                    "StaCla = " & Trim(gtLocationTypeCode) & vbCrLf & _
                    "LocationState = " & gtLocationState & vbCrLf & _
                    "LatDMS = " & gtLatDMS & vbCrLf & _
                    "LonDMS = " & gtLonDMS
    'MsgBox gtMsg, , "CheckLatLon"
    DoEvents


'gtOutputData = gtCallSign & "|" & _
               Trim(gtTowerRegistrationNumber) & "|" & _
               Trim(gtLocationTypeCode) & "|" & _
               Trim(gtLocationState) & "|" & _
               gtLatDMS & "|" & _
               gtLonDMS

gtOutputData = gtCallSign & "|" & _
               Trim(gtLocationTypeCode) & "|" & _
               Trim(gtLocationState) & "|" & _
               gtLatDMS & "|" & _
               gtLonDMS

    Select Case giBadDataCode
        Case Is = 1
            Print #giBadDataFF, "Missing State Code"
            Print #giBadDataFF, gtOutputData
            Print #giBadDataFF, ""
            
            MsgBox gtInputData, , "Missing State Code"
            DoEvents

        Case Is = 2
            'Print #giBadDataFF, "Bad Lat / Lon"
            Print #giBadDataFF, gtOutputData
            Print #giBadDataFF, ""
            'MsgBox gtInputData, , "Bad Lat / Lon"
            DoEvents
        Case Is = 1
        Case Is = 1
    
    Case Else
    
    End Select

'MsgBox "pause", , "CheckLatLon"
'DoEvents


ExitCheckLatLon:

    '  Freely associated states
        '* Republic of the Marshall Islands  ---- MH = N/E  Marshall Islands
        '* Federated States of Micronesia
        '* Republic of Palau  ---- PW = N/E  Palau   730North    13430East

     '  GM = N/W  Gulf of Mexico
     '  AS = S/W  American Samoa  S110400 / S142000  / w1704300  /  w1692700
     '  FM = N/E  Federated States of Micronesia
     '  GU = N/E  Guam   13 28 N, 144 47 E  or 13 28 N, 144 47 E
     '  MP = N/E  Northern Marianas Island
     '  UM = United States Minor Islands
            '  Micronesia                FM
            '3 Northern Marianas Islands MP
            '2 Johnston Atoll            N/W
            '2 Midway Atoll              N/W
            '3 Howland Island            N/W
            '3 Kingman Reef              N/W
            '3 Palmyra Island            N/W
            '3 Wake Island               N/E
            '3 Baker Island              S/W
            '3 Jarvis Island             S/W

End Sub    '  CheckLatLon

Sub WriteOutFreqList()

    Dim glFreqCnt As Long
    gtFccRadSvc = gtRadSvc
    gtTxStationClass = gtTxClassStation
    gtRxStationClass = ""

    Set rsFreqList = dbJet.OpenRecordset("FreqList", dbOpenTable)

    gtFreqC = Format(gdFreqC, "00000000.00000000")           '  Lower Freq
    glFreqCnt = 0
    rsFreqList.Index = "idxFreqListKey"    ' Define current index.
    rsFreqList.Seek "=", Trim(Trim(gtFreqC) & Trim(gtFccRadSvc) & Trim(gtTxStationClass) & Trim(gtRxStationClass))
    If (rsFreqList.NoMatch) Then
        BeginTrans
        rsFreqList.AddNew
        rsFreqList!FreqListKey = Trim(Trim(gtFreqC) & Trim(gtFccRadSvc) & Trim(gtTxStationClass) & Trim(gtRxStationClass))
        rsFreqList!Freq = Trim(gtFreqC)
        rsFreqList!FccRadSvc = Trim(gtFccRadSvc)
        rsFreqList!TxClassStation = Trim(gtTxStationClass)
        rsFreqList!RxClassStation = Trim(gtRxStationClass)
        rsFreqList!FreqCnt = 1
        rsFreqList.Update
        CommitTrans
    Else
        glFreqCnt = rsFreqList!FreqCnt + 1

        BeginTrans
        rsFreqList.Edit
        rsFreqList!FreqCnt = glFreqCnt
        rsFreqList.Update
        CommitTrans
        'MsgBox ("1 FreqCnt = " & Str(glFreqCnt)), , "WriteOutFreqList"
        'DoEvents
    End If

    rsFreqList.Close
    Set rsFreqList = Nothing

End Sub    '  WriteOutFreqList

Sub WriteAntSiteCallSign()

    Dim gtCallSignData As String
    Dim giPosCallSign As Integer
    
    Dim gtRadSvcData As String
    Dim giPosRadSvc As Integer
    
    Dim glCallSignCount As Integer
    Dim glFreqCount As Integer
    
    rsAntSiteCallSign.Index = "idxAntSiteKey"    ' Define current index.
    rsAntSiteCallSign.Seek "=", gtAntSiteKey
    If (rsAntSiteCallSign.NoMatch) Then
        
        '  "AntSiteKey" NOT found
        BeginTrans
        rsAntSiteCallSign.AddNew
            rsAntSiteCallSign!AntSiteKey = gtAntSiteKey  '   dbText, 20)
            rsAntSiteCallSign!CallSigns = ""    '  Initialize "Memo" field
            rsAntSiteCallSign!CallSigns.AppendChunk (gtCallSign & "~")               ' Memo
            rsAntSiteCallSign!RadSvc = ""    '  Initialize "Memo" field
            rsAntSiteCallSign!RadSvc.AppendChunk (gtRadSvc & "~")               ' Memo
            rsAntSiteCallSign!FreqCount = 1
            rsAntSiteCallSign!CallSignCount = 1
        rsAntSiteCallSign.Update
        CommitTrans
        
        'MsgBox "AntSiteKey NOT found", , "WriteAntSiteCallSign"
        'DoEvents
        
        GoTo ExitCallSignRadSvc
    
    Else
        
        '  "AntSiteKey" found

        glFreqCount = rsAntSiteCallSign!FreqCount
        glCallSignCount = rsAntSiteCallSign!CallSignCount
        
        gtCallSignData = Trim(rsAntSiteCallSign!CallSigns)
        giPosCallSign = InStr(1, gtCallSignData, gtCallSign, 1)
        
        gtRadSvcData = Trim(rsAntSiteCallSign!RadSvc)
        giPosRadSvc = InStr(1, gtRadSvcData, gtRadSvc, 1)
        
        If (giPosCallSign > 0) Then
                
            '  "CallSign" found
            BeginTrans
            rsAntSiteCallSign.Edit
                rsAntSiteCallSign!FreqCount = glFreqCount + 1
            rsAntSiteCallSign.Update
            CommitTrans
            
            'MsgBox "CallSignRadSvc found", , "WriteAntSiteCallSign"
            'DoEvents
            
            GoTo ExitCallSignRadSvc

        Else
            '  CallSign NOT found

            BeginTrans
            rsAntSiteCallSign.Edit
                rsAntSiteCallSign!AntSiteKey = gtAntSiteKey  '   dbText, 20)
                rsAntSiteCallSign!CallSigns = ""    '  Initialize "Memo" field
                rsAntSiteCallSign!CallSigns.AppendChunk (gtCallSignData & gtCallSign & "~")               ' Memo
                If (giPosRadSvc < 1) Then
                    rsAntSiteCallSign!RadSvc = ""    '  Initialize "Memo" field
                    rsAntSiteCallSign!RadSvc.AppendChunk (gtRadSvcData & gtRadSvc & "~")               ' Memo
                End If
                rsAntSiteCallSign!FreqCount = glFreqCount + 1
                rsAntSiteCallSign!CallSignCount = glCallSignCount + 1
            rsAntSiteCallSign.Update
            CommitTrans

            'MsgBox "CallSignRadSvc NOT found", , "WriteAntSiteCallSign"
            'DoEvents
        
            GoTo ExitCallSignRadSvc
        
        End If
    
        MsgBox "AntSiteKey found", , "WriteAntSiteCallSign"
        DoEvents
    
    End If
    
ExitCallSignRadSvc:

    glFreqCount = 0
    glCallSignCount = 0

SkipWriteAntSiteCallSign:

End Sub    '  WriteAntSiteCallSign
